/**
 * Created by 王友生 on 2018-04-27.
 */

import './app.less';
import React, { Component } from 'react';
import { connect } from 'react-redux';
import { renderRoutes } from 'react-router-config'
import { IntlProvider, addLocaleData } from 'react-intl';
import zh_CN from './locale/zh_CN';
import en_US from './locale/en_US';
import zh from 'react-intl/locale-data/zh';
import en from 'react-intl/locale-data/en';
import 'moment/locale/zh-cn';
import LocaleProvider from 'antd/lib/locale-provider';
import zhCN from 'antd/lib/locale-provider/zh_CN';
import enUS from 'antd/lib/locale-provider/en_US';

addLocaleData([...zh, ...en]);

const messages = {
    zh: zh_CN,
    en: en_US
}

@connect((state, props) => {
    const lang = state.get('system').get('lang');
    return { lang, routes: props.routes.slice() };
})
export default class App extends Component {
    render() {
        const { routes, lang } = this.props;

        return <IntlProvider locale={lang} messages={messages[lang]} >
            <LocaleProvider locale={lang === 'en' ? enUS : zhCN}>
                {renderRoutes(routes)}
            </LocaleProvider>
        </IntlProvider>
    }
}
