/**
 * Created by 王友生 on 2018-04-10.
 */
import en from "../locale/en_US";
import zh from "../locale/zh_CN";
import _ from "lodash";
export const pageSizeOptions = ['20', '30', '40', '50', '100', '500'];

export const workFlowSelectorType = {
  supervene: {
    key: 'supervene',
    title: '并发'
  },
  series: {
    key: 'series',
    title: '串发'
  },
  jointly: {
    key: 'jointly',
    title: '会签'
  },
};

export const formFieldType = {
  text: {
    value: 'text',
    label: '字符串'
  },
  asyncText: {
    value: 'asyncText',
    label: '异步字符串'
  },
  passWord: {
    value: 'passWord',
    label: '密码'
  },
  number: {
    value: 'number',
    label: '数字'
  },
  amount: {
    value: 'amount',
    label: '金额'
  },
  priceRange: {
    value: 'priceRange',
    label: '金额区间'
  },
  select: {
    value: 'select',
    label: '选择器'
  },
  checkbox: {
    value: 'checkbox',
    label: '复选框',
    pid: 'select'
  },
  radio: {
    value: 'radio',
    label: '单选框',
    pid: 'select'
  },
  treeSelect: {
    value: 'treeSelect',
    label: '树选择',
    pid: 'select'
  },
  treeSelectForbidParent: {
    value: 'treeSelectForbidParent',
    label: '树选择（禁止选择父节点）',
    pid: 'select'
  },
  multipleSelect: {
    value: 'multipleSelect',
    label: '多选框',
    pid: 'select'
  },
  multipleTreeSelect: {
    value: 'multipleTreeSelect',
    label: '树选择（多选）',
    pid: 'select'
  },
  popupTreeSelect: {
    value: 'popupTreeSelect',
    label: '弹出树选择',
    pid: 'select'
  },
  date: {
    value: 'date',
    label: '日期',
  },
  time: {
    value: 'time',
    label: '时间',
    pid: 'date'
  },
  monthPicker: {
    value: 'monthPicker',
    label: '月份',
    pid: 'date'
  },
  yearPicker: {
    value: 'yearPicker',
    label: '年份',
    pid: 'date'
  },
  dateTime: {
    value: 'dateTime',
    label: '日期(时间)',
    pid: 'date'
  },
  dateRange: {
    value: 'dateRange',
    label: '日期区间',
    pid: 'date'
  },
  dateTimeRange: {
    value: 'dateTimeRange',
    label: '日期区间(时间)',
    pid: 'date'
  },
  customDateRange: {
    value: 'customDateRange',
    label: '快捷日期区间',
    pid: 'date'
  },
  customWeekRange: {
    value: 'customWeekRange',
    label: '周区间',
    pid: 'date'
  },
  customDateTime1: {
    value: 'customDateTime1',
    label: '日期时间(hh)',
    pid: 'date'
  },
  customDateTime2: {
    value: 'customDateTime2',
    label: '日期时间(hh:mm)',
    pid: 'date'
  },
  customDateTime3: {
    value: 'customDateTime3',
    label: '日期时间(hh:mm:ss)',
    pid: 'date'
  },
  textArea: {
    value: 'textArea',
    label: '输入域',
  },
  popup: {
    value: 'popup',
    label: '弹出参照'
  },
  popupMultiple: {
    value: 'popupMultiple',
    label: '弹出参照多选',
    pid: 'popup'

  },
  popupSync: {
    value: 'popupSync',
    label: '弹出参照同步',
    pid: 'popup'
  },
  thumb: {
    value: 'thumb',
    label: '缩略图'
  },
  tags: {
    value: 'tags',
    label: '标签'
  },
  popAlert: {
    value: 'popAlert',
    label: '弹窗警告提示'
  },
  picturesWall: {
    value: 'picturesWall',
    label: '多图片'
  },
  onlyCamera: {
    value: 'onlyCamera',
    label: '多图片(仅相机)'
  },
  htmlEditor: {
    value: 'htmlEditor',
    label: '富文本'
  },
  tinyMCE: {
    value: 'tinyMCE',
    label: '富文本（新）'
  },
  employeeSelector: {
    value: 'employeeSelector',
    label: '人员选择'
  },
  uploadFile: {
    value: 'uploadFile',
    label: '上传'
  },
  BDMap: {
    value: 'BDMap',
    label: '位置'
  },
  customPopup: {
    value: 'customPopup',
    label: '自定义弹窗'
  },
  coordinates: {
    value: 'coordinates',
    label: '自动获取坐标(手机)'
  },
  ICinfo: {
    value: 'ICinfo',
    label: '企业工商信息'
  },
  signature: {
    value: 'signature',
    label: '手写签名(手机)'
  },
  wechatIdQR: {
    value: "wechatIdQR",
    label: '微信ID绑定二维码'
  },
  marketIdQR: {
    value: "marketIdQR",
    label: '市场活动邀请二维码'
  },
  Audio: {
    value: "Audio",
    label: '音频展示'
  },
}

export const loginParamsConst = {
  userId: {
    value: 'id',
    label: '当前用户'
  },
  loginName: {
    value: 'loginName',
    label: '登录账号'
  },
  corpId: {
    value: 'corpId',
    label: '所在公司'
  },
  corpCode: {
    value: 'corpCode',
    label: '所在公司编码'
  },
  deptId: {
    value: 'deptId',
    label: '所在部门'
  },
  deptCode: {
    value: 'deptLongCode',
    label: '所在部门编码'
  },
  findCode: {
    value: 'findCode',
    label: '查询码'
  },
  groupId: {
    value: 'groupId',
    label: '所属组织'
  },
  customerId: {
    value: 'customerId',
    label: '客户ID'
  },
  jobId: {
    value: 'dutiesLongCode',
    label: '职务'
  },
  postId: {
    value: 'postLongCode',
    label: '岗位'
  },
  customerName: {
    value: 'customerName',
    label: '公众号-客户名称'
  },
  customerAddress: {
    value: 'customerAddress',
    label: '公众号-客户地址'
  },
  custpersonId: {
    value: 'custpersonId',
    label: '公众号-客户人员ID'
  },
  custpersonName: {
    value: 'custpersonName',
    label: '公众号-客户人员姓名'
  },
  custpersonMobile: {
    value: 'custpersonMobile',
    label: '公众号-客户人员联系电话'
  },
}

export const defaultValueTypeConst = {
  normal: {
    value: 'normal',
    label: '普通参数',
  },
  loginParams: {
    value: 'loginParams',
    label: '登录参数'
  },
  time: {
    value: 'time',
    label: '时间参数'
  },
  date: {
    value: 'date',
    label: '日期参数'
  },
  fastDate: {
    value: 'fastDate',
    label: '快捷日期'
  },
  month: {
    value: 'month',
    label: '月份参数'
  },
  dataRanger: {
    value: 'dataRange',
    label: '日期区间'
  },
  customDateRange: {
    value: 'customDateRange',
    label: '快捷日期区间'
  },
  priceRange: {
    value: 'priceRange',
    label: '金额区间'
  },
};

export const operationType = {
  '+': {
    value: '+',
    label: '+'
  },
  '-': {
    value: '-',
    label: '-'
  },
  '*': {
    value: '*',
    label: '*'
  },
  '/': {
    value: '/',
    label: '/'
  }
}

export const conditionType = {
  '=': {
    value: '=',
    label: '='
  },
  // '>': {
  //   value: '>',
  //   label: '>'
  // },
  // '<': {
  //   value: '<',
  //   label: '<'
  // },
  // '>=': {
  //   value: '>=',
  //   label: '>='
  // },
  // '<=': {
  //   value: '<=',
  //   label: '<='
  // },
}

export const functionType = {
  'max': {
    value: 'max',
    label: 'max'
  },
  'min': {
    value: 'min',
    label: 'min'
  },
  'sum': {
    value: 'sum',
    label: 'sum'
  }
  // '>': {
  //   value: '>',
  //   label: '>'
  // },
  // '<': {
  //   value: '<',
  //   label: '<'
  // },
  // '>=': {
  //   value: '>=',
  //   label: '>='
  // },
  // '<=': {
  //   value: '<=',
  //   label: '<='
  // },
}

export const formulaType = {
  normal: {
    value: 'normal',
    label: '普通公式'
  },
  expression: {
    value: 'expression',
    label: '代码注入'
  },
  inner: {
    value: 'inner',
    label: '内置函数'
  },
  custom: {
    value: 'custom',
    label: '自定义函数'
  },
  api: {
    value: 'api',
    label: '后台接口'
  },
  formConfig: {
    value: 'formConfig',
    label: '表单配置'
  }
}

export const referenceStyleType = {
  select: {
    value: '001',
    label: '下拉框',
    formStyle: formFieldType.select.value,
  },
  treeSelect: {
    value: '002',
    label: '下拉树',
    formStyle: formFieldType.treeSelect.value,
  },
  popTable: {
    value: '003',
    label: '弹出表',
    formStyle: formFieldType.popup.value,
  },
  popTreeTable: {
    value: '004',
    label: '弹出左树右表',
    formStyle: formFieldType.popup.value,
  },
  group: {
    value: '005',
    label: '分组',
    formStyle: formFieldType.text.value,
  },
  popupTreeSelect: {
    value: '006',
    label: '弹出树选择',
    formStyle: formFieldType.popupTreeSelect.value,
  },
  popupTree: {
    value: '007',
    label: '弹出树',
    formStyle: formFieldType.popupTreeSelect.value,
  },
  business: {
    value: '008',
    label: '多表弹出框',
    formStyle: formFieldType.popup.value,
  }
}

export const fixedType = {
  left: {
    value: 'left',
    label: '左'
  },
  right: {
    value: 'right',
    label: '右'
  },
  none: {
    value: 'none',
    label: '无'
  }
}

export const referenceStyleFormStyleMapping = {
  '001': formFieldType.select.value,
  '002': formFieldType.treeSelect.value,
  '003': formFieldType.popup.value,
  '004': formFieldType.popup.value
}

export const tableType = {
  '001': '主表',
  '002': '子表',
  '003': '关系表'
}

export const tableTypeSourceKey = {
  sourceKey: '004',
  mainTableKey: '001',
  childTableKey: '002',
  relationTableKey: '003'
}

export const tableAutoFields = [
  'ID',
  'CREATEUSER',
  'CREATETIME',
  'CREATEDEPT',
  'UPDATEUSER',
  'UPDATETIME',
  'UPDATEDEPT',
  'DELFLAG',
  'YNENABLE',
  'STATUS',
  'FUNP',
  'FUN',
  'FINDCODE',
  'GROUPID',
];

export const groupType = {
  part: 'part',
  table: 'table'
};

export const dataIndexType = {
  form: '1',
  list: '2',
  sublist: '3',
  query: '4'
}

export const partItemDefaultWidth = 6;
export const tableItemDefaultWidth = 200;

export const tableNickLabel = '000';

export const systemBuildType = '002';

export const selectedModeConst = {
  none: '',
  single: 'single',
  multiple: 'multiple'
}
export const classButton = {
  accredit: {
    value: '001',
    label: '授权'
  },
  batch: {
    value: '002',
    label: '批改'
  },
  audit: {
    value: '003',
    label: '审核'
  },
  pushRelationForm: {
    value: '004',
    label: '生单'
  },
  excel: {
    value: '005',
    label: '导入导出'
  },
  more: {
    value: '006',
    label: '更多'
  },
}
export const buttonType = {
  search: {
    value: '006',
    label: '查询'
  },
  add: {
    value: '001',
    label: '新增'
  },
  edit: {
    value: '002',
    label: '修改'
  },
  delete: {
    value: '003',
    label: '删除'
  },
  save: {
    value: '007',
    label: '保存'
  },
  addRelationForm: {
    value: '004',
    label: '推单'
  },
  relationSearch: {
    value: '005',
    label: '联查'
  },
  setting: {
    value: '026',
    label: '设置'
  },
  custom: {
    value: '008',
    label: '自定义'
  },
  reset: {
    value: '009',
    label: '重置'
  },
  attachment: {
    value: '010',
    label: '附件'
  },
  print: {
    value: '011',
    label: '打印'
  },
  export: {
    value: '012',
    label: '导出'
  },
  popForm: {
    value: '013',
    label: '弹窗'
  },
  import: {
    value: '014',
    label: '导入'
  },
  auditing: {
    value: '015',
    label: '审核'
  },
  abandon: {
    value: '016',
    label: '弃审'
  },
  addPopupRelationForm: {
    value: '017',
    label: '弹窗推单'
  },
  searchScheme: {
    value: '018',
    label: '查询方案'
  },
  customPopModal: {
    value: '019',
    label: '自定义弹窗'
  },
  download: {
    value: '020',
    label: '下载'
  },
  grant: {
    value: '021',
    label: '授权'
  },
  editForce: {
    value: '022',
    label: '强制修改'
  },
  recreateWorkflow: {
    value: '023',
    label: '流程重置'
  },
  queryView: {
    value: '025',
    label: '查询视图'
  },
  batchEdit: {
    value: '030',
    label: '批量修改'
  },
  batchDelete: {
    value: '027',
    label: '批量删除'
  },
  batchUpdate: {
    value: '028',
    label: '数据批改'
  },
  tools: {
    value: '029',
    label: '工具'
  },
  xuandan: {
    value: '032',
    label: '选单'
  },
  exportAll: {
    value: '033',
    label: '导出全部'
  },
  up: {
    value: '034',
    label: '置顶'
  },
  customRequest: {
    value: '035',
    label: '自定义接口'
  },
  customRequestJump: {
    value: '036',
    label: '请求带参跳出'
  },
}

export const buttonPositionType = {
  listTop: {
    value: '001',
    label: '列表上'
  },
  listRecord: {
    value: '002',
    label: '列表行'
  },
  detailTop: {
    value: '003',
    label: '详情上'
  },
  formTop: {
    value: '004',
    label: '表单上'
  },
  listMore: {
    value: '005',
    label: '列表更多'
  },
  detailMore: {
    value: '006',
    label: '详情更多'
  },
  formChildTable: {
    value: '007',
    label: '表单子表上'
  },
  formChildTableRecord: {
    value: '008',
    label: '表单子表行'
  },
  queryViewArea: {
    value: '009',
    label: '查询视图区域'
  }
}

export const dateFormatConst = 'YYYY-MM-DD';
export const monthFormatConst = 'YYYY-MM';
export const timeFormatConst = 'HH:mm:ss';
export const dateTimeFormatConst = `${dateFormatConst} ${timeFormatConst}`;

export const functionCodeType = {
  custom: {
    value: '3',
    label: '自定义'
  },
  report: {
    value: '6',
    label: '报表'
  },
  list: {
    value: '5',
    label: '列表'
  },
  advanceList: {
    value: '7',
    label: '高级列表'
  },
  advanceForm: {
    value: '8',
    label: '高级表单'
  },
  treeForm: {
    value: '9',
    label: '树表单'
  },
  customReports: {
    value: '10',
    label: '报表配置'
  },
  customReportCharts: {
    value: '11',
    label: '图表'
  }
};

export const functionTypeMapping = {
  '5': {
    type: 'list',
  },
  '6': {
    type: 'report',
  },
  '8': {
    type: 'edit',
  },
  '7': {
    type: 'advanceList',
  },
  '9': {
    type: 'treeForm'
  },
  '10': {
    type: 'customReports'
  },
  '11': {
    type: 'customReportCharts'
  }
}

export const chartTypeConst = {
  none: {
    value: 'none',
    label: '无'
  },
  line: {
    value: 'line',
    label: '折线图'
  },
  bar: {
    value: 'bar',
    label: '柱状图'
  },
  pie: {
    value: 'pie',
    label: '饼状图'
  },
  funnel: {
    value: 'funnel',
    label: '漏斗图'
  }
}

export const reportChartPositionTypeConst = {
  top: {
    value: 'top',
    label: '上方'
  },
  bottom: {
    value: 'bottom',
    label: '下方',
  },
  left: {
    value: 'left',
    label: '左测'
  },
  right: {
    value: 'right',
    label: '右侧'
  }
}

export const printPositionConst = {
  list: {
    value: '1',
    label: '列表'
  },
  form: {
    value: '2',
    label: '表单'
  },
  report: {
    value: '6',
    label: '报表'
  }
}

export const sysFormulaEditTypeConst = {
  add: 'add',
  edit: 'edit'
}

export const printerTableStyle = '<style>table,td,th {border: 1px solid #403335;border-style: solid;border-collapse: collapse; text-align: left; font-size: 14px; font-weight: 400; padding: 5px},</style>;'

export const defaultHighlightColor = '#D0021B';

export const messageTypeConst = {
  notice: {
    value: '001',
    label: '公告'
  },
  dealWith: {
    value: '002',
    label: '待办'
  },
  warning: {
    value: '003',
    label: '警告'
  },
  alert: {
    value: '004',
    label: '通知'
  },
  online: {
    value: '005',
    label: '在线数'
  },
  chat: {
    value: 'chat',
    label: '聊天消息'
  },
  custom: {
    value: '006',
    label: '自定义消息'
  }
}

export const noticePublishStatusConst = {
  published: {
    value: '002',
    label: '已发布'
  },
  unPublished: {
    value: '001',
    label: '未发布'
  }
}

export const globalTranslationSuffix = '_translation';

export const dashboardDefaultPageSizeConst = 10;

export const dashboardItemDisplayTypeConst = {
  table: {
    value: 'table',
    label: '表格'
  },
  list: {
    value: 'list',
    label: '列表'
  },
  card: {
    value: 'card',
    label: '卡片'
  },
}

window.numberFixedConst = 2;

export const systemCommonFileFunctionCode = '001';

export const supportImage = 'image/jpeg, image/png, image/jpg';

export const sysInlayFunCode = {
  sysUser: '0002001',
  sysRole: '002002',
  sysMenu: '002003',
  sysOrganization: '002004',
  sysNotic: '002005'
};

export const menuStyleConst = {
  tiled: {
    value: 'tiled',
    label: '平面'
  },
  fold: {
    value: 'fold',
    label: '折叠'
  }
}

export const dealWithStatusConst = {
  pedding: {
    value: '003',
    label: '未处理'
  },
  done: {
    value: '005',
    label: '已处理'
  },
  all: {
    value: '',
    label: '全部'
  }
}

export const dealWithGradeConst = {
  normal: {
    label: '普通',
    value: '001'
  },
  important: {
    label: '重要',
    value: '002'
  },
  critical: {
    label: '紧急',
    value: '003'
  }
}

export const editPagePositionConst = {
  tab: {
    label: '页签',
    value: 'tab'
  },
  popup: {
    label: '弹窗',
    value: 'popup'
  }
}

export const itemEventTypeConst = {
  click: {
    label: '单击',
    value: 'click'
  },
  doubleClick: {
    label: '双击',
    value: 'doubleClick'
  }
}

export const formChildSelectedRowKeysConst = '_selectedRowKeys';

//001角色 002部门 003岗位 004职务, 006单据人员

export const workflowNodeType = {
  role: {
    value: '001',
    label: '角色 '
  },
  person: {
    value: 'person',
    label: '人员'
  },
  department: {
    value: '002',
    label: '部门'
  },
  post: {
    value: '003',
    label: '岗位'
  },
  duties: {
    value: '004',
    label: '职务'
  },
  corporation: {
    value: '005',
    label: '单位'
  },
  group: {
    value: 'group',
    label: '组'
  },
  start: {
    value: 'start',
    label: '开始'
  },
  end: {
    value: 'end',
    label: '结束'
  },
  formPerson: {
    value: '006',
    label: '单据人员'
  },
  allDepartment: {
    value: '007',
    label: '全部部门'
  },
  allCorpration: {
    value: '008',
    label: '全部单位'
  }
}

export const workflowStatusConst = {
  new: {
    value: '1',
    label: '新建'
  },
  submitted: {
    value: '2',
    label: '提交'
  },
  verified: {
    value: '3',
    label: '审核'
  },
  process: {
    value: '4',
    label: '未完成'
  },
  done: {
    value: '5',
    label: '完成'
  },
  stop: {
    value: '6',
    label: '终止'
  }
}

export const dealWithResultStatusConst = {
  submitted: {
    value: '1',
    label: '提交完成'
  },
  verifiedOne: {
    value: '4',
    label: '处理未完成'
  },
  verified: {
    value: '5',
    label: '处理完成'
  },
  verifiedAll: {
    value: '6',
    label: '并发完成'
  },
  abandon: {
    value: '7',
    label: '撤回'
  },
  reject: {
    value: '8',
    label: '驳回'
  },
  recall: {
    value: '9',
    label: '弃审'
  },
  break: {
    value: '10',
    label: '中止'
  },
  read: {
    value: '11',
    label: '已读'
  },
  add: {
    value: '12',
    label: '加签'
  },
  recreate: {
    value: '13',
    label: '重置'
  }
};
export const dealWithResultStatusConstArr = _.toArray(dealWithResultStatusConst)
export const workFlowStatusMapping = {
  completed: {//已办
    key: '2',
    title: zh.work_completed,
    titleEN: en.work_completed
  },
  process: {//代办
    key: '1',
    title: zh.work_process,
    titleEN: en.work_process
  },
  notArrived: {//未到达
    key: '0',
    title: zh.work_notArrived,
    titleEN: en.work_notArrived
  },
  unread: {//未阅
    key: '3',
    title: zh.work_unread,
    titleEN: en.work_unread
  },
  read: {//已阅
    key: '4',
    title: zh.work_read,
    titleEN: en.work_read
  }
};

export const workFlowNodeAttrModeConst = {
  supervene: {
    value: '0',
    label: '并发'
  },
  compete: {
    value: '1',
    label: '竞争'
  },
}

export const detailDisplayTypeConst = {
  tab: {
    value: '1',
    label: '页签'
  },
  left: {
    value: '2',
    label: '滑动'
  }
}

export const wfRelationConst = {
  and: {
    value: 'and',
    label: '且',
    operation: (value1, value2) => value1 && value2
  },
  or: {
    value: 'or',
    label: '或',
    operation: (value1, value2) => value1 || value2
  }
}

export const wfConditionConst = {
  equal: {
    value: 'equal',
    label: '等于',
    operation: (value1, value2) => value1 == value2
  },
  notequal: {
    value: 'notequal',
    label: '不等于',
    operation: (value1, value2) => value1 != value2
  },
  more: {
    label: '大于',
    value: 'more',
    operation: (value1, value2) => parseFloat(value1) > parseFloat(value2)
  },
  less: {
    label: '小于',
    value: 'less',
    operation: (value1, value2) => parseFloat(value1) < parseFloat(value2)
  },
  moreequal: {
    label: '大于等于',
    value: 'moreequal',
    operation: (value1, value2) => parseFloat(value1) >= parseFloat(value2)
  },
  lessequal: {
    label: '小于等于',
    value: 'lessequal',
    operation: (value1, value2) => parseFloat(value1) <= parseFloat(value2)
  },
  contain: {
    label: '包含',
    value: 'contain',
    operation: (value1, value2) => value1.indexOf(value2) !== -1
  },
  notcontain: {
    label: '不包含',
    value: 'notcontain',
    operation: (value1, value2) => value1.indexOf(value2) === -1
  },
  section: {
    label: '区间',
    value: 'section',
    operation: (value1, value2, value3) => value1 >= value2 && value1 <= value3
  },
  belong: {
    label: '属于',
    value: 'belong',
    operation: (value1, value2) => {
      value1 = _.sortBy(value1.split(',')).join(',')
      value2 = _.sortBy(value2.split(',')).join(',')
      return value1 == value2
    }
  },
  empty: {
    label: '空',
    value: 'empty',
    operation: (value1) => value1 == null || value1 == "" || value1 == undefined
  },
  notempty: {
    label: '非空',
    value: 'notempty',
    operation: (value1) => value1 != null && value1 == "" && value1 == undefined
  }
}

export const wfHandleType = {
  notice: {
    value: '0',
    label: '知会',
  },
  handle: {
    value: '1',
    label: '审批',
  }
}

//request(url, values.toJSON(),true,false,sysInlayFunCode.sysUser)