/**
 * @Name : 异步加载组件
 * @Description : 配置路由时，按需加载使用
 * @Author : 王友生
 * @Creation Date : 2018/3/10 0010 10:51
 * @ModificationHistory
 */

import React, { Component } from "react";

export default function asyncComponent(importComponent) {
  class AsyncComponent extends Component {
    constructor(props) {
      super(props);

      this.state = {
        component: null
      };
    }

    async componentDidMount() {
      const { default: component } = await importComponent();

      this.setState({
        component: component
      });
    }

    render() {
      const C = this.state.component;

      return C ? <C {...this.props} /> : null;
    }
  }

  return AsyncComponent;
}
