import imageExtensions from './image-extensions.json';
import videoExtensions from './video-extensions.json';
export const getFileExt = (url) => {
    if (!url) {
        return { fileUrl: '', ext: '' };
    }
    const fileUrl = url.toLowerCase().split('?')[0];
    return fileUrl.substr(fileUrl.lastIndexOf('.') + 1, fileUrl.length);
}
export const isImage = (url) => {
    const ext = getFileExt(url);
    return imageExtensions.indexOf(ext) > -1
}

export const isVideo = (url) => {
    const ext = getFileExt(url);
    return videoExtensions.indexOf(ext) > -1;
}

export const isMP3 = (url) => {
    const ext = getFileExt(url);
    return ext === 'mp3';
}