import "./index.less"
import React, { Component } from 'react'
import { Button, Checkbox, Popover, Empty, message, Icon, Tooltip, Modal } from "antd"
import { connect } from "react-redux"
import { request } from "../../../utils/request";
import _ from 'lodash'

const { confirm } = Modal;
@connect((state, props)=>{
    const cache = state.get("list").get(props.fcode);
    const formC = state.get("form").get(props.fcode);
    const reference = state.get("reference");
    const mainTableName = formC.get("mainTableName");
    const formDetail=formC.getIn(["formDetail", props.id,])
    return {
        cache,
        formDetail,
        mainTableName,
        reference,
    }
})


export default class Stage extends Component {
    constructor(props){
        super(props);
        this.state={
            stageDetailData:[],
            nowCho:null,                       //当前页面选择查看
            nowStage:null,                     //当前所在的阶段从请求详情中获取
            stageDetailShow:false,
            detailsChoList:[],
            NCode:"",
            nList:[],
        }
    }

    componentDidMount(){
        const {stateD, stateC, formDetail, showStage, mainTableName} = this.props;    
        if(!formDetail){
            return
        }
        let zt = formDetail[mainTableName][showStage.dataIndex];

        stateD&&stateD.forEach((st,index) => {
            if(st[stateC.field.value]==zt){ 
                this.setState({nowStage:index})
            }
        });
    }

    componentWillReceiveProps(newProps){
        const {stateD, stateC, formDetail, mainTableName, showStage} = newProps;
        if(!formDetail){
            return
        }
        let zt = formDetail[mainTableName][showStage.dataIndex];

        if(zt!=this.props.formDetail.stage){
            stateD&&stateD.forEach((st,index) => {
                if(st[stateC.field.value]==zt){ 
                    this.setState({nowStage:index})
                }
            });
        }
    }

    // TODO:选择阶段展示详情
  choStage(obg, suoyin){
    const { stateD, stateC } = this.props;
    const { nowCho } = this.state;
    this.getDetailMes(obg[stateC.field.value]);

    this.setState({
      stageDetailShow:nowCho==suoyin?false:true,
      nowCho:nowCho==suoyin?null:suoyin
    })
  }

//   获取详情
  getDetailMes(code){

    const { formDetail } = this.props
    request('/crmOpportunity/getProcessDetail',{fid:formDetail.id, processId:code}).then(res=>{
        let newList  = res.result.data;
        newList.forEach(item=>{
            item.finished = item.isFinish=="1"? true : false;
        })
        res&&this.setState({stageDetailData:newList})
    })
  }

  

  // TODO:进入下一阶段
   nextStage(stageIndex, btype){
    const { stateD, formDetail, fcode, dispatch, showStage, id } = this.props;
    const { nowStage} = this.state;

    let that = this;

    if(fcode=="001900100002"){
        request('/crmOpportunity/isapprovalStatus',{id:id}).then(res=>{
            console.log("获取阶段验证", res);
            if(res){
                let qujianList = stateD.slice(nowStage, stageIndex);
                const getData=(fid, processId)=>{
                    return new Promise((resolve, reject) => {
                        request('/crmOpportunity/getProcessDetail',{fid:fid, processId:processId}).then(res=>{
                            resolve(res);
                        });
                    })
                }
    
                async function setList(){
                    let  mustListW= [];
                    let mustFinishedListW = []
                    for(let item of qujianList){
                        let l = await getData(formDetail.id, item.code);
                        let fromList = l.result.data;
                        let mustListN = fromList.filter(el=>el.isRequired=="1");
                        let mustFinishedListN = fromList.filter(el=>el.isRequired=="1"&&el.isFinish=="1");
                        mustListW = [...mustListW, ...mustListN];
                        mustFinishedListW = [...mustFinishedListW, ...mustFinishedListN];
                    }
                    if(mustListW.length!=mustFinishedListW.length){
                        const eWord = btype==2 ? "之前阶段有必选任务，请完成后再进入当前阶段" : "当前阶段有必选任务，请完成后再进入当前阶段";
                        message.error(eWord);
                        return;
                    }
            
                    let shiajian = new Date();
            
                    let timeNow = shiajian.getFullYear()+"-"+(shiajian.getMonth()+1).toString().padStart(2,"0")+"-"+shiajian.getDate().toString().padStart(2, '0');
            
                    request('/crmOpportunity/setProcessData.action',{
                        cname: "",
                        currentState: "",
                        customerId: formDetail.customerId,
                        ddate:timeNow,
                        estimateDealMoney: "",
                        estimateDealTime: "",
                        functionCode: fcode,
                        funCode:fcode,
                        id: formDetail.id,
                        iinvoice: formDetail.id,
                        percent: stateD[stageIndex].fpercent,
                        processId: stateD[stageIndex].code,
                        tableName:showStage.tableName,
                        tableField:showStage.dataIndex,
                        projectPercent: "",
                        selectedRowKeys: [],
                        status: "1"
            
                    }).then(res=>{
                        if(res){
                            request('/senior/getDetail',{funCode:fcode, id:formDetail.id}).then(res=>{
                                if(res){
                                    that.setState({nowCho:stageIndex})
                                    request('/senior/getDetail',{funCode:fcode, id:formDetail.id}).then(res=>{
                                        let formDetailNew = res.result;
                                        formDetailNew.id = formDetail.id
                                        dispatch({
                                            type:'form/FetchFormDetailDataSuccess',
                                            payload:{
                                                functionCode:fcode,
                                                id:formDetail.id,
                                                formDetail:formDetailNew
                                            }
                                        })
                                    })
                                }
                            });
                        }
                    });
            
                }
    
                setList();
            }
        })
    }else{

        let qujianList = stateD.slice(nowStage, stageIndex);
    
        const getData=(fid, processId)=>{
             return new Promise((resolve, reject) => {
                request('/crmOpportunity/getProcessDetail',{fid:fid, processId:processId}).then(res=>{
                    resolve(res);
                });
             })
        }
    
        async function setList(){
            let  mustListW= [];
            let mustFinishedListW = []
            for(let item of qujianList){
                let l = await getData(formDetail.id, item.code);
                let fromList = l.result.data;
                let mustListN = fromList.filter(el=>el.isRequired=="1");
                let mustFinishedListN = fromList.filter(el=>el.isRequired=="1"&&el.isFinish=="1");
                mustListW = [...mustListW, ...mustListN];
                mustFinishedListW = [...mustFinishedListW, ...mustFinishedListN];
            }
            if(mustListW.length!=mustFinishedListW.length){
                const eWord = btype==2 ? "之前阶段有必选任务，请完成后再进入当前阶段" : "当前阶段有必选任务，请完成后再进入当前阶段";
                message.error(eWord);
                return;
            }
    
            let shiajian = new Date();
    
            let timeNow = shiajian.getFullYear()+"-"+(shiajian.getMonth()+1).toString().padStart(2,"0")+"-"+shiajian.getDate().toString().padStart(2, '0');
    
            request('/crmOpportunity/setProcessData.action',{
                cname: "",
                currentState: "",
                customerId: formDetail.customerId,
                ddate:timeNow,
                estimateDealMoney: "",
                estimateDealTime: "",
                functionCode: fcode,
                funCode:fcode,
                id: formDetail.id,
                iinvoice: formDetail.id,
                percent: stateD[stageIndex].fpercent,
                processId: stateD[stageIndex].code,
                tableName:showStage.tableName,
                tableField:showStage.dataIndex,
                projectPercent: "",
                selectedRowKeys: [],
                status: "1"
    
            }).then(res=>{
                if(res){
                    request('/senior/getDetail',{funCode:fcode, id:formDetail.id}).then(res=>{
                        if(res){
                            request('/senior/getDetail',{funCode:fcode, id:formDetail.id}).then(res=>{
                                let formDetailNew = res.result;
                                formDetailNew.id = formDetail.id
                                dispatch({
                                    type:'form/FetchFormDetailDataSuccess',
                                    payload:{
                                        functionCode:fcode,
                                        id:formDetail.id,
                                        formDetail:formDetailNew
                                    }
                                })
                            })
                        }
                    });
                }
            });
    
            
            
        }
    
        setList();
    
        this.setState({nowCho:stageIndex})

    }
    
    

    

   

    
    
  }

    //阶段详情复选框选择
    choChange=(e,obg)=>{

        request('/crmOpportunity/addProcesssChooseLog',{fid:obg.fid, processId:obg.processId, processDetailId:obg.processDetailId,isFinish:e.target.checked?"1":'0'}).then(res=>{
            this.getDetailMes(obg.processId)
        })
    }

    watchDayMark(sid){
        const { fcode, id } = this.props;
        const { NCode } = this.state;
        
        if(NCode!=null&&NCode!=""&&NCode!=undefined){
            this.setState({
                NCode:"",
                nList:[]
            })
            return;
        }
        request("/crmOpportunity/getProcessWork",{
            id:id,
            stageId:sid,
            funCode:fcode
            
        }).then(res=>{
            console.log("获取日志列表",res);
            if(res){
                this.setState({nList:res.result.data, NCode:sid})
                
            }
        })
        
    }

    gotoRiZhiDetail(obg){
        const { dispatch } = this.props;
        dispatch({
            type:"list/changeSelectedId",
            payload:{
                selectedId:obg.id,
                functionCode:obg.fun
            }
        })
    }

    translateKey(k, item){
        const { reference } = this.props;
        const refMes = reference.get(k);
        const refC = refMes.get("config");
        const refL = refMes.get("treeData");
        let newList = refL.filter(el=>el[refC.field.value]==item);
        if(newList.length>0){
            return newList[0][refC.field.label];
        }
        return "管理员"
    }
    
  render() {
    const { stateD, stateC } = this.props;
    const { stageDetailShow, stageDetailData, nowCho, nowStage, NCode, nList } = this.state;


    // 判断当前的阶段位置
    const jieduan = (s)=>{
        const { nowStage, nowCho } = this.state;
        if(s == nowCho) return "dangqian"
        if(s == nowStage) return "now";
        if(s < nowStage) return "pass";
        return ""
    }
  
    return (
        <div className="stageMain">
            <div className="detailStage">
            {/* <Popover placement="bottomLeft" title={"阶段详情"} content={conMes} visible={stageDetailShow} trigger="click"> */}
            <div className="leftIcon" onClick={()=>{this.setState({stageDetailShow:false, nowCho:null})}}>
                <i style={{transform:stageDetailShow?"rotate(90deg)":"none", transformOrigin:"50% 50% 0", transition:"transform .2s"}} className="iconfont icon-ic_circle_next"></i>
            </div>
            {/* </Popover> */}
            <ul className="rightCon">
            {stateD&&stateD.map((item,index)=>{
                return(
                    <li>
                        {/* <Popover placement="bottom" content={(<div style={{ padding:10}}>{item.def1}</div>)} title={item.memo} trigger="hover"> */}
                        <div className={`nei ${jieduan(index)}`} onClick={()=>this.choStage(item, index)} ><em>{index+1}</em><span>{item[stateC.field.label]}</span>
                            <Popover placement="bottom" content={(<div onClick={(e)=>e.stopPropagation()} style={{ padding:10, margin:"-5px", background:"#f5f5f5"}}>
                                {nList.length>0&&<ul className="rizhiList">{nList.map((item,index1)=>{return(
                                    <li onClick={()=>this.gotoRiZhiDetail(item)} style={{borderLeft:"3px solid", borderLeftColor:"#"+Math.round(Math.random()*0x1000000).toString(16)}}>
                                        {/* <h4>{item.name}</h4> */}
                                        <div className="con">{item.activityContent.length>60 ? item.activityContent.substring(0,60)+"..." : item.activityContent}</div>
                                        <div className="conAb">
                                            <span>联系人：{item.custPersonName}</span>
                                            <span>创建人：{this.translateKey('f6453658d405413da7865bb454abf2ee',item.createUser)}</span>
                                            <span style={{textAlign:"right"}}>{item.workDay}</span></div>
                                    </li>
                                    )})}
                                </ul>
                                }
                                {nList.length==0&&<Empty />}
                            </div>)} title={(<h3 onClick={(e)=>e.stopPropagation()} style={{fontSize:15, margin:0}}>{item.memo}<Button size="small" style={{ float:"right"}} type="primary" onClick={()=>this.setState({NCode:""})}>收起</Button></h3>)} visible={NCode==item.code}>
                            <Tooltip placement="top" title={"查看工作日志"}>
                                <font onClick={(e)=>{e.stopPropagation(); this.watchDayMark(item.code)}}>
                                    <Icon type="container" />
                                </font>
                            </Tooltip>
                            </Popover>
                        </div>
                        {/* </Popover> */}
                    </li>
                )
                })
            }
            </ul>
            </div>

            {stageDetailShow&&<div className="stageDetail">
            <h3>
                <div className="left"><span>{stateD[nowCho][stateC.field.label]}：{stateD[nowCho].memo}</span>
                {nowStage!=(stateD.length-1)&&<em>当前阶段工作完成{stageDetailData.filter(el=>el.finished==true).length}/{stageDetailData.length}</em>}
                </div>
                <div className="right">
                    {nowCho<nowStage&&<Button onClick={()=>this.nextStage(nowCho, 3)} type="primary" size="small">回滚当前阶段</Button>}
                    {nowCho==nowStage&&nowStage!=(stateD.length-1)&&<Button onClick={()=>this.nextStage(nowCho+1, 1)} type="primary" size="small">下一阶段</Button>}
                    {nowCho==nowStage&&nowStage==(stateD.length-1)&&<span style={{ display:"inline-block", fontWeight:"bold", color:"#F30"}}>工作已完成</span>}
                    {((nowCho>nowStage)||(nowStage==null))&&<Button onClick={()=>this.nextStage(nowCho, 2)} type="primary" size="small">设置当前阶段</Button>}
                </div>
            </h3>
            <p className="stageDetailCon">{stateD[nowCho].def1}</p>
            <div className="stageDetailN">
            {stageDetailData.map((item,index)=>{
                return(
                <div className="stageBox" key={index}>
                    <dl>
                    <dt><Checkbox style={{margin:"0 5px 0 0", height:18}} onChange={(e)=>this.choChange(e, item, index)} checked={item.finished}></Checkbox>
                    <p>
                    {item.isRequired=="1"&&<span className="must">*</span>}{item.content}
                    </p></dt>
                    <dd>
                        {item.finished&&<span>{item.processPerson}</span>}
                        {item.finished&&<span>{item.processDate}</span>}
                    </dd>
                    </dl>
                </div>
                )
            })
            }
            </div>
            <div className="clearAll"></div>
            </div>
            }
        </div>
    )
  }
}
