import "./index.less"

import React, { PureComponent } from "react"
import DraggableModal from "../DraggableModal"
import { Button, Input, Menu, InputNumber, Dropdown, Modal as AntModal } from "antd"
import { get, isJSON } from "../../utils"
import provinces1 from "../../common/provinces.json"
import cities1 from "../../common/cities.json"
import areas1 from "../../common/areas.json"
import fetchJsonp from "fetch-jsonp"
import { connect } from "react-redux"
import { request } from './../../utils/request'

import _ from "lodash"



// let bMap = undefined;
var that = this
var ac
var map = undefined
const ak = "gvy9USNcoa9E1lNrTcY01pYOv8QnHnax"


@connect((state) => {
  const basicInfo = state.get("system").get("basicInfo");
  const activeTab = state.getIn(['system', 'activeTab'])
  let formDetail
  if (activeTab && activeTab.funCode) {
    formDetail = state.getIn(["form", activeTab.funCode, 'formData'])
  }
  return {
    basicInfo,
    funCode: activeTab && activeTab.funCode,
    formDetail
  };
})

export default class BDMap extends PureComponent {
  state = {
    visible: false,
    addressState: "",//地址的 五级数据 合并结果, 用于展示,
    myPoint: {},// 定位我的坐标
    customerList: [],//客户列表
    searchData: '',//搜索栏内容
    preMarkersId: [],//客户点标记列表
    rangeNum: 500,
    customerAddress: []
  }

  componentDidMount() {
    if (this.props.value) {
      let result = isJSON(this.props.value);
      //console.log('res',result);
      if (result) {
        this.setState({ searchVal: JSON.parse(this.props.value)[1] })
      }
    }
  }
  hideBaiDu() {
    this.hideMap = setInterval(() => {
      if (document.getElementById('baidu_jsapi_watermark')) {
        document.getElementById('baidu_jsapi_watermark').remove()
      } else {
        clearInterval(this.hideMap)
      }
    }, 500)
  }
  //   componentWillReceiveProps(newProps) {}
  componentWillUnmount() {
    //this.clearBDmap();
    clearInterval(this.hideMap)
  }

  componentDidUpdate(newprops) {
    //console.log('60-newprops',newprops)
    //console.log('61-this.props',this.props)
    if (newprops.value != this.props.value) {
      if (this.props.value) {
        let result = isJSON(this.props.value);
        //console.log('res',result);
        if (result) {
          this.setState({ searchVal: JSON.parse(this.props.value)[1] })
        }
      }
    }
    this.hideBaiDu()
  }

  componentWillReceiveProps(newProps) {
    if (newProps.formDetail && newProps.configItem && newProps.configItem.tableName) {
      if (newProps.formDetail.getIn([newProps.configItem.tableName, 'customerId']) && this.customerId !== newProps.formDetail.getIn([newProps.configItem.tableName, 'customerId'])) {
        this.customerId = newProps.formDetail.getIn([newProps.configItem.tableName, 'customerId'])
        request('/csCustomer/getCustomerAddress', { customerId: this.customerId })
          .then(res => {
            if (res && res.result) {
              res.result.map(item => {
                item.name = '(子) ' + item.detailedAddress
              })
              this.setState({ customerAddress: res.result })
            }
          })
      }
    }
  }


  initMap() {
    var that = this
    const { BMap } = window
    if (this.formRef) {
      this.formRef.state.value = ""
    }
    //初始化地图
    map = new BMap.Map("container", { enableMapClick: false })
    let { value } = this.props
    if (value) {
      try {
        value = JSON.parse(value)[0]
      } catch (e) {
        console.log("坐标数据错误", value)
      }
      let arr = value.split(",")
      if (arr && arr.length === 2) {

        let newPoint = {
          lon: arr[0],
          lat: arr[1]
        }
        that.lng = arr[0]
        that.lat = arr[1]
        that.address = {}
        this.setState({
          myPoint: newPoint
        })
        const point = new BMap.Point(arr[0], arr[1])
        map.centerAndZoom(point, 15)
        that.originalMK = new BMap.Marker(point)
        map.addOverlay(that.originalMK)
      }
    } else {
      var geolocation = new BMap.Geolocation()
      geolocation.getCurrentPosition(function (r) {
        if (this.getStatus() === 0) {
          //console.log(this.getStatus(),typeof this.getStatus());
          map.centerAndZoom(r.point, 15)
          that.originalMK = new BMap.Marker(r.point)
          that.lng = r.point.lng
          that.lat = r.point.lat
          map.addOverlay(that.originalMK)
          that.address = r.address
          let address = ""
          address += r.address.province
          address += r.address.city
          address += r.address.district
          address += r.address.street
          address += r.address.streetNumber
          that.setState({ addressState: address.replace(/undefined/g, "") })
        }
      })
    }
    map.addEventListener("click", function (e) {
      map.clearOverlays() //
      that.originalMK = new BMap.Marker(e.point)
      map.addOverlay(that.originalMK)
      that.lng = e.point.lng
      that.lat = e.point.lat
      that.searchAddressByLngAndLat() //获取地址 -- > 设置地址
    })
    map.enableScrollWheelZoom(true)

    ac = new BMap.Autocomplete({
      // 建立一个自动完成的对象
      input: document.getElementById("suggestId"),
      location: map
    })
    ac.addEventListener("onhighlight", e => {
      // 鼠标放在下拉列表上的事件
      let str = ""
      let DataValue = e.fromitem.value
      let value = ""
      if (e.fromitem.index > -1) {
        value = DataValue.province + DataValue.city + DataValue.district + DataValue.street + DataValue.business
      }
      str = `FromItem<br />index = ${e.fromitem.index}<br />value = ${value}`
      value = ""
      if (e.toitem.index > -1) {
        DataValue = e.toitem.value
        value = DataValue.province + DataValue.city + DataValue.district + DataValue.street + DataValue.business
      }
      str += `<br />ToItem<br />index = ${e.toitem.index}<br />value = ${value}`
      const searchResultPanel = document.getElementById("searchResultPanel")
      searchResultPanel.innerHTML = str
    })

    let myValue
    ac.addEventListener("onconfirm", e => {
      // 鼠标点击下拉列表后的事件
      const _value = e.item.value
      that.address.city = _value.city //这个接口缺少省
      that.address.district = _value.district
      that.address.street = _value.street
      that.address.streetNumber = _value.streetNumber
      that.address.business = _value.business
      myValue = _value.province + _value.city + _value.district + _value.street + _value.business
      document.getElementById("searchResultPanel").innerHTML = `onconfirm<br />index = ${e.item.index}<br />myValue = ${myValue}`
      setPlace()
      that.formRef.state.value = myValue
    })

    function setPlace() {
      map.clearOverlays() // 清除地图上所有覆盖物
      const local = new BMap.LocalSearch(map, {
        // 智能搜索
        onSearchComplete: myFun
      })
      function myFun() {
        const pp = local.getResults().getPoi(0).point // 获取第一个智能搜索的结果
        const pp2 = local.getResults().getPoi(0)
        that.lng = pp.lng
        that.lat = pp.lat //设置经纬度
        that.address.province = pp2.province //这个接口有省 市 2个;
        let addressTotal
        let temp = that.address
        addressTotal = temp.province + temp.city + temp.district + temp.street + temp.streetNumber + temp.business
        that.setState({ addressState: addressTotal.replace(/undefined/g, "") })
        map.centerAndZoom(pp, 18)
        map.addOverlay(new BMap.Marker(pp))
      }
      local.search(myValue)
    }
  }

  getInMpAddress(e) {
    let address = ""
    address += e.address.province
    address += e.address.city
    address += e.address.district
    address += e.address.street
    address += e.address.streetNumber

    this.setState({ addressState: address.replace(/undefined/g, "") })
    // return address.replace(/undefined/g,"");
    return e.address
  }

  searchAddressByLngAndLat() {
    var that = this
    const { BMap } = window
    var myGeo = new BMap.Geocoder()
    myGeo.getLocation(new BMap.Point(that.lng, that.lat), function (result) {
      if (result) {
        that.address = result.addressComponents
        let address = ""
        address += result.addressComponents.province
        address += result.addressComponents.city
        address += result.addressComponents.district
        address += result.addressComponents.street
        address += result.addressComponents.streetNumber
        that.setState({ addressState: address.replace(/undefined/g, "") })
      }
    })
  }

  clearBDmap() {
    //map = null;
    try {
      // 注销地图（换成你初始化时定义的地图变量）
      map = null
      // 获取interval的最高ID然后遍历清除
      const HIGHEST_INTERVAL_ID = setInterval(";")
      for (let i = 0; i < HIGHEST_INTERVAL_ID; i++) {
        clearInterval(i)
      }
      // 获取百度地图创建的DOM并销毁
      const BAIDU_MAPS = document.querySelectorAll(".tangram-suggestion-main")
      BAIDU_MAPS.forEach(item => {
        document.body.removeChild(item)
      })
    } catch (e) {
      //console.log(e);
    }
    this.setState({ visible: false })
  }
  submitPre(pos, address) {
    if (address && Object.keys(address).length != 0) {
      AntModal.confirm({
        title: '确认',
        content: '系统发现你更改了定位地址,是否同步更新详细地址?',
        onOk: () => this.submit(pos, address, 1),
        onCancel: () => this.submit(pos, address)
      });
    }
  }
  submit(pos, address, param3) {
    const { options } = this.state
    let res = "",
      fullAddress = "",
      DetailedAddress = ""
    if (address && Object.keys(address).length != 0) {
      //res = this.BDMapDataTranscode(address).toString();
      //console.log('转换-结果',res);
      fullAddress = (address.province + address.city + address.district + address.street + address.streetNumber + address.business).replace(
        /undefined/g,
        ""
      )
      DetailedAddress = (
        address.province +
        address.city +
        address.district +
        address.street +
        address.streetNumber +
        address.business
      ).replace(/undefined/g, "")
      res = [address.province, address.city, address.district].join(",")
    }
    if (address && address.address) {
      fullAddress = address.address
    }
    if (address.type == 'address') {
      fullAddress = address.name
    }
    if (pos && address && Object.keys(address).length != 0) {
      this.setState({ searchVal: fullAddress, addressState: fullAddress })
      if (param3) {
        this.props.onChange && this.props.onChange(JSON.stringify([pos, fullAddress, res, param3]))
      } else {
        this.props.onChange && this.props.onChange(JSON.stringify([pos, fullAddress, res]))
      }
    }
    this.clearBDmap()
    this.setState({ mapList: [] })
  }
  childrenSubmit(item) {
    this.props.onChange && this.props.onChange(item)
    this.clearBDmap()
    this.setState({ mapList: [] })
  }
  /**
   *获取百度地址
   *
   * @param {输入值} val
   * @memberof BDMap
   */
  onMapList(val) {
    let url = `https://api.map.baidu.com/place/v2/search?query=${val}&region=全国&output=json&address_result=true&ak=${ak}`
    fetchJsonp(url, {
      headers: { Accept: "application/json" },
      jsonCallbackFunction: "showLocation"
    })
      .then(response => response.json())
      .then(data => {
        if (data.status === 0)
          if (data.results[0] && data.results[0].location && data.results[0].province) {
            data.results.map(item => {
              item.district = item.area
            })
            // console.log('data.results', data.results);
            this.setState({ mapList: data.results })
          } else if (data.result_type == 'address_type' && data.results[0] && data.results[0].location) {//地址转详情
            let contraryUrl = `https://api.map.baidu.com/reverse_geocoding/v3/?ak=${ak}&output=json&location=${data.results[0].location.lat + ',' + data.results[0].location.lng}`
            fetchJsonp(contraryUrl, {
              headers: { Accept: "application/json" },
              jsonCallbackFunction: "showLocation"
            })
              .then(response => response.json())
              .then(data => {
                if (data.status == 0 && data.result && data.result.addressComponent) {
                  let { location, addressComponent } = data.result
                  this.setState({
                    mapList: [{
                      location,
                      province: addressComponent.province,
                      city: addressComponent.city,
                      district: addressComponent.district,
                      street: addressComponent.street,
                      name: val,
                      type: 'address'
                    }]
                  })
                } else {
                  this.setState({ mapList: [] })
                }
              })
          } else {
            this.setState({ mapList: [] })
          }
      })
  }
  // 防抖
  dOnMapList = _.debounce(this.onMapList, 500)

  /**
   *渲染下拉
   *
   * @return {*}
   * @memberof BDMap
   */
  menu() {
    let { mapList, customerAddress } = this.state
    if (this.customerId) {
      if (!mapList) {
        mapList = []
      }
      mapList = [...customerAddress, ...mapList]
    }
    return (
      <Menu style={{ maxHeight: "200px", overflowY: "auto" }}>
        {mapList &&
          mapList.length &&
          mapList.map((item, idx) => {
            return (
              <Menu.Item onClick={() => {
                if (item.BDMap) {
                  this.childrenSubmit(item.BDMap)
                } else {
                  this.submitPre(`${item.location.lng},${item.location.lat}`, item)
                }
              }} key={`${item.address}${idx}`}>
                <a>{`${item.name}${item.city ? "-" + item.city : ""}`}</a>
              </Menu.Item>
            )
          })}
      </Menu>
    )
  }

  // NOTE:查周边
  searchPeriphery() {
    const { basicInfo } = this.props;
    const { rangeNum } = this.state;
    let data = {
      searchData: this.state.searchData,
      userId: basicInfo.id,
      idepartment: basicInfo.deptLongCode,
      longtitude: this.state.myPoint.lon,
      latitude: this.state.myPoint.lat,
      radius: rangeNum,
    }
    request('/newAppWeb/getCustomerListForMapNewApp', data)
      .then(data => {
        console.log("地图周边查询数据", data);
        if (data.result.data && data.result.data.length) {
          this.setState({
            customerList: data.result.data
          }, () => this.addMarkers())
        }
      })
  }

  //设置打点
  addMarkers() {
    let that = this
    const { BMap } = window
    const { preMarkersId, customerList, myPoint } = this.state;
    map = new BMap.Map("container", { enableMapClick: false });

    let centerP = new BMap.Point(myPoint.lon, myPoint.lat);
    map.centerAndZoom(centerP, 15);
    customerList.forEach(item => {
      const point = new BMap.Point(item.lng, item.lat);
      that.originalMK = new BMap.Marker(point)
      map.addOverlay(that.originalMK)
    })

    map.addEventListener("click", function (e) {
      // map.clearOverlays() //
      // that.originalMK = new BMap.Marker(e.point)
      // map.addOverlay(that.originalMK)
      // that.lng = e.point.lng
      // that.lat = e.point.lat
      that.searchAddressByLngAndLat() //获取地址 -- > 设置地址
    })
    map.enableScrollWheelZoom(true)
    // let coors = [];
    // BMap.removeAnnotations({
    //     ids:preMarkersId
    // });
    // let preMarkersId2 = [];
    // coors = customerList.map((item,index)=>{
    //     let point = {
    //         lon:item.lng,
    //         lat:item.lat,
    //         id:index
    //     }
    //     preMarkersId2.push(index)
    //     return point;
    // })
    // this.setState({
    //     preMarkersId:preMarkersId2
    // })

    // bMap.addAnnotations({
    //         annotations: coors,
    //         icon: 'widget://res/Icon_mark.png',
    //         draggable: true
    // }, (ret)=> {
    //         if (ret){
    //             customerList.map((item,index) => {
    //                 if (index === ret.id){
    //                     this.setBubble(item, ret.id);
    //                     bMap.popupBubble({
    //                             id: ret.id
    //                     });
    //                 }

    //             })
    //         }
    // });
  }

  setSeartch(e) {
    this.setState({
      searchData: e.target.value
    })
  }



  render() {
    const { addressState, searchVal, searchData, rangeNum, customerList } = this.state
    let { detail, value, configItem } = this.props
    let valueNew = _.cloneDeep(value);
    let valueNewJP;
    let oldVal;
    if (isJSON(valueNew)) {
      valueNewJP = valueNew && isJSON && JSON.parse(valueNew);
      value = valueNewJP;
      // if (searchVal != valueNewJP[1]) {
      //   console.log('valueNewJP', valueNewJP[1]);
      //   this.setState({ searchVal: valueNewJP[1] })
      // }
    } else {
      valueNewJP = ["", valueNew, ""];
      oldVal = value
      // if (searchVal != valueNew) {
      //   console.log('valueNew', valueNew);
      //   this.setState({ searchVal: valueNew })
      // }
    }

    var that = this

    // console.log("value", configItem)
    // try {
    //   value = value ? JSON.parse(value) : value
    // } catch (e) {
    //   oldVal = value
    // }

    return (
      <div>
        <DraggableModal
          wrapClassName="bdMapModal"
          width={1160}
          style={{ top: "3%" }}
          bodyStyle={{ height: "500px" }}
          title={addressState ? `地图 (当前位置:${addressState})` : `地图`}
          visible={this.state.visible}
          getContainer={false}
          onOk={() => {
            !detail && this.props.onChange && this.submitPre(`${this.lng},${this.lat}`, this.address)
            this.setState({ visible: false })
          }}
          onCancel={() => this.clearBDmap()}
        >
          <div style={{ height: "100%" }}>
            {/* <div style={{padding:10, display:"flex", justifyContent:"space-between"}}>
            <Input value={searchData} onChange={(e)=>this.setSeartch(e)} placeholder="请输入坐标"></Input>
            <InputNumber min={0}  value={rangeNum} step={50} style={{marginLeft:5}} onChange={(e)=>this.setState({rangeNum:e})} />
            <Button type="primary" style={{marginLeft:5}} onClick={()=>{this.searchPeriphery()}}>搜周边</Button>
            </div> */}

            {!detail && (
              <div id="r-result" style={{ width: "100%", marginBottom: "5px" }}>
                <Input
                  ref={ref => (this.formRef = ref)}
                  id="suggestId"
                  style={{ width: "100%" }}
                  allowClear
                  placeholder="输入地点搜索..."
                />
              </div>
            )}
            {customerList && customerList.length > 0 && <div style={{ float: "right", width: 300, height: "100%", overflow: "hidden auto" }}>
              <ul style={{ listStyle: "none", padding: 0 }}>
                {customerList.map((item, idx) => {
                  return (
                    <li key={idx} style={{ padding: "10px 10px 5px", borderBottom: "1px solid #eaeaea" }}>
                      <h3 style={{ fontWeight: "bold" }}>{item.cname}</h3>
                      <p style={{ fontSize: 13, marginBottom: 5, }}><span>详细地址：</span>{item.detailedAddress}</p>
                      <p style={{ display: "flex", marginBottom: 5, justifyContent: 'space-between' }}><span>销售人员：{item.salesperson}</span><span style={{ textAlign: "right" }}>{item.dmaker}</span></p>
                    </li>
                  )
                })}
              </ul>
            </div>
            }

            <div id="container" style={{ width: "100%", height: "100%" }} />

            <div id="searchResultPanel" style={{ border: "1px solid #C0C0C0", width: "150px", height: "auto", display: "none" }} />
          </div>
        </DraggableModal>
        {detail ? (
          oldVal ? (
            <span style={{ lineHeight: "25px" }}>{oldVal}</span>
          ) : (
            <a
              style={{ color: "#40a9ff" }}
              onClick={() => this.setState({ visible: true }, () => that.initMap())}
              title={value[0]}
              className={"h4_noWrap"}
            >
              {value[1]}
            </a>
          )
        ) : (
          <div style={{ display: "flex" }}>
            <Dropdown trigger={["click"]} overlay={this.menu()}>
              <Input
                value={searchVal}
                onChange={e => {
                  e.persist();
                  that.setState({ searchVal: e.target.value })
                  that.props.onChange && that.props.onChange(JSON.stringify([valueNewJP[0], e.target.value, valueNewJP[2]]))
                  that.dOnMapList(e.target.value)
                }}
              />
            </Dropdown>
            {configItem.groupType != "table" && <Button size="small" onClick={() => this.setState({ visible: true }, () => that.initMap())}>
              地图
            </Button>}
          </div>
        )}
      </div>
    )
  }
}
