/**
 * Created by 王友生 on 2018-05-03.
 */

import './index.less';

import React, { PureComponent } from 'react';
import { Cascader, Select, Button, Input, Tag, Dropdown, Menu as AntMenu, Icon, message, Tooltip, Popover, Collapse, List, Card, Checkbox } from 'antd';
import { FormattedMessage, injectIntl } from 'react-intl';
import { connect } from 'react-redux';
import { operationType, conditionType, functionType, formulaType, tableType, wfConditionConst, selectedModeConst } from '../../common/const';
import { translateObjectToList, getItemSourceByKey } from '../../utils';
import DraggableModal from "../DraggableModal";
import CustomTreeSelect from '../CustomTreeSelect';
import CustomSelect from '../CustomSelect';
import T from "../../utils/commonCalculation"
import math from "mathjs"
import _ from 'lodash';
math.config({
  number: "BigNumber"
})
const { TextArea } = Input;
const { Panel } = Collapse;

const operationTypeList = translateObjectToList(operationType);
const conditionTypeTypeList = translateObjectToList(conditionType);
const functionTypeTypeList = translateObjectToList(functionType);

const formulaRender = {};
const transformLabel = (keys, options) => {
  let parent = options.filter(item => item.value == keys[0])
  if (parent && parent.length > 0) {
    try {
      let item = parent[0].children.filter(child => child.value == keys[1])[0]
      return parent[0]['label'] + '-' + item['label']
    } catch (error) {
      console.log('error6', keys, options);
    }
  }
}
const demo = () => {
  return <Collapse defaultActiveKey={['1']}>
    <Panel header="主表影响主表" key="1">
      <pre>
        {'params["memo"]=Number(params[\'quantity\'])*Number(params["price"])'}
      </pre>
      <pre>
        {'return params'}
      </pre>
    </Panel>
    <Panel header="主表影响子表" key="2">
      <pre>
        <code>
          {'for(let i = 0; i < params["bu_contract_product"].length; i++) {'}
          <br />
          {'params["bu_contract_product"][i]["standardPrice"] = params["rate"] * params["bu_contract_product"][i]["noriginalcurtaxprice"];'}
          <br />
          {'}'}
          <br />
          {'return params'}
        </code>
      </pre>
    </Panel>
    <Panel header="子表影响子表" key="3">
      <pre>
        {'if(params["bu_contract_product"].length==0){return params}'}
      </pre>
      <pre>
        {'params["bu_contract_product"][childIndex]["noriginalcursummny"]=params["bu_contract_product"][childIndex]["quantity"]*'}
      </pre>
      <pre>
        {'params["bu_contract_product"][childIndex]["noriginalcurtaxprice"];'}
      </pre>
      <pre>
        {'return params;'}
      </pre>
    </Panel>
  </Collapse>
}

const fun = () => {
  return <div style={{ height: '400px', overflowY: 'auto', padding: '5px' }}>
    <List
      grid={{ gutter: 10, column: 3 }}
      dataSource={T.remark}
      renderItem={item => (
        <List.Item>
          <Card
            onClick={(e) => {
              e.stopPropagation();
              const input = document.createElement('input');
              input.style.cssText = 'display: block;opacity: 0;position: absolute;left: -10000px;top: -10000px;z-index: -1;'
              document.body.appendChild(input);
              input.value = `T.${item.value}(${item.param})`;
              input.select();
              document.execCommand('copy');
              document.body.removeChild(input);
              message.info('复制成功')
            }}
            hoverable
            headStyle={{ backgroundColor: '#f0f8ff', padding: '5px' }}
            bodyStyle={{}} title={item.title}>
            <div style={{ padding: '5px' }}>{`T.${item.value}(${item.param})`}</div>
          </Card>
        </List.Item >
      )}
    />
  </div >
}
// 普通
formulaRender[formulaType.normal.value] = (item, index, options, onChange, formatMessage, onDelete) => <div key={index}
  className="group">
  <p>{`${index + 1}.${formulaType.normal.label}`}</p>
  <Cascader
    value={item.get('result')}
    expandTrigger="hover"
    onChange={(value) => onChange(index, 'result', value)}
    placeholder={formatMessage({ id: "locale_please_select" })}
    options={options} />
  <Select style={{ width: '50px' }} value={conditionType['='].value}>
    {
      conditionTypeTypeList.map((item, index) => <Select.Option key={index}
        value={item.value}>{item.label}</Select.Option>)
    }
  </Select>
  <Cascader
    value={item.get('first')}
    expandTrigger="hover"
    onChange={(value) => onChange(index, 'first', value)}
    placeholder={formatMessage({ id: "locale_please_select" })}
    options={options} />
  <Select style={{ width: '50px' }}
    value={item.get('operation')}
    onChange={(value) => onChange(index, 'operation', value)}>
    {
      operationTypeList.map((item, index) => <Select.Option key={index}
        value={item.value}>{item.label}</Select.Option>)
    }
  </Select>
  <Cascader
    value={item.get('second')}
    expandTrigger="hover"
    onChange={(value) => onChange(index, 'second', value)}
    placeholder={formatMessage({ id: "locale_please_select" })}
    options={options} />
  <div className="delete">
    <Button onClick={() => onDelete(index)} shape='circle' type="danger" icon='delete' />
  </div>
</div>;
// 代码注入
formulaRender[formulaType.expression.value] = (item, index, options, onChange, formatMessage, onDelete) => {
  let insertIdx = undefined;
  let textAreaRef = null;
  const transformKey = (value) => {
    let table = options.filter(item => {
      return value[0] == item.value
    })
    if (table[0].tableType == '001') {
      return 'params["' + value[1] + '"]'
    } else {
      return 'params["' + value[0] + '"][childIndex]["' + value[1] + '"]'
    }
  }
  const getCursorPosition = (ctrl) => {
    if (ctrl && ctrl.resizableTextArea && ctrl.resizableTextArea.textArea && ctrl.resizableTextArea.textArea.selectionStart) {
      insertIdx = ctrl.resizableTextArea.textArea.selectionStart
    }
  }
  const onChangeArea = (value) => {
    if (insertIdx == undefined) {
      onChange(index, 'area', item.get('area') ? item.get('area') + transformKey(value) : transformKey(value))
    } else {
      let area = item.get('area')
      let first = area ? area.slice(0, insertIdx) : ''
      let last = area ? area.slice(insertIdx) : ''
      area = first + transformKey(value) + last;
      onChange(index, 'area', area)
    }
  }
  let newKeys = item.get('newKeys') ? item.get('newKeys') : []
  newKeys = _.cloneDeep(newKeys)
  return <div key={index}
    className="group">
    <p>{`${index + 1}.${formulaType.expression.label}`}</p>
    <div className="expression">
      <div>
        <Cascader
          expandTrigger="hover"
          onChange={(value) => {
            console.log('newKeys', [...newKeys, ...value]);
            onChange(index, 'newKeys', [...newKeys, value])
          }}
          options={options}>
          <Button>添加触发字段</Button>
        </Cascader>
        <Cascader
          expandTrigger="hover"
          onChange={(value) => onChangeArea(value)}
          options={options}>
          <Button style={{ margin: '0 5px' }}>添加字段</Button>
        </Cascader>
        {/* <Button onClick={() => {
          let value = item.get('area');
          try {
            console.log('eval(value)', eval(value));
            message.success('成功')
          } catch (e) {
            console.log('err', e);
            message.info('无法解析的公式')
            return
          }
        }}>测试</Button> */}
        <Tooltip title={"手动录入配合添加字段,支持js语句params为当前表单数据,childIndex为当前子表下标,必须return params,子表childIndex参与运算时要实现判断子表不得小于0"}>
          <Icon style={{ fontSize: '16px', marginLeft: '5px' }} type="info-circle" />
        </Tooltip>
        <Popover zIndex={1001}
          content={demo()} title="样例" trigger="click">
          <span className="example">例</span>
        </Popover>
        <Popover zIndex={1001}
          overlayStyle={{ width: '900px' }}
          overlayClassName={"fun"}
          content={fun()} title="工具类" trigger="click">
          <span className="example">fu</span>
        </Popover>
      </div>
      <div className="delete">
        <Button onClick={() => onDelete(index)} shape='circle' type="danger" icon='delete' />
      </div>
    </div>
    <TextArea
      ref={ref => textAreaRef = ref}
      value={item.get('area')}
      onBlur={() => getCursorPosition(textAreaRef)}
      onChange={(e) => {
        onChange(index, 'area', e.target.value)
      }}
      style={{ marginTop: '10px' }} rows={4} />
    {/* 循环 */}
    <div style={{ marginTop: '5px' }}>
      {newKeys && newKeys.length > 0 && newKeys.map((item, keyIdx) => {
        return <Tag key={keyIdx} color="green">{transformLabel(item, options)} <Icon onClick={() => {
          newKeys.splice(keyIdx, 1)
          onChange(index, 'newKeys', newKeys)
        }} style={{ cursor: 'pointer' }} type="close-circle" /></Tag>
      })}
    </div>
  </div >
};
// 内置函数
formulaRender[formulaType.inner.value] = (item, index, options, onChange, formatMessage, onDelete) => <div key={index}
  className="group">
  <p>{`${index + 1}.${formulaType.inner.label}`}</p>
  <Cascader
    expandTrigger="hover"
    value={item.get('result')}
    onChange={(value) => onChange(index, 'result', value)}
    placeholder={formatMessage({ id: "locale_please_select" })}
    options={options} />
  <Select style={{ width: '50px' }} value={conditionType['='].value}>
    {
      conditionTypeTypeList.map((item, index) => <Select.Option key={index}
        value={item.value}>{item.label}</Select.Option>)
    }
  </Select>
  <Select style={{ width: '80px' }}
    value={item.get('funcName')}
    onChange={(value) => onChange(index, 'funcName', value)}>
    {
      functionTypeTypeList.map((item, index) => <Select.Option key={index}
        value={item.value}>{item.label}</Select.Option>)
    }
  </Select>
  <Cascader
    expandTrigger="hover"
    value={item.get('first')}
    onChange={(value) => onChange(index, 'first', value)}
    placeholder={formatMessage({ id: "locale_please_select" })}
    options={options} />
  <div className="delete">
    <Button onClick={() => onDelete(index)} shape='circle' type="danger" icon='delete' />
  </div>
</div>
// 自定义函数
formulaRender[formulaType.custom.value] = (item, index, options, onChange, formatMessage, onDelete) => {
  let arrKey = ['first', 'second', 'third']
  let oldKeys = []
  if (!item.get('newKeys')) {
    arrKey.map(key => {
      if (item.get(key)) {
        oldKeys.push(item.get(key))
        // onChange(index, key, undefined)
      }
    })
  }
  if (oldKeys.length > 0 && !item.get('newKeys')) {
    onChange(index, 'newKeys', oldKeys)
  }
  let newKeys = item.get('newKeys') ? item.get('newKeys') : []
  newKeys = _.cloneDeep(newKeys)
  return <div key={index}
    className="group">
    <p>{`${index + 1}.${formulaType.custom.label}`}</p>
    <div className="expression">
      <div>
        <Input style={{ width: '200px' }} value={item.get('funcName')} placeholder="请填写方法名"
          onChange={(e) => onChange(index, 'funcName', e.target.value)} />
        {/* 添加 */}
        <Cascader
          expandTrigger="hover"
          onChange={(value) => {
            console.log('newKeys', [...newKeys, ...value]);
            onChange(index, 'newKeys', [...newKeys, value])
          }}
          options={options}>
          <Button style={{ margin: '0 5px' }}>添加触发字段</Button>
        </Cascader>
        {/* 提示 */}
        <Tooltip title={"填写方法名,按钮添加触发字段"}>
          <Icon style={{ fontSize: '16px', marginLeft: '5px' }} type="info-circle" />
        </Tooltip>
      </div>
      {/* 删除 */}
      <div className="delete">
        <Button onClick={() => onDelete(index)} shape='circle' type="danger" icon='delete' />
      </div>
    </div>
    {/* 循环 */}
    <div style={{ marginTop: '5px' }}>
      {newKeys && newKeys.length > 0 && newKeys.map((item, keyIdx) => {
        return <Tag key={keyIdx} color="green">{transformLabel(item, options)} <Icon onClick={() => {
          newKeys.splice(keyIdx, 1)
          onChange(index, 'newKeys', newKeys)
        }} style={{ cursor: 'pointer' }} type="close-circle" /></Tag>
      })}
    </div>
  </div>
}
// 接口
formulaRender[formulaType.api.value] = (item, index, options, onChange, formatMessage, onDelete) => {
  let arrKey = ['first', 'second', 'third', 'forth']
  let oldKeys = []
  if (!item.get('newKeys')) {
    arrKey.map(key => {
      if (item.get(key)) {
        oldKeys.push(item.get(key))
        // onChange(index, key, undefined)
      }
    })
  }
  if (oldKeys.length > 0 && !item.get('newKeys')) {
    onChange(index, 'newKeys', oldKeys)
  }
  let newKeys = item.get('newKeys') ? item.get('newKeys') : []
  newKeys = _.cloneDeep(newKeys)
  return <div key={index}
    className="group">
    <p>{`${index + 1}.${formulaType.api.label}`}</p>
    <div className="expression">
      <div>
        {/* <span style={{ paddingRight: '10px' }}>接口</span> */}
        <Input style={{ width: '200px' }} value={item.get('apiUrl')} placeholder="请填写接口"
          onChange={(e) => onChange(index, 'apiUrl', e.target.value)} />
        {/* 添加 */}
        <Cascader
          expandTrigger="hover"
          onChange={(value) => {
            console.log('newKeys', [...newKeys, ...value]);
            onChange(index, 'newKeys', [...newKeys, value])
          }}
          options={options}>
          <Button style={{ margin: '0 5px' }}>添加触发字段</Button>
        </Cascader>
        {/* 提示 */}
        <Tooltip title={"填写接口,按钮添加触发字段"}>
          <Icon style={{ fontSize: '16px', marginLeft: '5px' }} type="info-circle" />
        </Tooltip>
      </div>
      <div className="delete" >
        <Button onClick={() => onDelete(index)} shape='circle' type="danger" icon='delete' />
      </div>
    </div>
    {/* 循环 */}
    <div style={{ marginTop: '5px' }}>
      {newKeys && newKeys.length > 0 && newKeys.map((item, keyIdx) => {
        return <Tag key={keyIdx} color="green">{transformLabel(item, options)} <Icon onClick={() => {
          newKeys.splice(keyIdx, 1)
          onChange(index, 'newKeys', newKeys)
        }} style={{ cursor: 'pointer' }} type="close-circle" /></Tag>
      })}
    </div>
  </div>
}
let resultCache = []
// 表单配置
formulaRender[formulaType.formConfig.value] = (item, index, options, onChange, formatMessage, onDelete, source, dispatch, reference, dictionary) => {
  let newKeys = item.get('newKeys') ? item.get('newKeys') : []
  newKeys = _.cloneDeep(newKeys)
  let sourceArr = source ? source.toJS() : []
  sourceArr = Array.isArray(sourceArr) ? sourceArr : options
  const returnConValue = () => {
    let text = item.get('conValue')
    let result = item.get('result')
    let conValueSource = undefined;
    if (!resultCache[index]) {
      resultCache[index] = item.get('result')
    } else if (JSON.stringify(resultCache[index]) != JSON.stringify(result)) {
      onChange(index, 'conValue', undefined)
      text = undefined
      resultCache[index] = item.get('result')
    }
    sourceArr.map(block => {
      if (block.children) {
        block.children.map(item => {
          if (result && item.tableName == result[0] && item.dataIndex == result[1]) {
            conValueSource = item
          }
        })
      }
    })
    if (conValueSource) {
      if (conValueSource.type === 'select') {
        let { itemSource, config } = getItemSourceByKey(conValueSource, dispatch, reference, dictionary);
        return <CustomSelect
          selectProps={{ value: text }}
          needSelectItem
          source={itemSource}
          field={config && config.field}
          defaultValue={text}
          onChange={(value, selectedItem) => {
            onChange(index, 'conValue', value)
          }} />
      } else if (conValueSource.type === 'multipleSelect') {
        let { itemSource, config } = getItemSourceByKey(conValueSource, dispatch, reference, dictionary);
        return <CustomSelect
          selectProps={{ mode: "multiple", value: text ? text : [] }}
          needSelectItem
          source={itemSource}
          field={config && config.field}
          defaultValue={text}
          onChange={(value, selectedItem) => {
            onChange(index, 'conValue', value)
          }} />
      } else if (conValueSource.type === 'treeSelect' || conValueSource.type === 'treeSelectForbidParent') {
        let { itemSource, config } = getItemSourceByKey(conValueSource, dispatch, reference, dictionary);
        return config && config.field && <CustomTreeSelect
          needSelectItem
          data={itemSource || []}
          style={{ minWidth: '200px' }}
          treeField={config && config.field && {
            id: config.field.value,
            name: config.field.label,
            pid: config.field.pid
          }}
          onChange={(value, selectedItem) => {
            onChange(index, 'conValue', value)
          }}
          value={text} />
      } else if (conValueSource.type === 'popup') {
        const suffix = text ? <Icon type="close-circle" style={{ cursor: 'pointer' }} onClick={() => {
          onChange(index, 'conValue', undefined)
        }} /> : null;
        return <Input value={text && text.length > 0 && text[0].label || ''}
          suffix={suffix}
          onFocus={(e) => {
            e.target.blur();
            dispatch({
              type: 'reference/visibleReference',
              payload: {
                id: conValueSource.referenceKey,
                item: conValueSource,
                selectedMode: selectedModeConst.single,
                objectHash: 'node-editor',
                onSelectedSuccess: (selectedItems) => {
                  const mainField = _.find(conValueSource.affectFields, { referenceField: 'id' });
                  let value = [];
                  _.forEach(selectedItems, selectedItem => {
                    value.push({ value: selectedItem['id'], label: selectedItem[conValueSource.referenceField] });
                  })
                  let mainKey = mainField ? mainField.formField[1] : conValueSource[conValueSource.referenceField];
                  onChange(index, 'conValue', value)
                }
              }
            })
          }} />
      } else {
        return <Input style={{ width: '200px' }} value={item.get('conValue')} placeholder="请填写值"
          onChange={(e) => onChange(index, 'conValue', e.target.value)} />
      }
    } else {
      return <Input style={{ width: '200px' }} value={item.get('conValue')} placeholder="请填写值"
        onChange={(e) => onChange(index, 'conValue', e.target.value)} />
    }
  }
  return <div key={index}
    className="group">
    <p>{`${index + 1}.${formulaType.formConfig.label}`}</p>
    <div className="expression" style={{ marginBottom: '10px' }}>
      <div>
        {/* 添加 */}
        <Cascader
          expandTrigger="hover"
          onChange={(value, selectedOptions) => {
            if (selectedOptions[0].tableType) {
              value = [...value, selectedOptions[0].tableType]
            }
            onChange(index, 'newKeys', [...newKeys, { dataIndex: value }])
          }}
          options={options}>
          <Button style={{ marginRight: '5px' }}>添加影响字段</Button>
        </Cascader>
        {/* 提示 */}
        <Tooltip title={"填写触发字段,按钮添加影响字段"}>
          <Icon style={{ fontSize: '16px', marginLeft: '5px' }} type="info-circle" />
        </Tooltip>
      </div>
      <div className="delete" >
        <Button onClick={() => onDelete(index)} shape='circle' type="danger" icon='delete' />
      </div>
    </div>
    <div style={{ display: 'flex' }}>
      {/* 触发字段 */}
      <Cascader
        style={{ width: '200px' }}
        expandTrigger="hover"
        value={item.get('result')}
        onChange={(value) => {
          onChange(index, 'result', value)
        }}
        placeholder={"触发字段"}
        options={options} />
      {/* 对比符 */}
      <Select style={{ minWidth: '80px' }}
        source={translateObjectToList(wfConditionConst)} defaultValue={item.get('condition')}
        onChange={(value) => {
          onChange(index, 'condition', value)
        }} >
        {
          translateObjectToList(wfConditionConst).map((item, index) => <Select.Option key={index}
            value={item.value}>{item.label}</Select.Option>)
        }
      </Select>
      {/* 值 */}
      <div style={{ width: '200px' }}>{returnConValue()}</div>
    </div>
    {/* 影响字段循环 */}
    <div style={{ marginTop: '5px' }}>
      {newKeys && newKeys.length > 0 && newKeys.map((item, keyIdx) => {
        // console.log('newKeys', newKeys);
        return <Tag key={keyIdx} color="green">
          {transformLabel(item.dataIndex, options)}&nbsp;&nbsp;
          <Checkbox checked={item.required} onChange={(e => { item.required = e.target.checked; onChange(index, 'newKeys', newKeys) })}>必填</Checkbox>
          <Checkbox checked={item.hide} onChange={(e => { item.hide = e.target.checked; onChange(index, 'newKeys', newKeys) })}>隐藏</Checkbox>
          <Checkbox checked={item.disabled} onChange={(e => { item.disabled = e.target.checked; onChange(index, 'newKeys', newKeys) })}>只读</Checkbox>
          {item.dataIndex[2] == '002' && <Checkbox checked={item.requiredSubTable} onChange={(e => { item.requiredSubTable = e.target.checked; onChange(index, 'newKeys', newKeys) })}>表必填</Checkbox>}
          {item.dataIndex[2] == '002' && <Checkbox checked={item.hideSubTable} onChange={(e => { item.hideSubTable = e.target.checked; onChange(index, 'newKeys', newKeys) })}>表隐藏</Checkbox>}
          <Icon onClick={() => {
            newKeys.splice(keyIdx, 1)
            onChange(index, 'newKeys', newKeys)
          }} style={{ paddingLeft: '5px', cursor: 'pointer' }} type="close-circle" />
        </Tag>
      })}
    </div>
  </div>
}
@connect((state) => {
  const dictionary = state.get('dictionary');
  const reference = state.get('reference');
  return {
    dictionary,
    reference
  };
})
class CalculationFormula extends PureComponent {

  state = {
    options: [],
    visible: false
  }
  componentWillReceiveProps(newProps) {
    if (newProps.funCode !== this.props.funCode) {
      resultCache = []
    }
  }
  openSettingPop() {
    const options = [];
    const { tables, tableProps } = this.props;
    tables.map(item => {
      // if (item.tableType == '001' || item.tableType == '002' && !item.relFun || item.tableType == '003') {
      options.push({
        value: item.tableName,
        label: `${item.tableDesc}${item.tableType ? '(' + tableType[item.tableType].charAt(0) + ')' : ''}`,
        title: item.tableName,
        tableType: item.tableType,
        children: Array.from(tableProps[item.tableName], x => {
          return {
            label: x.fieldDesc || x.title,
            value: x.field || x.dataIndex,
            title: x.field || x.dataIndex
          }
        })
      });
      // }
    });
    this.setState({ options, visible: true });
  }

  render() {
    const { onClose, onSelectEnd, intl: { formatMessage }, onItemChange, onItemDelete, addItem, formulaList, saveConfig, source, dispatch, reference, dictionary, shortForm } = this.props;
    const { options, visible } = this.state;
    const menu = (
      <AntMenu onClick={(e) => addItem(e.key)}>
        <AntMenu.Item key={formulaType.normal.value}>{formulaType.normal.label}</AntMenu.Item>
        {/* {!shortForm && <AntMenu.Item key={formulaType.expression.value}>{formulaType.expression.label}</AntMenu.Item>} */}
        <AntMenu.Item key={formulaType.expression.value}>{formulaType.expression.label}</AntMenu.Item>
        <AntMenu.Item key={formulaType.inner.value}>{formulaType.inner.label}</AntMenu.Item>
        <AntMenu.Item key={formulaType.custom.value}>{formulaType.custom.label}</AntMenu.Item>
        <AntMenu.Item key={formulaType.api.value}>{formulaType.api.label}</AntMenu.Item>
        {/* {!shortForm && <AntMenu.Item key={formulaType.formConfig.value}>{formulaType.formConfig.label}</AntMenu.Item>} */}
        <AntMenu.Item key={formulaType.formConfig.value}>{formulaType.formConfig.label}</AntMenu.Item>
      </AntMenu>
    );
    return <span>
      <Button size="small" type="primary" onClick={() => this.openSettingPop()}>计算公式</Button>
      <DraggableModal title={<FormattedMessage id="locale_calculation_formula" />}
        visible={visible}
        onCancel={() => this.setState({ visible: false })}
        destroyOnClose
        onOk={() => {
          this.setState({ visible: false });
          saveConfig && saveConfig();
        }}
        bodyStyle={{ padding: '0 10px', height: '400px', overflow: 'auto', backgroundColor: '#d7d9e0' }}
        width={1000}>
        <div className="formula">
          <div>
            {formulaList.map((item, index) => formulaRender[item.get('type')](item, index, options, (index, key, value) => {
              onItemChange(index, key, value)
            },
              formatMessage, (index) => onItemDelete(index), source, dispatch, reference, dictionary))}
          </div>
          <Dropdown overlay={menu}>
            <Button className="add">添加<Icon type="down" /></Button>
          </Dropdown>
        </div>
      </DraggableModal>
    </span>
  }
}

export default injectIntl(CalculationFormula)
