import React, { Component } from "react"
import readyData from "../data"
import "./../index.less"
import { Menu, Dropdown, Modal, Button } from "antd"
import { connect } from "react-redux"
import timeTool from "../tool"

@connect((state, index) => {
  return {
    state
  }
})
export default class BBox extends Component {
  constructor(props) {
    super(props)
    this.state = {
      week: null,
      visible:false
    }
  }

  startingPosition(time, dayTime) {
    let nt = timeTool.timestampToTime(dayTime) + " 00:00:00"
    let top = 0
    let dayTimeT = new Date(nt).getTime()
    let pTimeT = new Date(time).getTime()
    let xiaoshi = time.substring(11, 13) ? (pTimeT < dayTimeT ? "00" : time.substring(11, 13)) : "00"
    top = parseInt(xiaoshi) * 60
    return top
  }

  timeH(listbiaoD, bTime, eTime) {
    let h = 0

    let listE = new Date(timeTool.timestampToTime(listbiaoD) + " 23:59:59").getTime()
    let realE = new Date(eTime.length < 11 ? eTime + " 23:59:59" : eTime).getTime()

    let quantian
    if (realE >= listE) {
      quantian = true
    }

    let xiaoshiB = bTime.substring(11, 13) ? bTime.substring(11, 13) : "00"
    let xiaoshiE = eTime.substring(11, 13) ? (quantian ? "24" : eTime.substring(11, 13)) : "24"
    h = (parseInt(xiaoshiE) - parseInt(xiaoshiB)) * 60

    return h
  }

  // 判断计划是否应该在这个日期内
  timeSpace(obg1, obg2, tableName1, tableName2) {
    let show = false
    let thisDateB = new Date(obg2 + " 00:00:00").getTime() //日期内一天的开始
    let thisDateE = new Date(obg2 + " 23:59:59").getTime() //日期内一天的结束
    let thisNextB = thisDateB + 24 * 60 * 60 * 1000
    
    // let planDateB = new Date(obg1[tableName1]&&obg1[tableName1].length<11?obg1[tableName1] + " 00:00:00" : obg1[tableName1]).getTime()          //计划的开始时间（时间戳）
    // let planDateE = new Date(obg1[tableName2]&&obg1[tableName2].length<11?obg1[tableName2] + " 23:59:59" : obg1[tableName2]).getTime()  
    let planDateB = new Date(obg1.beginDate + " 00:00:00").getTime()          //计划的开始时间（时间戳）
    let planDateE = new Date(obg1.endDate + " 23:59:59").getTime()          //计划的结束时间（时间戳）

    
    if ((planDateB>=thisDateB&&planDateB<thisNextB)) {
      show = true
    }

    if((planDateE>=thisDateE&&planDateB<thisDateE)){
      show = true
    }

    return show
  }

  render() {
    const { dayTime } = readyData
    const { list, addNewN, today, stateConfig } = this.props;

    let tdList =  list.richengList.filter(el => this.timeSpace(el, timeTool.timestampToTime(today), "bu_plan000beginDate", "bu_plan000endDate"));         //获取今日的已发布的列表
    let sentPeoList = tdList.map(stp=>stp.bu_plan000createUser);
    let  unSentPeo =  list.departmentPeo.filter(el=>sentPeoList.indexOf(el.id)<0);
    
    

    const menu = (
      <Menu>
        <Menu.Item onClick={() => addNewN("001900140001")} key="1">
          新增日程计划
        </Menu.Item>
        {/* <Menu.Item onClick={() => addNewN("001900040001")} key="2">
          新增实施计划
        </Menu.Item> */}
      </Menu>
    )
    return (
      <div className="timeBox">
        <ul className="leftTitle">
          {dayTime.map((el, index) => {
            return (
              <li key={index}>
                <span>{el}</span>
              </li>
            )
          })}
        </ul>
        <Dropdown overlay={menu} trigger={["contextMenu"]}>
          <ul className="rightCon">
            {dayTime.map((el, index) => {
              return (
                <li key={index}>
                  <span></span>
                  <span></span>
                </li>
              )
            })}

            <div className="dataBox">
              {/* .filter(el=>this.timeSpace(el,timeTool.timestampToTime(today),"bu_plan000beginDate","bu_plan000endDate")) */}
              {list.richengList &&
                list.richengList
                  .filter(el => this.timeSpace(el, timeTool.timestampToTime(today), "bu_plan000beginDate", "bu_plan000endDate"))
                  .map((el, index) => {
                    return (
                      <div key={index} className="dataBoxN">
                        <div
                          onDoubleClick={() => this.props.goToDetail(el, "001900140001")}
                          style={{
                            // top: this.startingPosition(el.bu_plan000beginDate, today),
                            top: 0,
                            // height: this.timeH(today, el.bu_plan000beginDate, el.bu_plan000endDate),
                            height:"100%",
                            background:((index+1) % 2 == 0)?"#6da75d" : "#8fc37f"
                          }}
                        >
                          <h4>{el.name}</h4>
                          
                          <div>
                          {/* <p style={{display:"block"}}>参与人员:{this.renming(el.bu_plan000userName)}</p> */}
                          <p style={{display:"block"}}>计划日期:{el.beginDate} ~ {el.endDate}</p>
                          <p style={{display:"block"}}>参与人员:{timeTool.renming(el.userName, list)}</p>
                          {el.activityContent}
                          </div>
                        </div>
                      </div>
                    )
                  })}
              {/* .filter(el=>this.timeSpace(el,timeTool.timestampToTime(today),"bu_activity_plan000beginDate","bu_activity_plan000beginDate")) */}
              
              {/* {list.shishiList &&
                list.shishiList
                  .filter(el =>
                    this.timeSpace(el, timeTool.timestampToTime(today), "bu_activity_plan000beginDate", "bu_activity_plan000endDate")
                  )
                  .map((el, index) => {
                    return (
                      <div key={index} className="dataBoxN">
                        <div
                          onDoubleClick={() => this.props.goToDetail(el, "001900040001")}
                          style={{
                            top: this.startingPosition(el.bu_activity_plan000beginDate, today),
                            height: this.timeH(today, el.bu_activity_plan000beginDate, el.bu_activity_plan000endDate),
                            background: "#0089ff"
                          }}
                        >
                          <h4>{el.bu_activity_plan000projectName}</h4>
                          <div>{el.bu_activity_plan000activityContent}</div>
                        </div>
                      </div>
                    )
                  })} */}
            </div>
          </ul>
        </Dropdown>

        <Modal
          title="本日未发布日志人员"
          visible={list.showUnSentPeo}
          onCancel={()=>{this.props.changeUnSentShow(!list.showUnSentPeo)}}
          footer={[
            <Button key="submit" type="primary" onClick={()=>{this.props.changeUnSentShow(!list.showUnSentPeo)}}>
              确定
            </Button>
          ]}
        >
          {unSentPeo.map(item=>{
            return(
              <p>{item.username}</p>
            )
          })}
        </Modal>
      </div>
    )
  }
}
