import React, { Component } from "react"
import readyData from "../data"
import "./../index.less"
import timeTool from "../tool"
import { Menu, Dropdown, Popover, Modal, Button } from "antd"
import { connect } from "react-redux"

@connect((state, index) => {
  return {
    state
  }
})
export default class MBox extends Component {
  constructor(props) {
    super(props)
    this.state = {
      dayList: []
    }
  }

  // TODO:判断计划是否应该在这个日期内(传入:obg1:当计划的内容主要拿取其中的时间,obg2:当日的开始结束时间,tableName1,tableName2:日期属性名需要从外面传入)
  timeSpace(obg1, obg2, tableName1, tableName2) {
    
    let show = false;
    let thisDateB = new Date(obg2 + " 00:00:00").getTime()        //日历内一天的开始（时间戳）
    let thisDateE = new Date(obg2 + " 23:59:59").getTime()        //日历内一天的结束（时间戳）
    let thisNextB = thisDateB + 24 * 60 * 60 * 1000               //第二天开始（时间戳）

    // let planDateB = new Date(obg1[tableName1]&&obg1[tableName1].length<11?obg1[tableName1] + " 00:00:00" : obg1[tableName1]).getTime()          //计划的开始时间（时间戳）
    // let planDateE = new Date(obg1[tableName2]&&obg1[tableName2].length<11?obg1[tableName2] + " 23:59:59" : obg1[tableName2]).getTime()          //计划的结束时间（时间戳）

    let planDateB = new Date(obg1.beginDate + " 00:00:00").getTime()          //计划的开始时间（时间戳）
    let planDateE = new Date(obg1.endDate + " 23:59:59").getTime()          //计划的结束时间（时间戳）
    

    if ((planDateB>=thisDateB&&planDateB<thisNextB)) {
      show = true
    }

    if((planDateE>=thisDateE&&planDateB<thisDateE)){
      show = true
    }

    return show
  }

  render() {
    const { weekTime } = readyData
    const { list, listF, addNewN } = this.props
    const { today } = list
    let data = timeTool.timestampToTime(today)
    let dataS = new Date(data).getTime()

    let tdList =  listF.richengList.filter(el => this.timeSpace(el, timeTool.timestampToTime(today), "bu_plan000beginDate", "bu_plan000endDate"));         //获取今日的已发布的列表
    let sentPeoList = tdList.map(stp=>stp.bu_plan000createUser);
    let  unSentPeo =  listF.departmentPeo.filter(el=>sentPeoList.indexOf(el.id)<0);

    const menu = (
      <Menu>
        <Menu.Item onClick={() => addNewN("001900140001")} key="1">
          新增日程计划
        </Menu.Item>
        {/* <Menu.Item onClick={() => addNewN("001900040001")} key="2">
          新增实施计划
        </Menu.Item> */}
      </Menu>
    )
    return (
      <div className="mouthBox">
        <div className="topBox">
          {weekTime.map((el, index) => {
            return <span key={index}>{el.shortName}</span>
          })}
        </div>
        <div className="contentBox">
          {list.mouthList.map((item, index) => {
            return (
              <Dropdown key={index} overlay={menu} trigger={["contextMenu"]}>
                <div
                  className={`${"contentBoxN"} ${new Date(item).getMonth() + 1 == list.mouth ? "a" : "b"} ${item == dataS ? "nowD" : ""}`}
                >
                  <h4>{timeTool.timestampToTime(item).substring(8, 13)}</h4>
                  <div className="contentBoxC">
                    {listF.richengList
                      .filter(el =>
                        this.timeSpace(el, timeTool.timestampToTime(list.mouthList[index]), "bu_plan000beginDate", "bu_plan000endDate")
                      )
                      .map((el, index) => {
                        return (
                          <Popover 
                          title={el.bu_plan000name}
                          content={(
                            <div>
                            <p>计划日期:{el.beginDate} ~ {el.endDate}</p>
                            <p>参与人:{timeTool.renming(el.userName, list)}</p>
                            <p>{el.activityContent}</p>
                            </div>
                          )}
                          >
                          <p key={index} onDoubleClick={() => this.props.goToDetail(el, "001900140001")} style={{ background:((index+1) % 2 == 0)?"#6da75d" : "#8fc37f" }}>
                            <em>
                              {el.beginDate&&el.beginDate.substring(0, 11)}
                              ~{el.endDate&&el.endDate.substring(0, 16)}
                            </em>
                            <span style={{display:"block"}}>参与人员:{timeTool.renming(el.userName, list)}</span>
                            <span>{el.name}</span>
                          </p>
                          </Popover>
                        )
                      })}
                    {/* {listF.shishiList
                      .filter(el =>
                        this.timeSpace(
                          el,
                          timeTool.timestampToTime(list.mouthList[index]),
                          "bu_activity_plan000beginDate",
                          "bu_activity_plan000endDate"
                        )
                      )
                      .map((el, index) => {
                        return (
                          <p key={index} onDoubleClick={() => this.props.goToDetail(el, "001900040001")} style={{ background: "#0089ff" }}>
                            <em>
                              {el.bu_activity_plan000beginDate.substring(0, 16)}~{el.bu_activity_plan000endDate.substring(0, 16)}
                            </em>
                            <span>{el.bu_activity_plan000projectName}</span>
                          </p>
                        )
                      })} */}
                  </div>
                </div>
              </Dropdown>
            )
          })}
        </div>
        <Modal
          title="本月未发布日志人员"
          visible={listF.showUnSentPeo}
          // onOk={()=>{this.props.changeUnSentShow(!listF.showUnSentPeo)}}
          onCancel={()=>{this.props.changeUnSentShow(!listF.showUnSentPeo)}}
          footer={[
            <Button key="submit" type="primary" onClick={()=>{this.props.changeUnSentShow(!listF.showUnSentPeo)}}>
              确定
            </Button>
          ]}
        >
          {unSentPeo.map(item=>{
            return(
              <p>{item.username}</p>
            )
          })}
        </Modal>
      </div>
    )
  }
}
