import React, { Component } from "react"
import readyData from "../data"
import "./../index.less"
import { Menu, Dropdown, Popover, Modal, Button } from "antd"
import timeTool from "../tool"
import { connect } from "react-redux"

@connect((state, index) => {
  return {
    state
  }
})
export default class WBox extends Component {
  constructor(props) {
    super(props)
    this.state = {
      week: null
    }
  }
  componentDidMount() {
    const { today } = this.props
    this.setState({
      week: timeTool.getWeek(today)
    })
  }

  startingPosition(time, dayTime) {
    let nt = timeTool.timestampToTime(dayTime) + " 00:00:00"
    let top = 0
    let dayTimeT = new Date(nt).getTime()
    let pTimeT = new Date(time).getTime()
    let xiaoshi = time.substring(11, 13) ? (pTimeT < dayTimeT ? "00" : time.substring(11, 13)) : "00"
    top = parseInt(xiaoshi) * 60
    return top
  }

  timeH(listbiaoD, bTime, eTime) {
    let h = 0

    // let listB = new Date(timeTool.timestampToTime(listbiaoD)+" 00:00:00").getTime();
    let listB = new Date(timeTool.timestampToTime(listbiaoD) + " 00:00:00").getTime() //列表当天的开始
    let listE = new Date(timeTool.timestampToTime(listbiaoD) + " 23:59:59").getTime() //列表当天的结束
    let realE = new Date(eTime.length < 11 ? eTime + " 23:59:59" : eTime).getTime()
    let nextB = listB + 24 * 60 * 60 * 1000
    // let quantian=false;
    // if(realE>nextB){
    //     quantian = true;
    // }

    let xiaoshiB = bTime.substring(11, 13) ? bTime.substring(11, 13) : "00"
    let xiaoshiE = eTime.substring(11, 13) ? (realE > nextB ? "24" : eTime.substring(11, 13)) : "24"
    h = (parseInt(xiaoshiE) - parseInt(xiaoshiB)) * 60

    return h
  }

  // 判断计划是否应该在这个日期内
  timeSpace(obg1, obg2, tableName1, tableName2) {
    let show = false
    let thisDateB = new Date(obg2 + " 00:00:00").getTime() //日期内一天的开始
    let thisDateE = new Date(obg2 + " 23:59:59").getTime() //日期内一天的结束
    let thisNextB = thisDateB + 24 * 60 * 60 * 1000

    // let planDateB = new Date(obg1[tableName1]&&obg1[tableName1].length<11?obg1[tableName1] + " 00:00:00" : obg1[tableName1]).getTime()          //计划的开始时间（时间戳）
    // let planDateE = new Date(obg1[tableName2]&&obg1[tableName2].length<11?obg1[tableName2] + " 23:59:59" : obg1[tableName2]).getTime()          //计划的结束时间（时间戳）

    let planDateB = new Date(obg1.beginDate + " 00:00:00").getTime()          //计划的开始时间（时间戳）
    let planDateE = new Date(obg1.endDate + " 23:59:59").getTime()          //计划的结束时间（时间戳）

    // if (thisDateB <= planDateB && planDateE < thisNextB) {
    //   show = true
    // }

    if ((planDateB>=thisDateB&&planDateB<thisNextB)) {
      show = true
    }

    if((planDateE>=thisDateE&&planDateB<thisDateE)){
      show = true
    }

    return show
  }

  render() {
    const { dayTime, weekTime } = readyData
    const { today, weekList, list, addNewN } = this.props;
    
    let tdList =  list.richengList;         //获取今日的已发布的列表
    let sentPeoList = tdList.map(stp=>stp.bu_plan000createUser);
    let  unSentPeo =  list.departmentPeo.filter(el=>sentPeoList.indexOf(el.id)<0);

    const menu = (
      <Menu>
        <Menu.Item onClick={() => addNewN("001900140001")} key="1">
          新增日程计划
        </Menu.Item>
        {/* <Menu.Item onClick={() => addNewN("001900040001")} key="2">
          新增实施计划
        </Menu.Item> */}
      </Menu>
    )
    return (
      <div className="timeBox">
        <ul className="leftTitle">
          <li>
            <span></span>
          </li>
          {dayTime.map((el, index) => {
            return (
              <li key={index}>
                <span>{el}</span>
              </li>
            )
          })}
        </ul>
        <div className="rightCon weekBox">
          {weekTime.map((item, index) => {
            return (
              <Dropdown key={index} overlay={menu} trigger={["contextMenu"]}>
                <ul className={weekList[index] == today.getTime() ? "a" : "b"}>
                  <li className="title">
                    {item.fullName}
                    {timeTool.timestampToTime(weekList[index])}
                  </li>
                  {dayTime.map((el, index) => {
                    return (
                      <li key={index}>
                        <span></span>
                        <span></span>
                      </li>
                    )
                  })}
                  <div className="dataBox">
                    {list.richengList
                      .filter(el =>
                        this.timeSpace(el, timeTool.timestampToTime(weekList[index]), "bu_plan000beginDate", "bu_plan000endDate")
                      )
                      .map((el, index) => {
                        return (
                          <div key={index} className="dataBoxN">
                            <Popover
                              overlayStyle={{ width: 300 }}
                              placement="rightTop"
                              content={(
                                <div>
                                <p>计划日期:{el.beginDate} ~ {el.endDate}</p>
                                <p>参与人:{timeTool.renming(el.userName, list)}</p>
                                <p>{el.activityContent}</p>
                                </div>
                              )}
                              title={el.name}
                            >
                              <div
                                onDoubleClick={() => this.props.goToDetail(el, "001900140001")}
                                style={{
                                  top: 0,
                                  // height: this.timeH(weekList[index], el.bu_plan000beginDate, el.bu_plan000endDate),
                                  height:"100%",
                                  background:((index+1) % 2 == 0)?"#6da75d" : "#8fc37f"
                                }}
                              >
                                <h4>
                                  {list.richengList.filter(el =>
                                    this.timeSpace(
                                      el,
                                      timeTool.timestampToTime(weekList[index]),
                                      "bu_plan000beginDate",
                                      "bu_plan000endDate"
                                    )
                                  ).length > 3
                                    ? el.name.substring(0, 1)
                                    : el.name}
                                </h4>
                                {/* <div style={{display:"block"}}>参与人员:{this.renming(el.bu_plan000userName)}</div> */}
                                <div>
                                <p style={{display:"block"}}>计划日期:{el.beginDate} ~ {el.endDate}</p>
                                <p style={{display:"block"}}>参与人员:{timeTool.renming(el.userName, list)}</p>
                                  {list.richengList.filter(el =>
                                    this.timeSpace(
                                      el,
                                      timeTool.timestampToTime(weekList[index]),
                                      "bu_plan000beginDate",
                                      "bu_plan000endDate"
                                    )
                                  ).length < 4 && el.activityContent}
                                </div>
                              </div>
                            </Popover>
                          </div>
                        )
                      })}

                    {/* {list.shishiList
                      .filter(el =>
                        this.timeSpace(
                          el,
                          timeTool.timestampToTime(weekList[index]),
                          "bu_activity_plan000beginDate",
                          "bu_activity_plan000endDate"
                        )
                      )
                      .map((el, index) => {
                        return (
                          <div key={index} className="dataBoxN">
                            <Popover
                              overlayStyle={{ width: 300 }}
                              placement="rightTop"
                              content={el.bu_activity_plan000activityContent}
                              title={el.bu_activity_plan000projectName}
                            >
                              <div
                                onDoubleClick={() => this.props.goToDetail(el, "001900040001")}
                                style={{
                                  top: this.startingPosition(el.bu_activity_plan000beginDate, weekList[index]),
                                  height: this.timeH(weekList[index], el.bu_activity_plan000beginDate, el.bu_activity_plan000endDate),
                                  background: "#0089ff"
                                }}
                              >
                                <h4 onDoubleClick={() => this.props.goToDetail(el, "001900040001")}>
                                  {list.shishiList.filter(el =>
                                    this.timeSpace(
                                      el,
                                      timeTool.timestampToTime(weekList[index]),
                                      "bu_activity_plan000beginDate",
                                      "bu_activity_plan000endDate"
                                    )
                                  ).length > 3
                                    ? el.bu_activity_plan000projectName.substring(0, 1)
                                    : el.bu_activity_plan000projectName}
                                </h4>
                                <div>
                                  {list.shishiList.filter(el =>
                                    this.timeSpace(
                                      el,
                                      timeTool.timestampToTime(weekList[index]),
                                      "bu_activity_plan000beginDate",
                                      "bu_activity_plan000endDate"
                                    )
                                  ).length < 4 && el.bu_activity_plan000activityContent}
                                </div>
                              </div>
                            </Popover>
                          </div>
                        )
                      })} */}
                  </div>
                </ul>
              </Dropdown>
            )
          })}
        </div>
        <Modal
          title="本周未发布日志人员"
          visible={list.showUnSentPeo}
          onCancel={()=>{this.props.changeUnSentShow(!list.showUnSentPeo)}}
          footer={[
            <Button key="submit" type="primary" onClick={()=>{this.props.changeUnSentShow(!list.showUnSentPeo)}}>
              确定
            </Button>
          ]}
        >
          {unSentPeo.map(item=>{
            return(
              <p>{item.username}</p>
            )
          })}
        </Modal>
      </div>
    )
  }
}
