/**
 * Created by 王友生 on 2018-07-18.
 */

import React, { PureComponent } from 'react';
import { Tag } from 'antd';

const { CheckableTag } = Tag;

const defaultField = {
  value: 'value',
  label: 'label'
}

export default class CheckableTags extends PureComponent {

  handleChange(checked, item) {
    const { onChange, value, field } = this.props;
    let valueArray = [];
    const itemValue = item[(field && field.value) || defaultField.value];
    if (value) {
      valueArray = value.split(',');
    }
    if (checked) {
      valueArray.push(itemValue)
    } else {
      valueArray.splice(valueArray.indexOf(itemValue), 1);
    }
    onChange && onChange(valueArray.toString())
  }

  render() {
    const { source, field, value, disabled, onlyShowChecked } = this.props;
    return <div>
      {
        source.map((item, index) => {
          const checked = value && value.indexOf(item[(field && field.value) || defaultField.value]) >= 0;
          if (onlyShowChecked && ! checked) return null;
          return <CheckableTag
            key={index}
            style={{ margin: '1px' }}
            checked={checked}
            onChange={(checked) => ! disabled && this.handleChange(checked, item)}>
            {item[(field && field.label) || defaultField.label]}
          </CheckableTag>
        })
      }
    </div>
  }
}
