import React from 'react';
import ReactDOM from 'react-dom';
import { Modal, Button } from 'antd';

const ConfirmDialog = ({ title, content, onOk, onCancel, onClose, close, okText, cancelText, visible }) => {
  return <Modal
		title={<div style={{padding: '5px 10px'}}>{title}</div>}
		visible={visible}
		onCancel={() => {
			onClose && onClose();
			close()}
		}
		footer={<div><Button size="small" onClick={() => {
			onCancel && onCancel();
			close();
		}}>{cancelText || '取消'}</Button><Button size="small" onClick={() => {
			onOk && onOk();
			close()
		}}>{okText || '完成'}</Button></div>}>
			<p>{content}</p>
		</Modal>
}
export default function confirmFunc(config) {
	const div = document.createElement('div');
	document.body.appendChild(div);
	let currentConfig = { ...config, close, visible: true };

	function render(props) {
		ReactDOM.render(<ConfirmDialog {...props}/>, div);
	}

	function destroy() {
		const unmountResult = ReactDOM.unmountComponentAtNode(div);
		if (unmountResult && div.parentNode) {
      div.parentNode.removeChild(div);
    }
	}

	function close() {
		currentConfig.visible = false;
		currentConfig.afterClose = () => destroy();
		render(currentConfig);
	}

	render(currentConfig);
}
