import './index.less';
import styles from "./index.less";
import React, { PureComponent } from 'react';
import { DatePicker, Popover, Button, message } from 'antd';
import moment from 'moment';
import classnames from 'classnames';
import { getBeginAndEndDate } from '../../utils'
import { dateFormatConst, dateTimeFormatConst } from '../../common/const'
import { quickButtonGroups, quickButtons } from '../../utils/quick-button';
import { FormattedMessage } from 'react-intl';
import _ from 'lodash';


class CustomDateTime extends PureComponent {
  constructor(props) {
    super(props);
    this.elem1 = React.createRef();
    this.elem2 = React.createRef();
    this.elem3 = React.createRef();

    this.state = {
      // beginDate: undefined,
      // endDate: undefined,
      // selectedLabel: '',
      // selectedValue: '',
      value: null,
      outOfPos: false,
      format: '',
    }
  }

  componentDidMount() {
    const { value, format } = this.props;
    //console.log("***内部组件接收到的参数",this.props)
    this.initPropsValue(value);
    if (format === 1) {
      this.setState({ format: 'YYYY-MM-DD HH' })
    } else if (format === 2) {
      this.setState({ format: 'YYYY-MM-DD HH:mm' })
    } else if (format === 3 || format === 0) {
      this.setState({ format: 'YYYY-MM-DD HH:mm:ss' })
    }
    const hourCount = [], minuteCount = [], secondCount = [];
    if (format === 1) {
      for (let i = 0; i < 24; i++) {
        hourCount.push({ val: i, checked: false });
      }
    } else if (format === 2) {
      for (let i = 0; i < 24; i++) {
        hourCount.push({ val: i, checked: false });
      }
      for (let i = 0; i < 60; i++) {
        minuteCount.push({ val: i, checked: false });
      }
    } else if (format === 3 || format === 0) {
      for (let i = 0; i < 24; i++) {
        hourCount.push({ val: i, checked: false });
      }
      for (let i = 0; i < 60; i++) {
        minuteCount.push({ val: i, checked: false });
        secondCount.push({ val: i, checked: false });
      }
    }
    this.setState({ hourCount, minuteCount, secondCount })
  }

  componentWillReceiveProps(nextProps) {
    const { value } = nextProps;
    // console.log('nextProps', value, this.props.value);
    if (value !== this.props.value) {
      // this.handleChangeState(value);
      this.setState({
        value: moment(value)
      })
    }
  }

  initPropsValue(v) {
    if (v) { this.setState({ value: moment(v) }, () => this.transferToFather()) }
  }

  handleChangeState(value) {
    //console.log('处理的数据',value);
    if (value) {
      this.setState({
        value: moment(value)
      }, () => this.transferToFather())
    }
    else {
      this.setState({
        value: null
      }, () => this.transferToFather())
    }
  }

  handleChange(value) {
    //console.log(value)
    //console.log(value,typeof value);
    if (value) {
      this.setState({ value }, () => this.initTimeLed());
    } else {
      this.setState({ value: null }, () => this.transferToFather());
    }
  }
  transferToFather() {
    const dateString = this.state.value ? this.state.value.format(dateTimeFormatConst) : '';
    this.props.onChange && this.props.onChange(dateString);
  }
  setTime(v1, v2) {
    //console.log(v1,v2)
    let tempValue = this.state.value;
    if (!tempValue) {
      message.error('必须先选择一个日期');
      return
    }
    if (v1 === 1) {
      let temp = _.cloneDeep(this.state.hourCount);
      temp.map(item => {
        if (item.val === v2) {
          item.checked = true;
        } else {
          item.checked = false;
        }
      })
      tempValue.hours(v2);
      this.setState({ hourCount: temp, value: tempValue }, () => this.transferToFather());

      if (this.elem1.current) {
        this.elem1.current.scrollTop = v2 * 28;
      }
    } else if (v1 === 2) {
      let temp = _.cloneDeep(this.state.minuteCount);
      temp.map(item => {
        if (item.val === v2) {
          item.checked = true;
        } else {
          item.checked = false;
        }
      })
      tempValue.minutes(v2);
      this.setState({ minuteCount: temp, value: tempValue }, () => this.transferToFather());
      if (this.elem2.current) {
        this.elem2.current.scrollTop = v2 * 28;
      }

    } else if (v1 === 3) {
      let temp = _.cloneDeep(this.state.secondCount);
      temp.map(item => {
        if (item.val === v2) {
          item.checked = true;
        } else {
          item.checked = false;
        }
      })
      tempValue.seconds(v2);
      this.setState({ secondCount: temp, value: tempValue }, () => this.transferToFather());

      if (this.elem3.current) {
        this.elem3.current.scrollTop = (v2) * 28;
      }
    }
  }

  initTimeLed() {
    const { format } = this.props;
    let temp = this.state.value;
    if (temp) {
      let temp1 = temp.hour();
      let temp2 = temp.minutes();
      let temp3 = temp.seconds();
      //console.log(temp1,temp2,temp3);
      if (format === 1) {
        this.setTime(1, temp1);
      } else if (format === 2) {
        this.setTime(1, temp1);
        this.setTime(2, temp2);
      } else if (format === 3 || format === 0) {
        this.setTime(1, temp1);
        this.setTime(2, temp2);
        this.setTime(3, temp3);
      }
      // this.setTime(1,temp1);
      // this.setTime(2,temp2);
      // this.setTime(3,temp3);
      this.transferToFather();
    }
  }

  onOpenChange(v) {
    const { format } = this.props;
    //console.log(v);
    //setTimeout(()=>console.log(this.elem1,this.elem2,this.elem3),2000)
    //console.log(this.elem1,this.elem2,this.elem3);
    if (v) {
      //console.log(this.state.value);
      let temp = this.state.value;
      if (temp) {
        const temp1 = temp && temp.hour();
        const temp2 = temp && temp.minute();
        const temp3 = temp && temp.second();
        var timer = setInterval(() => {
          if (this.elem1.current) {
            clearInterval(timer);
            if (format === 1) {
              this.setTime(1, temp1);
            } else if (format === 2) {
              this.setTime(1, temp1);
              this.setTime(2, temp2);
            } else if (format === 3 || format === 0) {
              this.setTime(1, temp1);
              this.setTime(2, temp2);
              this.setTime(3, temp3);
            }
            // this.setTime(1,temp1);
            // this.setTime(2,temp2);
            // this.setTime(3,temp3);
          }
        }, 500)
      } else {
        temp = moment();
        this.setState({
          value: moment()
        }, () => {
          const temp1 = temp && temp.hour();
          const temp2 = temp && temp.minute();
          const temp3 = temp && temp.second();
          var timer2 = setInterval(() => {
            if (this.elem1.current) {
              clearInterval(timer2);
              if (format === 1) {
                this.setTime(1, temp1);
              } else if (format === 2) {
                this.setTime(1, temp1);
                this.setTime(2, temp2);
              } else if (format === 3 || format === 0) {
                this.setTime(1, temp1);
                this.setTime(2, temp2);
                this.setTime(3, temp3);
              }
              // this.setTime(1,temp1);
              // this.setTime(2,temp2);
              // this.setTime(3,temp3);
            }
          }, 500)
        })

      }

    }
  }
  readPos(e) {
    let mouseX = e.clientX;
    let windowX = window.outerWidth;
    const { format } = this.props;
    let tempVal = 0;
    if (format === 1) {
      tempVal = 57
    } else if (format === 2) {
      tempVal = 57 * 2
    } else if (format === 3 || format === 0) {
      tempVal = 57 * 3
    }
    //console.log(mouseX,windowX)
    //console.log(e.target.type,e.target);
    if (e.target.type === 'text') {
      if (mouseX + 278 + tempVal > windowX) {
        //console.log('超出边界');
        this.setState({ outOfPos: true })
      } else {
        //console.log('未能超出');
        this.setState({ outOfPos: false })
      }
    }
  }

  render() {
    const { size, disabled, format, placeholder = [], lang, } = this.props;
    const { value, hourCount, minuteCount, secondCount } = this.state;
    let timeLed = '', show1 = '', show2 = '', show3 = '';
    if (format === 1) { timeLed = 'HH'; show1 = 1 }
    else if (format === 2) { timeLed = 'HH:mm'; show1 = 1; show2 = 1 }
    else if (format === 3 || format === 0) { timeLed = 'HH:mm:ss'; show1 = 1; show2 = 1; show3 = 1; }

    const attachComponent = <div className="customDateTime">
      <div className='timeLed'>{value && value.format(timeLed) || '请选择日期'}</div>
      <div className='wrapper'>
        {show1 && <ul ref={this.elem1}>
          {hourCount && hourCount.map(item => {
            if (item < 10) {
              return <li key={item.val} className={item.checked ? "hover" : ''} onClick={() => this.setTime(1, item.val)}>{`0${item.val}`}</li>
            } else {
              return <li key={item.val} className={item.checked ? "hover" : ''} onClick={() => this.setTime(1, item.val)}>{item.val}</li>
            }
          })}
        </ul>}
        {show2 && <ul ref={this.elem2}>
          {minuteCount && minuteCount.map(item => {
            if (item < 10) {
              return <li key={item.val} className={item.checked ? "hover" : ''} onClick={() => this.setTime(2, item.val)}>{`0${item.val}`}</li>
            } else {
              return <li key={item.val} className={item.checked ? "hover" : ''} onClick={() => this.setTime(2, item.val)}>{item.val}</li>
            }
          })}
        </ul>}
        {show3 && <ul ref={this.elem3}>
          {secondCount && secondCount.map(item => {
            if (item < 10) {
              return <li key={item.val} className={item.checked ? "hover" : ''} onClick={() => this.setTime(3, item.val)}>{`0${item.val}`}</li>
            } else {
              return <li key={item.val} className={item.checked ? "hover" : ''} onClick={() => this.setTime(3, item.val)}>{item.val}</li>
            }
          })}
        </ul>}
      </div>
    </div>;

    return (
      <div onClick={e => this.readPos(e)}>
        <DatePicker renderExtraFooter={() => attachComponent}
          size={this.props.size ? this.props.size : 'small'}
          disabled={disabled}
          showTime value={value} onOpenChange={data => { this.onOpenChange(data) }}
          onChange={date => { this.handleChange(date) }}
          dropdownClassName={!this.state.outOfPos ? 'test' : this.state.outOfPos && format === 1 ? 'test11' : this.state.outOfPos && format === 2 ? 'test22' : this.state.outOfPos && format === 3 || format === 0 ? 'test33' : ''}
          style={{ width: '100%' }}
          getPopupContainer={triggerNode => triggerNode.parentNode || document.body}
          format={this.state.format ? this.state.format : "YYYY-MM-DD HH:mm:ss"}
        //popupStyle={{right:'200px!important'}}
        //getCalendarContainer={()=>document.getElementById('Select')}
        />
      </div>
    )
  }
}

export default CustomDateTime;