/**
 * Created by 王友生 on 2018-07-20.
 */

import './index.less';

import React, { PureComponent } from 'react';
import { List } from 'antd';
import { getItemActualValue } from '../../utils';
import { connect } from 'react-redux';
import { renderAColor } from '../../utils';

@connect((state, route) => {
  const reference = state.get('reference');
  const dictionary = state.get('dictionary');
  return {
    reference,
    dictionary
  }
})
export default class CustomList extends PureComponent {
  render() {
    const { dataSource, listColumnsConfig, dispatch, reference, dictionary, onItemDoubleClick } = this.props;
    if (! listColumnsConfig || ! dataSource) {
      return <div>暂无数据</div>
    }
    const { titleConfig, descConfig } = listColumnsConfig;
    return <List
      className="listWrapper"
      itemLayout="horizontal"
      dataSource={dataSource}
      renderItem={(itemData, index) => {
        const title = titleConfig ? getItemActualValue(titleConfig, itemData[titleConfig.dataIndex], dispatch, reference, dictionary) : ' '
        const desc = descConfig ? getItemActualValue(descConfig, itemData[descConfig.dataIndex], dispatch, reference, dictionary) : ' ';
        return <List.Item onDoubleClick={() => onItemDoubleClick && onItemDoubleClick(itemData)}>
          <List.Item.Meta
            avatar={(index || index === 0) &&
            <span className="metaIcon" style={{ backgroundColor: renderAColor() }}>{index + 1}</span>}
            title={title}
            description={desc}
          />
        </List.Item>
      }}
    />
  }
}
