import React, { PureComponent } from 'react';
import DraggableModal from '../DraggableModal';
import { connect } from 'react-redux';
import { getCachePopComponent } from '../../utils';

@connect(state => {
	const customPopEdit = state.getIn(['system', 'customPopEdit']);
	return {
		activeKey: customPopEdit.get('activeKey'),
		record: customPopEdit.get('record'),
		functionCode: customPopEdit.get('functionCode')
	}
})
export default class CustomPopModal extends PureComponent {
  render() {
		const { activeKey, record, functionCode } = this.props;
		if (! activeKey) {
			return null;
		}
		let { C } = getCachePopComponent(activeKey);
		return <C record={record} functionCode={functionCode} />
	}
}
