/**
 * Created by 王友生 on 2018-05-14.
 */

import React, { PureComponent } from 'react';
import { message, Select, Switch, TreeSelect, Tooltip, Affix } from 'antd';
import _ from 'lodash';
import './index.less';
import { convertListToTreeSource, fastDate } from "../../utils";
import { FormattedMessage } from 'react-intl';
import { connect } from "react-redux";

@connect((state) => {
  const lang = state.get('system').get('lang');
  return {
    lang
  }
})
export default class CustomSelect extends PureComponent {
  state = { filterSource: [] }

  componentDidMount() {
    const { source, field, fromPage, sourceScenario, filter } = this.props;

    // console.log("source", source);
    // console.log("sourceScenario", sourceScenario);
    // console.log("filter", filter);
    let sourceList = _.cloneDeep(source);

    if (filter && filter.filterReg && sourceList.length > 0) {
      let filterSource = sourceList.filter((item) => {
        return eval(filter.filterReg).test(item[filter.filterColumn])
      });
      this.setState({ filterSource })
    }
    const newSource = _.filter(sourceList, sourceScenario);
    this.setState({ source: newSource || [] });
  }

  componentWillReceiveProps(newProps) {
    if (newProps.source && newProps.source !== this.props.source) {
      const newSource = _.filter(newProps.source, newProps.sourceScenario);

      this.setState({ source: newSource || [] });
    } else if (!_.isEqual(newProps.sourceScenario, this.props.sourceScenario)) {
      const newSource = _.filter(newProps.source, newProps.sourceScenario);
      this.setState({ source: newSource || [] });
    }
    if (newProps.filter && newProps.filter.filterReg && newProps.source.length > 0) {
      let filterSource = newProps.source.filter((item) => {
        return eval(newProps.filter.filterReg).test(item[newProps.filter.filterColumn])
      });
      this.setState({ filterSource })
    }
  }

  renderOption(data, field) {
    data && data.map((item, index) => {
      const label = field ? item[field.label] : item.label;
      const value = field ? item[field.value] : item.value;
      const title = field ? item[field.title] : item.title;
      return <Select.Option
        key={index}
        title={title ? title : label}
        search={value}
        value={value}
        label={label}>
        {field ? item[field.label] : item.label}</Select.Option>
    })
  }



  render() {
    const { source, filterSource } = this.state;
    const { field, onChange, selectProps, fromPage, style, needSelectItem, value, defaultValue, filter, isFilter } = this.props;

    let sourceList = _.cloneDeep(source);

    // if(sourceList&&sourceList.length>0){
    //   sourceList.forEach(item=>{
    //     if(fromPage&&fromPage.type==="writeBack"&&item.disabled=="1"){
    //       item.disabled = false;
    //     }
    //   })
    // }

    return <Select
      className="custom-select"
      style={{ minWidth: '100px', ...style }}
      allowClear
      showSearch
      size="default"
      optionFilterProp="label"
      defaultValue={defaultValue}
      {...selectProps}
      onChange={(value) => {
        if (needSelectItem) {
          const search = {};
          search[field ? field.value : 'value'] = value;
          onChange && onChange(value || '', _.find(isFilter && filterSource.length > 0 ? filterSource : source, search) || {});
          return;
        }
        onChange && onChange(value || '')
      }}>
      {
        sourceList && (isFilter && filterSource.length > 0 ? filterSource : sourceList).map((item, index) => {
          const label = field ? item[field.label] : item.label;
          const value = field ? item[field.value] : item.value;
          const title = field ? item[field.title] : item.title;
          return <Select.Option
            key={index}
            search={value}
            value={value}
            //2022-04-13 10:29:55支持禁用
            disabled={item.disabled}
            // disabled={false}
            label={label}>
            <Tooltip title={<span onClick={(e) => {
              e.stopPropagation();
              const input = document.createElement('input');
              input.style.cssText = 'display: block;opacity: 0;position: absolute;left: -10000px;top: -10000px;z-index: -1;'
              document.body.appendChild(input);
              input.value = title ? title : label;
              input.select();
              document.execCommand('copy');
              document.body.removeChild(input);
            }}>{title ? title : label}</span>} >
              {field ? item[field.label] : item.label}  {fromPage && fromPage.type === "modeling" && (title ? `(${title})` : `(${label})`)}

            </Tooltip>
          </Select.Option>
        })
      }
    </Select>
  }

}
