/**
 * Created by 王友生 on 2018-05-18.
 */

import React, { PureComponent } from "react"
import { TreeSelect, Switch } from "antd"
import { convertListToTreeSource } from "../../utils"
import _ from "lodash"

const TreeNode = TreeSelect.TreeNode

export default class CustomTreeSelect extends PureComponent {
  state = {}

  componentDidMount() {
    const { data, treeField, sourceScenario, filter, treeExpand } = this.props
    if (filter && filter.filterReg) {
      let filterData = data.filter(item => {
        return eval(filter.filterReg).test(item[filter.filterColumn])
      })
      this.setState({ filterData: convertListToTreeSource(filterData, treeField, sourceScenario) })
    }
    this.setState({ data: data ? convertListToTreeSource(data, treeField, sourceScenario) : [] })
    this.controlExpand(convertListToTreeSource(data, treeField, sourceScenario), treeExpand)
  }
  controlExpand(dataSource, treeExpand) {
    // 5.10父节点控制
    const { treeField } = this.props
    if (Array.isArray(dataSource)) {
      if (treeExpand == "openFirst") {
        let expandedKeys = []
        dataSource.map(item => {
          if (item.children && item.children.length > 0) {
            expandedKeys.push(item[treeField.id])
          }
        })
        this.setState({
          expandedKeys
        })
      } else if (treeExpand == "openEnd") {
        // let expandedKeys = []
        // function recursion(dataItem) {
        //   dataItem.map(item => {
        //     if (item.children && item.children.length > 0) {
        //       expandedKeys.push(item[treeField.id])
        //       recursion(item.children)
        //     }
        //   })
        // }
        // recursion(dataSource)
        let expandedKeys = this.setListKey(dataSource)
        this.setState({
          expandedKeys
        })
      }
    }
  }

  setListKey(yuanList) {
    let expandedKeys = []
    const recursion = dataItem => {
      dataItem.map(item => {
        if (item.children && item.children.length > 0) {
          expandedKeys.push(item.code)
          recursion(item.children)
        }
      })
    }
    recursion(yuanList)
    return expandedKeys
  }

  componentWillReceiveProps(newProps) {
    if (newProps.data && newProps.data !== this.props.data) {
      this.setState({ data: convertListToTreeSource(newProps.data, newProps.treeField, newProps.sourceScenario) })
      this.controlExpand(convertListToTreeSource(newProps.data, newProps.treeField, newProps.sourceScenario), newProps.treeExpand)
    } else if (!_.isEqual(newProps.sourceScenario, this.props.sourceScenario)) {
      this.setState({ data: convertListToTreeSource(newProps.data, newProps.treeField, newProps.sourceScenario) })
    }
    if (newProps.treeField && newProps.treeField !== this.props.treeField) {
      this.controlExpand(convertListToTreeSource(newProps.data, newProps.treeField, newProps.sourceScenario), newProps.treeExpand)
    }
    if (newProps.filter && newProps.filter.filterReg) {
      let filterData = newProps.data.filter(item => {
        return eval(newProps.filter.filterReg).test(item[newProps.filter.filterColumn])
      })
      this.setState({
        filterData: convertListToTreeSource(filterData, newProps.treeField, newProps.sourceScenario)
      })
    }
  }

  renderTreeNode(data) {
    const { treeField, forbitParent } = this.props
    return data.map(item => {
      return (
        <TreeNode
          disabled={forbitParent && !!item["children"]}
          key={item[treeField["id"]]}
          value={item[treeField["id"]]}
          title={<span title={item[treeField["id"]]}>{item[treeField["name"]]}</span>}
          label={item[treeField["name"]]}
        >
          {item["children"] && this.renderTreeNode(item["children"])}
        </TreeNode>
      )
    })
  }

  getTreeNode(data, realValue, displayValue, selectedValue) {
    const { treeField } = this.props
    let isNodeSelected = true
    try {
      data.map(item => {
        if (item["children"]) {
          const allChildrenSelected = this.getTreeNode(item["children"], realValue, displayValue, selectedValue)
          if (allChildrenSelected) {
            realValue.push(item[treeField["id"]])
            displayValue.push(item[treeField["name"]])
          } else {
            isNodeSelected = false
          }
        } else if (selectedValue.indexOf(item[treeField["id"]]) >= 0) {
          realValue.push(item[treeField["id"]])
          displayValue.push(item[treeField["name"]])
        } else {
          isNodeSelected = false
        }
      })
      return isNodeSelected
    } catch (e) {
      console.error("customTreeSele:data错误")
    }
  }

  render() {
    const { data, filterData, expandedKeys } = this.state
    if (!data) return null
    const {
      onChange,
      placeholder,
      value,
      disabled,
      antProps,
      needSelectItem,
      data: source,
      treeField,
      style,
      multiple,
      isFilter,
      filter
    } = this.props
    return (
      <TreeSelect
        {...antProps}
        disabled={disabled}
        style={style}
        showSearch
        showArrow={true}
        allowClear
        multiple={multiple}
        treeDefaultExpandedKeys={expandedKeys}
        dropdownMatchSelectWidth={false}
        value={value}
        onChange={(value, label) => {
          value = value || ""
          if (multiple) {
            const realValue = []
            const displayValue = []
            this.getTreeNode(isFilter && filter ? filterData : data, realValue, displayValue, value)
            return onChange({ value, realValue: realValue.toString(), displayValue: displayValue.toString() })
          }
          if (needSelectItem) {
            const search = {}
            search[treeField["id"]] = value
            onChange && onChange(value, _.find(source, search) || {})
            return
          }
          return onChange && onChange(value || "", label || "")
        }}
        placeholder={placeholder}
        treeNodeFilterProp="label"
      >
        {this.renderTreeNode(isFilter && filterData ? filterData : data)}
      </TreeSelect>
    )
  }
}
