import React, { PureComponent } from "react"
import { DatePicker, Select, Row, Col } from "antd"
import moment from "moment"

const { MonthPicker } = DatePicker

export default class CustomWeekRange extends PureComponent {
  constructor(props) {
    super(props)

    this.handleChange = this.handleChange.bind(this)
    this.handleSelectChange = this.handleSelectChange.bind(this)

    this.state = {
      weeks: [],
      weekLabels: [],
      param1: null,
      param2: null,
      dateString: "" //
    }
  }
  componentDidMount() {
    const { value } = this.props
    //console.log('value is *******' ,value)
    //console.log('this props is *******' ,this.props.value)
    if (value && value[0]) {
      this.handleChange(moment(value[0], "YYYY-MM"), value)
    }
  }

  componentWillReceiveProps(nextProps) {
    const { value } = nextProps
    //console.log('nextProps',value)
    //console.log('thisProps',this.props.value)
    if (value && this.props.value) {
      if (value[0] !== this.props.value[0]) {
        if (value[0]) {
          this.handleChange(moment(value[0], "YYYY-MM"), value)
        } else {
          this.handleChange(null, value)
        }
      } else if (value[1] !== this.props.value[1]) {
        if (value[0]) {
          this.handleChange(moment(value[0], "YYYY-MM"), value)
        } else {
          this.handleChange(null, value)
        }
      } else if (value[2] !== this.props.value[2]) {
        if (value[0]) {
          this.handleChange(moment(value[0], "YYYY-MM"), value)
        } else {
          this.handleChange(null, value)
        }
      } else if (value[3] !== this.props.value[3]) {
        if (value[0]) {
          this.handleChange(moment(value[0], "YYYY-MM"), value)
        } else {
          this.handleChange(null, value)
        }
      }
    }
  }

  getWeeks(year, month) {
    const d = new Date()
    // 该月第一天
    d.setFullYear(year, month - 1, 1)
    let w1 = d.getDay()
    if (w1 == 0) w1 = 7
    // 该月天数
    d.setFullYear(year, month, 0)
    const dd = d.getDate()
    // 第一个周一
    let d1
    if (w1 != 1) d1 = 7 - w1 + 2
    else d1 = 1
    const week_count = Math.ceil((dd - d1 + 1) / 7)
    //console.log(week_count)
    return week_count
  }

  getMondayTime(year, month, weekday) {
    const d = new Date()
    // 该月第一天
    d.setFullYear(year, month - 1, 1)
    let w1 = d.getDay()
    if (w1 == 0) w1 = 7
    // 该月天数
    d.setFullYear(year, month, 0)
    const dd = d.getDate()
    // 第一个周一
    let d1
    if (w1 != 1) d1 = 7 - w1 + 2
    else d1 = 1
    const monday = d1 + (weekday - 1) * 7
    return monday
  }

  handleChange(date, dateString) {
    //console.log('@@@date is ',date ? date.format('YYYY-MM-DD') : '');
    //console.log('@@@dateString is ',dateString);
    if (date) {
      const year = date.format("YYYY")
      const month = date.format("MM")
      const day = date.format("DD")

      const weeks = []
      const weekLabels = []

      let count = this.getWeeks(year, month)
      //console.log('year',year);
      //console.log('month',month);
      while (count > 0) {
        const weekDay = this.getMondayTime(year, month, count)
        count--
        const start = moment(`${year}-${month}-${weekDay}`)
        const end = moment(`${year}-${month}-${weekDay}`).add(6, "days")
        weekLabels.push(`${start.format("YYYY-MM-DD")}至${end.format("YYYY-MM-DD")}（第${count + 1}周）`)
        weeks.push([`${year}-${month}`, start.format("YYYY-MM-DD"), end.format("YYYY-MM-DD"), `${count + 1}`])
      }

      const head = moment(date).startOf("month")
      const tail = moment(date).endOf("month")
      //console.log('head',head,head.format('YYYY-MM-DD'));
      //console.log('tail',tail,tail.format('YYYY-MM-DD'));
      weekLabels.unshift(`${head.format("YYYY-MM-DD")}至${tail.format("YYYY-MM-DD")}（本月）`)
      weeks.unshift([`${year}-${month}`, head.format("YYYY-MM-DD"), tail.format("YYYY-MM-DD"), `0`])
      //console.log('weekLabels',weekLabels)
      //console.log('weeks',weeks)

      this.setState(
        {
          param1: date,
          //param2:'',
          weeks: weeks.reverse(),
          weekLabels: weekLabels.reverse()
        },
        () => {
          //console.log('dateString',dateString)
          if (dateString) {
            const label = `${dateString[1]}至${dateString[2]}（第${dateString[3]}周）`
            const idx = weekLabels.indexOf(label)

            //console.log('找索引',idx);
            //const temp = JSON.stringify(dateString);
            //console.log('!!!现在的dateString',temp)
            //console.log('!!!以前记录的dateString',this.state.dateString)

            if (idx !== -1 && (JSON.stringify(dateString) !== this.state.dateString || this.state.param2 !== idx)) {
              //this.setState({param1:date})
              this.handleSelectChange(idx)
            }
            if (idx === -1 && (JSON.stringify(dateString) !== this.state.dateString || this.state.param2 !== weekLabels.length - 1)) {
              //this.setState({param1:date})
              this.handleSelectChange(weekLabels.length - 1)
            }
          }
        }
      )
    } else {
      this.setState(
        {
          param1: null,
          param2: "",
          weeks: [],
          weekLabels: []
        },
        this.props.onChange && this.props.onChange('["","","",""]')
      )
    }
  }

  handleSelectChange(index) {
    //console.log('触发了子组件',index)
    //console.log(1,this.state.weeks[index]);
    //console.log(2,JSON.stringify(this.state.weeks[index]));
    this.setState({ param2: index, dateString: JSON.stringify(this.state.weeks[index]) })
    this.props.onChange && this.props.onChange(JSON.stringify(this.state.weeks[index]))
  }

  render() {
    const { param1, param2 } = this.state
    //console.log('param2',param2)
    return (
      <div>
        <Row>
          <Col span={6}>
            <MonthPicker
              size="small"
              value={param1 && param1}
              className="custom-week-range"
              placeholder="请选择月份"
              onChange={this.handleChange}
              style={{ paddingBottom: 6 }}
              allowClear={true}
            />{" "}
          </Col>
          <Col span={18}>
            <Select size="small" value={param2} onChange={this.handleSelectChange}>
              {this.state.weekLabels.map((label, index) => {
                return (
                  <Select.Option key={index} value={index}>
                    {label}
                  </Select.Option>
                )
              })}
            </Select>{" "}
          </Col>
        </Row>
      </div>
    )
  }
}
