/**
 * @Name : 描述详情组件
 * @Description : 左边是描述，右边是显示的具体内容
 * @Author : 王友生
 * @Creation Date : 2018/3/10 0010 10:51
 * @ModificationHistory
 */

import React from 'react';
import classNames from 'classnames';
import { Col } from 'antd';
import styles from './index.less';
import responsive from './responsive';

const Description = ({ term, column, className, children, ...restProps }) => {
  const clsString = classNames("description", className);
  return (
    <Col className={clsString} {...responsive[column]} {...restProps}>
      {term && <div className="term">{term}</div>}
      {children && <div className="detail">{children}</div>}
    </Col>
  );
};

export default Description;
