/**
 * @Name : 描述显示组件
 * @Description : 在显示一部分静态数据时使用，自动布局
 * @Author : 王友生
 * @Creation Date : 2018/3/10 0010 10:51
 * @ModificationHistory
 */
/* eslint-disable */
import React from "react"
import classNames from "classnames"
import { Row } from "antd"
import styles from "./index.less"

export default ({ className, title, col = 3, layout = "horizontal", gutter = 32, children, size, ...restProps }) => {
  const clsString = classNames("descriptionList", layout, className, {
    descriptionListSmall: size === "small",
    descriptionListLarge: size === "large"
  })
  const column = col > 4 ? 4 : col
  return (
    <div className={clsString} {...restProps}>
      {title ? <div className="title">{title}</div> : null}
      <Row gutter={gutter}>{React.Children.map(children, child => React.cloneElement(child, { column }))}</Row>
    </div>
  )
}
