/**
 * Created by 王友生 on 2018-08-01.
 */

import styles from "./index.less"
import React, { Component } from "react"
import { Upload, Icon, Modal, message, Cascader } from "antd"
import { serverUrl, fileServerUrl } from "../../common/config"
import { systemCommonFileFunctionCode, supportImage } from "../../common/const"
import classnames from "classnames"
import { request, get } from "../../utils"
import provinces1 from "../../common/provinces.json"
import cities1 from "../../common/cities.json"
import areas1 from "../../common/areas.json"
import _ from "lodash"

export default class Division extends Component {
  constructor(props) {
    super(props)
    this.state = {
      provinces: null,
      cities: null,
      areas: null,
      options: null
    }
  }

  componentWillReceiveProps(newProps) {
    //console.log(20,newProps)
  }

  componentDidMount() {
    this.props.onChange && this.getProvinceInfos()
  }

  onChange(value, selectedOptions) {
    //console.log(value, selectedOptions);
    if (value) {
      // && value.length === 3 && selectedOptions && selectedOptions.length === 3
      //let array = [value.toString(),`${selectedOptions[0].label}${selectedOptions[1].label}${selectedOptions[2].label}`];
      let arrayToString = [value.toString()]
      arrayToString = JSON.stringify(arrayToString)
      //console.log('32',array);
      this.props.onChange && this.props.onChange(arrayToString)
    }
  }

  getProvinceInfos() {
    get("/sysPlatformCfg/getProvinceInfos", {}).then(data => {
      if (data) {
        //console.log('1');
        this.setState({ provinces: JSON.parse(data.result) }, () => this.getCityInfos())
      }
      if (!data) {
        //console.log('11');
        this.setState({ provinces: provinces1 }, () => this.getCityInfos())
      }
    })
  }
  getCityInfos() {
    //console.log('64',this.state.provinces);
    get("/sysPlatformCfg/getCityInfos", {}).then(data => {
      if (data) {
        //console.log('2');
        this.setState({ cities: JSON.parse(data.result) }, () => this.getAreaInfos())
      }
      if (!data) {
        //console.log('22');
        this.setState({ cities: cities1 }, () => this.getAreaInfos())
      }
    })
  }
  getAreaInfos() {
    get("/sysPlatformCfg/getAreaInfos", {}).then(data => {
      if (data) {
        //console.log('3');
        this.setState({ areas: JSON.parse(data.result) }, () => this.setOpitions())
      }
      if (!data) {
        //console.log('33');
        this.setState({ areas: areas1 }, () => this.setOpitions())
      }
    })
  }

  setOpitions() {
    let provinces = _.cloneDeep(this.state.provinces)
    let cities = _.cloneDeep(this.state.cities)
    let areas = _.cloneDeep(this.state.areas)

    let matchCity, matchProvince, options2

    areas.forEach(area => {
      matchCity = cities.filter(city => city.code === area.cityCode)[0]
      if (matchCity) {
        matchCity.children = matchCity.children || []
        matchCity.children.push({
          label: area.name,
          value: area.code
        })
      }
    })

    cities.forEach(city => {
      matchProvince = provinces.filter(province => province.code === city.provinceCode)[0]
      if (matchProvince) {
        matchProvince.children = matchProvince.children || []
        matchProvince.children.push({
          label: city.name,
          value: city.code,
          children: city.children
        })
      }
    })

    options2 = provinces.map(province => ({
      label: province.name,
      value: province.code,
      children: province.children
    }))
    //console.log('***',options2);
    this.setState({ options: options2 })
  }

  render() {
    const { options } = this.state
    return (
      <Cascader
        options={options}
        disabled={this.props.onChange ? false : true}
        changeOnSelect
        value={this.props.value}
        style={{ width: "100%" }}
        size={"small"}
        onChange={(value, selectedOptions) => this.onChange(value, selectedOptions)}
      />
    )
  }
}
