/**
 * Created by 王友生 on 2018-06-11.
 */
/* eslint-disable */
import styles from "./index.less"
import React from "react"
import { Col, Icon } from "antd"
import classnames from "classnames"
import EllipsisText from "../EllipsisText"

export default ({ isOverNode, title, focus, width, key, onDelete, onClick, onDragStart, onDragOver, onDragEnd, overflow }) => {
  return (
    <Col span={width > 24 ? 6 : width} key={key}>
      <div
        className={classnames("node", isOverNode ? "behind" : "", focus ? "focus" : "")}
        draggable
        onDragStart={e => {
          e.stopPropagation()
          onDragStart && onDragStart()
        }}
        onDragOver={e => {
          e.stopPropagation()
          onDragOver && onDragOver()
        }}
        onDragEnd={e => {
          e.stopPropagation()
          onDragEnd && onDragEnd()
        }}
        onClick={e => {
          e.stopPropagation()
          onClick && onClick()
        }}
      >{overflow ? <div className="autoWidth"><div>{title}</div></div> : <EllipsisText>{title}</EllipsisText>}
        <Icon
          className="close"
          onClick={e => {
            e.stopPropagation()
            onDelete && onDelete()
          }}
          type="close"
        />
      </div>
    </Col>
  )
}
