import React, { PureComponent } from 'react'
import EmployeeSelector from '../index';
import { workflowNodeType } from '../../../common/const';
import { Tooltip } from 'antd';

export default class EmplyeeSelectorLable extends PureComponent {
	state = {
		visible: false,
	}

	render() {
		const { value, onSelectEnd, edit, employeeSupport } = this.props;
		let personCount = 0;
		let postCount = 0;
		let dutiesCount = 0;
		let departCount = 0;
		let roleCount = 0;
		let corpCount = 0;
		let summary = '';
		let items = [];
		if (value) {
			items = JSON.parse(value);
			if (items && items.length > 0) {
				items.map(item => {
					if (item.type === workflowNodeType.person.value) {
						personCount++;
					} else if (item.type === workflowNodeType.post.value) {
						postCount++;
					} else if (item.type === workflowNodeType.duties.value) {
						dutiesCount++;
					} else if (item.type === workflowNodeType.department.value || item.type === workflowNodeType.allDepartment.value) {
						departCount++;
					} else if (item.type === workflowNodeType.role.value) {
						roleCount++;
					} else if (item.type === workflowNodeType.corporation.value || item.type === workflowNodeType.allCorpration.value) {
						corpCount++
					}
					summary += `${item.name} `;
				});
			}
		}
		let desc = ''
		personCount && (desc += `${personCount}人 `);
		postCount && (desc += `${postCount}岗位 `);
		dutiesCount && (desc += `${dutiesCount}职务 `);
		departCount && (desc += `${departCount}部门 `);
		corpCount && (desc += `${corpCount}单位 `);
		roleCount && (desc += `${roleCount}角色 `);
		return <div style={{ padding: '3px 0 2px' }}>
			<Tooltip title={summary}>{desc}</Tooltip>
			{edit && <a onClick={(e) => {
				e.preventDefault();
				this.setState({ visible: true })
			}}>选择</a>
			}
			{edit && <EmployeeSelector
				value={items}
				employeeSupport={employeeSupport}
				visible={this.state.visible}
				onClose={() => this.setState({ visible: false })}
				onSelectEnd={(type, nodes) => { this.setState({ visible: false }); onSelectEnd && onSelectEnd(JSON.stringify(nodes)) }} />
			}
		</div>
	}
}
