import './index.less'
import React, { Component } from 'react';
import { Select, Button, Tooltip, Modal } from 'antd';
import AutogenerationForm from "../AutoGenerationForm";
import { connect } from "react-redux";
import { wfConditionConst } from "../../common/const";
import { Map, fromJS } from "immutable"
import { cloneableGenerator } from 'redux-saga/utils';

const { Option } = Select;

@connect(state => {
  const lang = state.get("system").get("lang");
  const activeTab = state.get("system").get("activeTab");
  return {
    lang,
    activeTab
  }
})

export default class FreeCombinationForm extends Component {

  constructor(props) {
    super(props)
    this.state = {
      shanchu: "",
      freeCombinationList: props.freeData ? props.freeData : [
        { title: "", dataIndex: "", type: "", tiaojian: "", tjtitle: "", tiaojianMes: [], tiaojianMesData: {}, tiaojianObg: "" }
      ],
    }
  }

  componentWillUpdate(newprops) {
    if (newprops.activeTab.name != this.props.activeTab.name) {
      this.setKong();
    }
    if (newprops.freeData && newprops.freeData !== this.state.freeCombinationList) {
      this.setState({
        freeCombinationList: newprops.freeData
      })
    }
  }

  // TODO:新增自定义form的一个条目
  addNewItem() {
    const { freeCombinationList } = this.state
    const { getChangeData } = this.props;
    const newObg = { title: "", dataIndex: "", type: "", tiaojian: "", tjtitle: "", tiaojianMes: [], tiaojianMesData: {}, tiaojianObg: "" }
    let newlist = [...freeCombinationList, ...[newObg]]

    this.setState({
      freeCombinationList: newlist
    }, () => {
      const { freeCombinationList } = this.state;
      getChangeData && getChangeData(freeCombinationList)
    })
  }

  // TODO:删除所选的行
  shangchu(suoyin) {
    const { freeCombinationList } = this.state;
    const { getChangeData } = this.props;
    let that = this;
    if (freeCombinationList.length === 1) {
      Modal.error({
        title: "删除行提示！",
        content: "高级查询条件最少一行，当前已经是最后一行，无法删除！"
      })
      this.setState({
        freeCombinationList: [
          { title: "", dataIndex: "", type: "", tiaojian: "", tjtitle: "", tiaojianMes: [], tiaojianMesData: {}, tiaojianObg: "" }
        ]
      }, () => {
        that.setKong()
      })
      return
    }
    let newList = freeCombinationList.filter((el, index) => index != suoyin)
    this.setState({
      freeCombinationList: newList
    }, () => {
      const { freeCombinationList } = this.state;
      getChangeData && getChangeData(freeCombinationList)
    })
  }

  // TODO:选择框改变
  setSelectChange(value, obg, suoyin) {
    const { searchConfig, searchScenario, getChangeData } = this.props;
    const { freeCombinationList } = this.state
    let keyList = value.split(",");

    let newList = _.cloneDeep(freeCombinationList)

    let keywords = searchConfig[0].filter(el => el.tableName == keyList[0] && el.dataIndex == keyList[1])

    let newObg = {
      [keywords[0].tableName]: {
        [keywords[0].dataIndex]: { value: "1", type: keywords[0].type }
      }
    }
    // return;
    newList[suoyin].dataIndex = keywords[0].dataIndex;
    newList[suoyin].tableName = Object.keys(newObg)[0];
    newList[suoyin].title = keywords[0].title;
    newList[suoyin].type = keywords[0].type
    let list = []
    list[0] = searchConfig[0].filter(el => el.tableName == keyList[0] && el.dataIndex == keyList[1])
    newList[suoyin].tiaojianMes = list
    newList[suoyin].tiaojianMesData = fromJS(newObg)
    newList[suoyin].tiaojianObg = ""
    this.setState({
      freeCombinationList: newList
    }, () => {
      const { freeCombinationList } = this.state;
      getChangeData && getChangeData(freeCombinationList)
    })
  }

  // TODO:设置后面数据
  setDataState(value, dataIndex, item, referenceResult, suoyin) {
    const { getChangeData } = this.props;
    const { freeCombinationList } = this.state
    let newList = _.cloneDeep(freeCombinationList)

    newList.forEach((element, index) => {
      if (element.dataIndex == dataIndex && index == suoyin) {
        element.tiaojianObg = value
        element.tiaojianMesData = element.tiaojianMesData.setIn([item.tableName, dataIndex, "value"], value)
      }
    })

    this.setState({
      freeCombinationList: newList
    }, () => {
      const { freeCombinationList } = this.state;
      getChangeData && getChangeData(freeCombinationList)
    })
  }

  // TODO:判断符选择
  setTiaoJian = (judgmentF, suoyin) => {
    const { getChangeData } = this.props;
    const { freeCombinationList } = this.state
    let newList = _.cloneDeep(freeCombinationList)

    let keys = Object.keys(wfConditionConst)
    let fName = ""
    keys.forEach(item => {
      if (judgmentF == wfConditionConst[item].value) {
        fName = wfConditionConst[item].label
      }
    })
    newList.forEach((element, index) => {
      if (index === suoyin) {
        element.tiaojian = judgmentF
        element.tjtitle = fName
      }
    })
    this.setState({
      freeCombinationList: newList
    }, () => {
      const { freeCombinationList } = this.state;
      getChangeData && getChangeData(freeCombinationList)
    })
  }

  setKong() {
    const { getChangeData } = this.props;
    this.setState({
      freeCombinationList: [
        { title: "", dataIndex: "", type: "", tiaojian: "", tjtitle: "", tiaojianMes: [], tiaojianMesData: {}, tiaojianObg: "" }
      ]
    }, () => {
      // const { freeCombinationList } = this.state;
      getChangeData && getChangeData([])
    })
  }

  // TODO:删除整个条件组
  dropGroup() {
    // const setKong = () => {
    //   this.setState({
    //     freeCombinationList: [
    //       { title: "", dataIndex: "", type: "", tiaojian: "", tjtitle: "", tiaojianMes: [], tiaojianMesData: {}, tiaojianObg: "" }
    //     ]
    //   })
    // }
    let that = this;
    Modal.confirm({
      title: "确定删除整个条件组？",
      onOk() {
        that.setKong()
      }
      // onCancel(){},
    })
  }

  render() {
    const { freeCombinationList, shanchu } = this.state
    const { searchConfig, tableConfig, lang, operator, setOperator } = this.props;
    // console.log(666, 'searchConfig' + '\n', searchConfig, 'tableConfig' + '\n', tableConfig, 'operator' + '\n', operator)
    tableConfig &&
      tableConfig.length > 0 &&
      tableConfig.map(item => {
        if (!item.titleCh) {
          item.titleCh = item.title
        }
      })
    tableConfig &&
      tableConfig.length > 0 &&
      tableConfig.map(item => {
        item.title = lang === "en" ? item.titleEN : item.titleCh
      })

    let keysList = Object.keys(wfConditionConst)
    let dropIndex = keysList.indexOf("notcontain")
    keysList.splice(dropIndex, 1)
    // console.log("条件列表", keysList);

    // TODO:筛选出条件字段中能用的字段
    const listNotHave = () => {
      // let newArr = searchConfig&&searchConfig[0].filter((x) => !freeCombinationList.some((item) => x.dataIndex === item.dataIndex));
      let newArr = searchConfig && searchConfig[0].filter(el => el.hide != "1");
      return newArr
    }

    // TODO: 判断禁用
    const isDisable = value => {
      const unChoList = ["dateRange"]
      return unChoList.indexOf(value) > -1
    }



    return (
      <div className="layerFormW">
        <span className="zongTj">
          <Tooltip placement="top" title={"点击切换'且'、'或'查询关系"}>
            <font onClick={() => setOperator && setOperator(operator == "and" ? "or" : "and")}>{operator == "and" ? "且" : "或"}</font>
          </Tooltip>
          <em onClick={() => this.dropGroup()}>-</em>
        </span>
        <ul className="layerForm">
          {freeCombinationList &&
            freeCombinationList.map((item, index) => (
              <li className="layerLi" key={index}>
                <Select
                  style={{ width: 200, borderRadius: 2, marginRight: 10 }}
                  placeholder={"请选择条件字段"}
                  value={item.title}
                  onChange={(value, item) => this.setSelectChange(value, item, index)}
                >
                  {listNotHave() &&
                    listNotHave().map((item1, index1) => (
                      // <Option key={index1} value={item1.dataIndex}></Option>
                      <Option key={index1} value={item1.tableName + ',' + item1.dataIndex}>
                        {item1.title}
                      </Option>
                    ))}
                </Select>
                {/* disabled={isDisable(item.type)}   //禁用属性 */}
                <Select
                  style={{ width: 120, borderRadius: 2, marginRight: 10 }}
                  onChange={value => this.setTiaoJian(value, index)}
                  value={item.tjtitle}
                  placeholder="请选择条件关系"
                >
                  {keysList &&
                    keysList.map((item, index) => (
                      <Option key={index} value={wfConditionConst[item].value}>
                        {wfConditionConst[item].label}
                      </Option>
                    ))}
                </Select>
                <div style={{ width: 310, marginRight: 10, display: "inline-block" }}>
                  {item.tiaojianMes.length > 0 ? (
                    <AutogenerationForm
                      style={{
                        display: "inline-block",
                        height: 32,
                        lineHeight: 32,
                        boxSizing: "border-box",
                        marginTop: "-2px!important",
                        verticalAlign: "middle",
                        width: "100%"
                      }}
                      lang={this.props.lang}
                      forbidHide
                      labelWidthSwitch={"hide"}
                      scale={5}
                      config={[...[...item.tiaojianMes]]}
                      source={item.tiaojianMesData}
                      getItemValue={() => item.tiaojianObg}
                      // onItemValueChange && onItemValueChange(value, dataIndex, item, referenceResult) &&
                      onItemValueChange={(value, dataIndex, item, referenceResult) =>
                        this.setDataState(value, dataIndex, item, referenceResult, index)
                      }
                    />
                  ) : (
                    <span className="tishiWord">请选择搜索条件字段</span>
                  )}
                </div>
                <Tooltip placement="top" title={"删除当前行"}>
                  <Button type="primary" size="small" shape="circle" onClick={() => this.shangchu(index)} icon="minus" />
                </Tooltip>
              </li>
            ))}
          <li className="layerLi">
            <Tooltip placement="top" title={"新增一行"}>
              <Button size="small" type="primary" shape="circle" icon="plus" onClick={() => this.addNewItem()} />
            </Tooltip>
          </li>
        </ul>
      </div>
    )
  }
}
