/**
 * Created by 王友生 on 2018-05-14.
 */

import React, { PureComponent } from "react"
import { Select, Input, List, Button, Message, Empty, Popover } from "antd"
import _ from "lodash"
import "./index.less"
import { connect } from "react-redux"
import DraggableModal from "../DraggableModal"
import AutoGenerationDetail from "../AutoGenerationDetail"
import { request } from "../../utils/request"
import { timestampToTime } from "../../utils"
const { Search } = Input
const { Option } = Select

@connect(state => {
  const lang = state.get("system").get("lang")
  const form = state.get("form")
  return {
    lang,
    form
  }
})
export default class ICinfo extends PureComponent {
  basicInfo = JSON.parse(localStorage.getItem("basicInfo"))
  state = {
    visible: false,
    list: [],
    config: [
      [
        {
          width: 24,
          dataIndex: "name",
          title: "公司名称",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "alias",
          title: "简称",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "property3",
          title: "英文名",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "historyNames",
          title: "曾用名",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "companyOrgType",
          title: "企业类型",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "industry",
          title: "行业",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "legalPersonName",
          title: "法人姓名",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "type",
          title: "法人类型",
          type: "select",
          source: [
            { label: '人', value: '1' },
            { label: '公司', value: '2' },
          ],
        },
        {
          width: 24,
          dataIndex: "phoneNumber",
          title: "电话",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "email",
          title: "邮箱",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "websiteList",
          title: "网址",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "city",
          title: "市",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "base",
          title: "省份简称",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "regStatus",
          title: "企业状态",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "estiblishTime",
          title: "成立日期",
          type: "date"
        },
        {
          width: 24,
          dataIndex: "toTime",
          title: "营业期限",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "fromTime",
          title: "经营开始时间",
          type: "date"
        },
        {
          width: 24,
          dataIndex: "regCapital",
          title: "注册资本",
          type: "text"
        },
        // {
        //   width: 24,
        //   dataIndex: "actualCapitalCurrency",
        //   title: "实收注册资本币种",
        //   type: "text"
        // },
        {
          width: 24,
          dataIndex: "regCapitalCurrency",
          title: "注册资本币种",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "staffNumRange",
          title: "人员规模",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "businessScope",
          title: "经营范围",
          type: "textArea"
        },


        {
          width: 24,
          dataIndex: "socialStaffNum",
          title: "参保人数",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "tags",
          title: "企业标签",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "isMicroEnt",
          title: "是否小微企业",
          type: "select",
          source: [
            { label: '不是', value: '0' },
            { label: '是', value: '1' },
          ],
        },
        {
          width: 24,
          dataIndex: "regInstitute",
          title: "登记机关",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "regNumber",
          title: "注册号",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "regLocation",
          title: "注册地址",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "orgNumber",
          title: "组织机构代码",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "creditCode",
          title: "社会信用代码",
          type: "text"
        },

        {
          width: 24,
          dataIndex: "taxNumber",
          title: "纳税人识别号",
          type: "text"
        },

        {
          width: 24,
          dataIndex: "bondNum",
          title: "股票号",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "bondName",
          title: "股票名",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "usedBondName",
          title: "股票曾用名",
          type: "text"
        },

        {
          width: 24,
          dataIndex: "cancelDate",
          title: "注销日期",
          type: "date"
        },
        {
          width: 24,
          dataIndex: "cancelReason",
          title: "注销原因",
          type: "textArea"
        },
        {
          width: 24,
          dataIndex: "revokeDate",
          title: "吊销日期",
          type: "date"
        },
        {
          width: 24,
          dataIndex: "revokeReason",
          title: "吊销原因",
          type: "textArea"
        },
        {
          width: 24,
          dataIndex: "id",
          title: "企业id",
          type: "text"
        },
        {
          width: 24,
          dataIndex: "updateTimes",
          title: "更新时间",
          type: "date"
        },
        {
          width: 24,
          dataIndex: "approvedTime",
          title: "核准时间",
          type: "date"
        },
      ]
    ],
    ICinfo: true,
  }

  componentDidMount() {
    this.setState({
      visible: false,
      list: [],
      value: this.props.value
    })
  }

  componentWillReceiveProps(newProps) {
    if (newProps.value) {
      this.setState({ value: newProps.value })
    }
  }

  showModal = () => {
    if (!this.state.value) {
      Message.info("请输入")
      return
    }
    if (this.basicInfo.thirdParty.aic != "1") {
      Message.info("未配置第三方授权，请前往“平台设置”->“第三方授权”配置")
      return;
    }
    this.setState({
      visible: true
    })
    this.search(this.state.value)
  }
  handleOk = e => {
    this.setState({
      visible: false
    })
  }
  handleCancel = () => {
    this.setState({
      visible: false
    })
  }
  onCancel = val => {
    this.setState({ value: val })
    this.props.onChange(val)
    // this.search(val)
  }
  inputCancel = e => {
    this.setState({ value: e.target.value })
    this.props.onChange(e.target.value)
  }
  search = val => {
    console.log("val", val)
    if (val.length > 1) {
      request("/third/getYonyouAICList", { word: val }).then(res => {
        if (res.result && _.isArray(res.result) && res.result.length > 0) {
          this.setState({
            list: res.result
          })
        } else if (res.result && res.result.code) {
          this.errorHandle(res.result.code)
        }
      })
    }
  }
  debounceSearch = _.debounce(this.search, 500)
  detail(item) {
    const { config } = this.state
    request("/third/getYonyouAICInfo", { name: item.name }).then(res => {
      if (res.result) {
        let detail = res.result;
        let obg = {};
        config[0].forEach(item => {
          if (item.type == 'date') {
            if (detail[item.dataIndex]) {
              obg[item.title] = timestampToTime(detail[item.dataIndex])
            } else {
              obg[item.title] = ''
            }
          } else if (item.type == 'select') {
            if (detail[item.dataIndex]) {
              obg[item.title] = item.source.filter(sourceItem => { return sourceItem.value == detail[item.dataIndex] })[0].label
            } else {
              obg[item.title] = ''
            }
          } else {
            obg[item.title] = detail[item.dataIndex]
          }
        })
        this.setState({
          detail: obg,
          oldDetail: detail
        })
        // onChange(res.result.name, res.result)
        // this.setState({ visible: true })
      }
    })
  }
  errorHandle(code) {
    switch (code) {
      case "300004":
        this.setState({ ICinfo: false })
        this.basicInfo.thirdParty.aic = 0
        localStorage.setItem("basicInfo", JSON.stringify(this.basicInfo))
        break
      default:
        break
    }
  }
  // 获取商户信息在congfig中的字段
  getItem = (list, reMes) => {
    list.forEach(item => {
      if (item.dataIndex == "businessInfo") {
        //商户字段暂存在localStorage中
        window.localStorage.setItem("businessItem", JSON.stringify(item))
      }
      if (Array.isArray(item)) {
        this.getItem(item, reMes)
      }
    })
  }

  fillIn = () => {
    const { detail, config, itemNow, oldDetail } = this.state
    const { onChange, functionCode, form, dispatch } = this.props
    const formConfig = form.get(functionCode).get("config").get("formConfig")
    this.getItem(formConfig)
    // 保存到form的企业信息中
    dispatch({
      type: "form/changeFormData",
      payload: {
        value: JSON.stringify(detail),
        item: JSON.parse(localStorage.businessItem),
        functionCode: functionCode
      }
    })
    onChange(oldDetail.name, oldDetail)
    this.setState({ visible: false })
  }

  showMes(list, obg) {
    let newobg = typeof obg == 'string' ? JSON.parse(obg) : obg
    return (
      <ul style={{ listStyle: "none", width: 400, height: 450, overflow: "hidden auto" }}>
        {list.map((item, index) => {
          return (
            <div key={index} style={{ padding: "5px 0" }}>
              <p
                style={{
                  float: "left",
                  textAlign: "right",
                  fontStyle: "normal",
                  width: 80,
                  marginRight: 10,
                  marginBottom: 0
                }}
              >
                {item}:
              </p>
              <p style={{
                overflow: "hidden",
                minHeight: '18px',
                marginBottom: 0
              }}>{newobg[item]}</p>
            </div>
          )
        })}
      </ul>
    )
  }

  render() {
    const { value, list, config, detail, ICinfo } = this.state
    const { onChange, form, functionCode } = this.props
    const codeMes = form.get(functionCode);
    if (!codeMes) {
      return null;
    }
    const formData = codeMes.get("formData")
    const basicInfo = this.basicInfo
    const options = list.map(d => (
      <Option
        onClick={() => {
          this.detail(d)
        }}
        key={d.name}
      >
        {d.name}
      </Option>
    ))
    const firmMes = formData ? formData.getIn(["cs_customer", "businessInfo"]) : undefined //从form存贮状态中取出用户信息getIn深层不会报错

    let firmMesList
    if (firmMes) {
      //如果有用户信息提取对象的key变成数组可遍历
      firmMesList = Object.keys(JSON.parse(firmMes))
    }

    const content = (
      <div style={{ textAlign: "center", padding: "50px 0", width: 300 }}>
        <h4 style={{ fontSize: 14 }}>暂无企业信息</h4>
        <p>请填写相关名称后，点击工商按钮选择</p>
      </div>
    )

    let content1
    if (firmMes) {
      content1 = this.showMes(firmMesList, firmMes) //有用户信息渲染返回
    }
    if (basicInfo && basicInfo.thirdParty && ICinfo) {
      return (
        <div style={{ flex: '1' }}>
          <div className={"IC"}>
            <Input size="small" value={value} placeholder={"工商搜索"} onChange={this.inputCancel} />
            {/* <Select
            showSearch
            value={value ? value : ''}
            placeholder={'工商搜索'}
            defaultActiveFirstOption={false}
            showArrow={false}
            filterOption={false}
            onSearch={this.debounceSearch}
            onChange={this.onCancel}
            notFoundContent={null}
          >
            {options}
          </Select> */}
            {/* 气泡弹出窗 */}
            <Popover placement="right" title={"企业信息"} content={firmMes ? content1 : content} trigger="hover">
              {/* 有企业信息的图标是蓝色，没有企业信息的图标是红色 */}
              <i onClick={this.showModal} style={{ color: firmMes ? "#1a98f1" : "#F30" }} className="iconfont icon-gongshang"></i>
            </Popover>
          </div>
          <DraggableModal
            title="企业工商"
            visible={this.state.visible}
            onCancel={this.handleCancel}
            width={800}
            onOk={this.fillIn}
            mask={true}
            footer={[
              <Button key="back" onClick={this.handleCancel}>
                取消
              </Button>,
              <Button key="submit" type="primary" onClick={this.fillIn}>
                回填
              </Button>
            ]}
          >
            <Search value={value ? value : ""} placeholder="工商搜索" onChange={this.inputCancel} onSearch={value => this.search(value)} />
            <div className={"ICinfoBlock"}>
              <List
                size="small"
                // header={<div>Header</div>}
                // footer={<div>Footer</div>}
                bordered
                dataSource={list}
                renderItem={item => <List.Item onClick={() => this.detail(item)}>{item.name}</List.Item>}
              />
              {/* <div className={"ICList"}>{detail ? <AutoGenerationDetail source={detail} showAll={true} config={config} /> : <Empty />}</div> */}
              <div className={"ICList"}>{detail ? this.showMes(Object.keys(detail), detail) : <Empty />}</div>
            </div>
          </DraggableModal>
        </div>
      )
    } else {
      return (<Input size="small" value={value} onChange={this.inputCancel} />)
    }
  }
}
