import React, { PureComponent } from 'react';
import classnames from 'classnames';
import './index.less'
import { message } from 'antd';

export default class HeaderSearch extends PureComponent {
  copyEl = React.createRef();

  render() {
    const { children, title, value, wrap, align, wordWrap, style, isNegative, titleWidth } = this.props;
    
    return <div className="keyValuePairedWrapper">
      {/* 增加判断表单字段标题参数设置 */}
      {titleWidth && <span className="keyTitle" style={{width:titleWidth}} title={title}>{title} : </span>}
      {!titleWidth && <span className="keyTitle" title={title}>{title} : </span>}
      {children ? children : (
        <React.Fragment>
          <h4
            className={classnames(wrap ? 'h4_wrap' : 'h4_noWrap', align ? align : '')}
            style={style}
            onDoubleClick={() => {
              const input = document.createElement('input');
              input.style.cssText = 'display: block;opacity: 0;position: absolute;left: -10000px;top: -10000px;z-index: -1;'
              document.body.appendChild(input);
              input.value = value;
              input.select();
              document.execCommand('copy');
              document.body.removeChild(input);
              //2021.1.6去除
              // message.success('复制成功');
            }}
            title={value}>
            <span style={{color:isNegative&&isNegative<0?"#F30":""}}>{value}</span>
          </h4>
        </React.Fragment>
      )}
    </div>
  }
}
