/**
 * Created by 王友生 on 2018-04-17.
 */
import styles from './index.less';
import React, { PureComponent } from 'react';
import { Popover, Tooltip, Icon } from 'antd';
import classnames from 'classnames';

export default class MainMenu extends PureComponent {

  state = {
    visibleKey: ''
  }

  renderMenuPopContent(menuItem, activeKey) {
    if (menuItem.items && menuItem.items.length > 0) {
      return <Popover
        overlayClassName="popover"
        key={menuItem.id}
        visible={menuItem.id == this.state.visibleKey}
        onVisibleChange={(visible) => this.setState({ visibleKey: visible ? menuItem.id : '' })}
        placement="right"
        content={menuItem.items.map((item) => {
          return <div key={item.id} className="subMenu">
            <span className={classnames("title", item.id === activeKey ? "active" : '')}
                  onClick={() => (!item.items || item.items.length === 0) && this.onMenuClick([item.id, menuItem.id])}>{item.menuName}</span>
            {
              item.items && item.items.length > 0 && <div className="content">
                {
                  item.items.map((childItem) => <div key={childItem.id}
                                                     className={childItem.id === activeKey ? "active" : ''}
                                                     onClick={() => this.onMenuClick([childItem.id, item.id, menuItem.id])}>{childItem.menuName}</div>)
                }
              </div>
            }
          </div>
        })}>
        <li className="menuName"><i className={"icon iconfont AntMenuIcon " + menuItem.icon + ' ' + "icon"} />{menuItem.menuName.substring(0, 2)}</li>

          {/*<img style={{ width: '20px', height: '20px', marginRight: '5px' }}*/}
               {/*src={menuItem.icon}*/}
               {/*alt='' />*/}
      </Popover>
    } else {
      return <Tooltip placement="right"
                      key={menuItem.id}
                      title={menuItem.menuName}>
        <li className={classnames("menuName", menuItem.id === activeKey ? "activeMenu" : '')}
            onClick={() => this.onMenuClick([menuItem.id])}><i className={"icon iconfont AntMenuIcon " + menuItem.icon + ' ' + "icon"} />{menuItem.menuName.substring(0, 2)}</li>
          {/*<img style={{ width: '20px', height: '20px', marginRight: '5px' }}*/}
               {/*src={menuItem.icon}*/}
               {/*alt='' />*/}
          {/*<i className={"icon iconfont " + menuItem.icon }></i>*/}

      </Tooltip>
    }
  }

  onMenuClick(keyPath) {
    const { onMenuClick } = this.props;
    this.setState({ visibleKey: '' });
    onMenuClick && onMenuClick(keyPath);
  }

  render() {
    const { menus, activeKey } = this.props;
    if (! menus) return null;
    return <ul className="menu">
      {
        menus && menus.map((menu) => this.renderMenuPopContent(menu, activeKey))
      }
    </ul>
  }
}
