/**
 * Created by 王友生 on 2018-04-23.
 */
import styles from './index.less';
import React, { PureComponent } from 'react';
import AutoGenerationForm from '../../components/AutoGenerationForm';
import {
  formFieldType, referenceStyleType, referenceStyleFormStyleMapping,
  defaultValueTypeConst, loginParamsConst, workflowNodeType, groupType, dataIndexType
} from '../../common/const';
import { translateObjectToList, fastDate } from '../../utils';
import { Button, Modal, Tabs, Icon } from 'antd';
import ReferenceConfig from '../ReferenceConfig';
import DraggableModal from "../DraggableModal";
import { quickButtons as dateButton } from '../../utils/quick-button'
import zh from '../../locale/zh_CN'
import _ from 'lodash'

const { TabPane } = Tabs;
//1.30日期区间翻译
let quickButtons = _.cloneDeep(dateButton)
quickButtons.map(item => {
  item.label = zh[item.label]
})
// showType=表单:1	列表:2	子表:3	查询条件:4

export default class NodeProps extends PureComponent {
  formConfig = [[{
    dataIndex: 'title',
    title: '名称',
    type: 'text',
    required: '1',
    showType: '1234'
  }, {
    dataIndex: 'titleEN',
    title: '名称EN',
    type: 'text',
    showType: '1234'
  }, {
    dataIndex: 'tableName',
    title: '表名',
    type: 'select',
    required: '1',
    source: [],
    field: {
      label: 'tableDesc',
      value: 'tableName',
      title: 'tableName'
    },
    showType: '1234'
  }, {
    dataIndex: 'dataIndex',
    title: '字段',
    type: 'select',
    required: '1',
    source: [],
    field: {
      label: 'fieldDesc',
      value: 'field',
      title: 'field'
    },
    showType: '1234'
  }, {
    dataIndex: 'type',
    title: '类型',
    type: 'treeSelect',
    required: '1',
    field: {
      value: 'value',
      label: 'label',
      pid: 'pid',
    },
    source: translateObjectToList(formFieldType),
    showType: '1234'
  }, {
    dataIndex: 'employeeSupport',
    title: '支持类型',
    type: 'tags',
    hide: '1',
    source: [workflowNodeType.corporation, workflowNodeType.department, workflowNodeType.post, workflowNodeType.duties, workflowNodeType.role, workflowNodeType.allDepartment, workflowNodeType.allCorpration],
    showType: '1234'
  }, {
    dataIndex: 'customReferenceKey',
    title: '自定义弹窗',
    type: 'text',
    hide: '1'
  }, {
    dataIndex: 'help',
    title: '帮助',
    type: 'text',
    showType: '1'
  }, {
    dataIndex: 'placeholder',
    title: '提示',
    type: 'text',
    showType: '13'
  }, {
    dataIndex: 'required',
    title: '必填',
    type: 'checkbox',
    width: 12,
    showType: '1234',
    disabled: false,
  }, {
    dataIndex: 'fieldMonitor',
    title: '变更记录',
    type: 'checkbox',
    width: 12,
    showType: '13',
    disabled: false,
  }, {
    dataIndex: 'showStage',
    title: '作为阶段显示',
    type: 'checkbox',
    width: 12,
    showType: '124'
  }, {
    dataIndex: 'listCanChange',
    title: '列表可修改',
    type: 'checkbox',
    width: 12,
    showType: '2'
  }, {
    dataIndex: 'productDev',
    title: '产品',
    help: '勾上此条件，用户无法修改',
    type: 'checkbox',
    width: 12,
    showType: '13'
  }, {
    dataIndex: 'disabled',
    title: '只读',
    type: 'checkbox',
    width: 12,
    showType: '134'
  }, {
    dataIndex: 'hide',
    title: '隐藏字段',
    type: 'checkbox',
    width: 12,
    showType: '1234',
    disabled: false,
  }, {
    dataIndex: 'hideInEdit',
    title: '编辑隐藏',
    type: 'checkbox',
    width: 12,
    showType: '13'
  }, {
    dataIndex: 'forbidEdit',
    title: '禁止修改',
    type: 'checkbox',
    help: '勾上此条件，创建的时候可以填写，禁止修改',
    width: 12,
    showType: '13'
  }, {
    dataIndex: 'mobileHide',
    title: '手机隐藏',
    type: 'checkbox',
    width: 12,
    showType: '123'
  }, {
    dataIndex: 'mainScenario',
    title: '分类视图',
    type: 'checkbox',
    width: 12,
    showType: '4'
  }, {
    dataIndex: 'masterField',
    title: '主表合计',
    type: 'checkbox',
    width: 12,
    showType: '2'
  }, {
    dataIndex: 'sumChildField',
    title: '子表合计',
    type: 'checkbox',
    width: 12,
    showType: '3'
  },
  // {
  //   dataIndex: 'sortField',
  //   title: '子表排序',
  //   type: 'checkbox',
  //   width: 12,
  //   showType: '3'
  // },
  {
    dataIndex: 'defaultHide',
    title: '默认隐藏',
    type: 'checkbox',
    help: '勾上此条件，快捷查询，列表中都不显示',
    width: 12,
    showType: '4'
  }, {
    dataIndex: 'group',
    title: '列合并',
    type: 'checkbox',
    width: 12,
    showType: '3'
  }, {
    dataIndex: 'groupMain',
    title: '主合并字段',
    type: 'checkbox',
    width: 12,
    showType: '3'
  },{
    dataIndex: 'sorter',
    title: '支持排序',
    type: 'checkboxBool',
    help: '仅列表有效',
    width: 12,
    showType: '2'
  }, {
    dataIndex: 'correcting',
    title: '数据批改',
    type: 'checkboxBool',
    help: '仅表单主表字段有效',
    width: 12,
    showType: '1'
  }, {
    dataIndex: 'supportFilter',
    title: '支持筛选',
    type: 'checkboxBool',
    width: 12,
    showType: '2'
  }, {
    dataIndex: 'detailQuick',
    title: '详情快速切换',
    help: '详情中字段会单独显示且可快速进行切换',
    type: 'checkboxBool',
    width: 12,
    showType: '1'
  },
  {
    dataIndex: 'organization',
    title: '组织结构图',
    help: '详情弹出组织结构树',
    type: 'checkboxBool',
    width: 12,
    showType: '1'
  },
  {
    dataIndex: 'organizationUrl',
    title: '组织结构图URL',
    help: '后台接口',
    type: 'text',
    width: 24,
    showType: '1'
  },
  {
    dataIndex: 'defaultValueType',
    title: '默认值类型',
    type: 'radio',
    source: translateObjectToList(defaultValueTypeConst),
    showType: '1234'
  }, {
    dataIndex: 'defaultValue',
    title: '默 认 值',
    type: 'text',
    showType: '1234'
  }, {
    dataIndex: 'showPermission',
    title: '隐藏权限',
    type: 'employeeSelector',
    employeeSupport: workflowNodeType.role.value,
    showType: '13'
  }
    , {
    dataIndex: 'editPermission',
    title: '禁止修改权限',
    type: 'employeeSelector',
    employeeSupport: workflowNodeType.role.value,
    showType: '13'
  }, {
    dataIndex: 'pattern',
    title: '正则校验',
    type: 'text',
    placeholder: '正则表达式校验',
    help: '例:/^([a-zA-Z\d])(\w|\-)+@[a-zA-Z\d]+\.[a-zA-Z]{2,4}$/',
    showType: '13'
  }, {
    dataIndex: 'errMsg',
    title: '错误提示',
    type: 'text',
    placeholder: '验证通过时提示信息',
    showType: '13'
  },
  {
    dataIndex: 'width',
    title: '字段宽度',
    type: 'number',
    defaultValue: '6',
    help: '采用24栅格',
    showType: '1234'
  },
  {
    dataIndex: 'titleWidth',
    title: '字段标题宽度',
    type: 'number',
    defaultValue: '110',
    help: '像素',
    showType: '14'
  },
  {
    dataIndex: 'align',
    title: '对齐方式',
    type: 'select',
    source: [
      {
        label: '左对齐',
        value: 'left'
      }, {
        label: '居中对齐',
        value: 'center'
      }, {
        label: '右对齐',
        value: 'right'
      }
    ],
    showType: '1234'
  }, {
    dataIndex: 'fixed',
    title: '冻结列',
    type: 'radio',
    source: [{
      label: 'none',
      value: 'none'
    }, {
      label: 'left',
      value: 'left'
    }, {
      label: 'right',
      value: 'right'
    }]
  }, {
    dataIndex: 'wildcard',
    title: '通配符',
    type: 'radio',
    help: '仅列表文本查询条件有效',
    source: [{
      label: '%左右%',
      value: 'both'
    }, {
      label: '%左',
      value: 'left'
    }, {
      label: '右%',
      value: 'right'
    }, {
      label: '等于',
      value: 'equal'
    }]
  }, {
    dataIndex: 'treeExpand',
    title: '树展开',
    type: 'radio',
    help: '仅树选择有效',
    source: [{
      label: '不展开',
      value: 'notOpen'
    }, {
      label: '展开一级',
      value: 'openFirst'
    }, {
      label: '展开末级',
      value: 'openEnd'
    }],
    showType: '1234'
  }]];

  formDicConfig = [[
    {
      dataIndex: 'sourceKey',
      title: '字典',
      type: 'select',
      field: {
        value: 'dicNo',
        label: 'dicNoName'
      },
      titleWidth: 70
    }, {
      dataIndex: 'dicPermission',
      title: '字典配置权限',
      type: 'employeeSelector',
      hide: '1',
      titleWidth: 70,
      employeeSupport: workflowNodeType.role.value
    }, {
      dataIndex: 'referenceKey',
      title: '参照',
      type: 'treeSelect',
      titleWidth: 70,
      field: {
        value: 'id',
        label: 'refName',
        pid: 'pid'
      }
    }, {
      dataIndex: 'referenceField',
      title: '参照字段',
      titleWidth: 70,
      type: 'select',
      disabled: '1',
      source: []
    }, {
      dataIndex: 'referenceDisplayField',
      title: '显示字段',
      titleWidth: 70,
      type: 'select',
      disabled: '1',
      hide: '1',
      source: []
    }, {
      dataIndex: 'triggerReference',
      title: '触发参照',
      titleWidth: 70,
      type: 'checkbox',
      width: 10
    }, {
      dataIndex: 'referenceRefresh',
      title: '支持刷新',
      titleWidth: 70,
      type: 'checkbox',
      width: 10
    }, {
      dataIndex: 'referenceConditions',
      title: '参照条件',
      type: 'checkbox',
      titleWidth: 70,
      width: 10,
      renderFunc: () => <Button icon="plus" size="small"
        onClick={() => this.setState({ referenceVisible: true })}></Button>
    }
  ]]

  formEventConfig = [[
    // {
    //   dataIndex: 'eventType',
    //   title: '事件类型',
    //   type: 'select',
    //   source: translateObjectToList(itemEventTypeConst)
    // },
    {
      dataIndex: 'eventFunctionCode',
      title: '关联功能',
      type: 'text'
    },
    {
      dataIndex: 'documentContentFunCode',
      title: '单据内功能码',
      type: 'checkbox'
    },
    {
      dataIndex: 'eventTableName',
      title: '关联表名',
      type: 'select',
      source: [],
      field: {
        label: 'tableDesc',
        value: 'tableName',
        title: 'tableName'
      }
    }, {
      dataIndex: 'eventDataIndex',
      title: '关联字段',
      type: 'select',
      source: [],
      field: {
        label: 'fieldDesc',
        value: 'field',
        title: 'field'
      }
    }
  ]];

  extraConfig = [[
    {
      dataIndex: 'wfNode',
      title: '流程节点',
      type: 'checkbox',
    },
    {
      dataIndex: 'wfCon',
      title: '流程条件',
      type: 'checkbox',
    }
  ]];

  constructor(props) {
    super(props);
    // console.log('props.node', props.node.toJSON());
    this.editConfig(props.node)
    if(props.childrenMesSave && Object.keys(props.childrenMesSave.rightMes).length>0){
      this.state = { ...props.childrenMesSave.rightMes }
    }else{
      this.state = { activeTab:"1", values: props.node, referenceVisible: false, showPermissionVisible: false };
    }
  }

  componentDidMount() {
    this.props.getRequired && this.props.getRequired(this.formConfig)
  }

  componentWillReceiveProps(newProps) {
    if (newProps.node !== this.props.node) {
      this.editConfig(newProps.node)
      this.setState({ values: newProps.node }, () => {
        let { values } = this.state;
        if (!newProps.node.get("dataIndex")) {
          values = values.set("sorter", true)
          this.setState({ values })
        }
      }
      )
    }
  }
  editConfig(node) {
    //console.log('478-node',node,typeof node,node && node.toJS());
    if (node) {
      this.formConfig[0].map(item => {
        if (item.showType && node.get('dataIndexType')) {
          item.hide = item.showType.indexOf(node.get('dataIndexType')) == -1 ? '1' : 0
        }
      })
    }
  }

  onItemValueChange(value, dataIndex) {
    let { values } = this.state;
    let { referencesObj, references } = this.props
    values = values.set(dataIndex, value);
    if (dataIndex === 'tableName') {
      //这里只取主表和关系表(relationTables)的话,选子表的信息没有被记录,所以需要取全部表
      let table;
      //console.log(495,this.props.tables,this.props.relationTables);
      if (this.props.tables) {
        table = this.props.tables.filter(x => x.tableName === value);//新增的
      } else if (this.props.relationTables) {
        table = this.props.relationTables.filter(x => x.tableName === value);//原本的
      }
      if (table && table.length > 0) {
        values = values.set('tableType', table[0].tableType);
      }
      // values = values.set('dataIndex', '');
    } else if (dataIndex === 'referenceKey') {
      values = values.set('referenceField', '');
      const filteredReference = this.props.references.filter(x => x.id === value) || [];
      const reference = this.getReference(value);
      if (reference && reference.filter) {
        values = values.set('filter', reference.filter);
      } else {
        values = values.delete('filter');
      }

      if (filteredReference.length > 0) {
        const refType = filteredReference[0].refType;
        values = values.set('type', referenceStyleFormStyleMapping[refType]);
        if (referenceStyleType.select.value === refType || referenceStyleType.treeSelect.value === refType) {
          values = values.set('triggerReference', '1');
        }
      }
    } else if (dataIndex === 'defaultValueType') {
      values = values.set('defaultValue', '');
    } else if (dataIndex === 'type' && value === formFieldType.employeeSelector.value) {
      values = values.set('employeeSupport', `${workflowNodeType.corporation.value},${workflowNodeType.department.value},${workflowNodeType.post.value},${workflowNodeType.duties.value}`)
    } else if (dataIndex === 'type') {//树参照默认referenceField
      if (value == 'popupTreeSelect') {
        values = values.set('referenceField', referencesObj[values.get('referenceKey')].field.label)
      }
    }
    if (dataIndex === 'fixed' && this.props.onNodeFixedChange) {
      this.props.onNodeFixedChange(values);
    } else {
      this.props.onNodeChange(values);
    }

    if (dataIndex == "type" && (value == "amount" || value == "number")) {
      values = values.set('align', 'right');
    }

    this.setState({ values });
  }

  getReference(referenceKey) {
    let { references, referencesObj, fetchReference, values } = this.props;
    const referenceSource = referencesObj[referenceKey];
    if (referenceSource) {
      return referenceSource;
    } else {
      const filteredReference = references.filter(x => x.id === referenceKey) || [];
      if (filteredReference.length > 0) {
        fetchReference(referenceKey);
      }
    }
  }

  changeTab(e){
    this.setState({
      activeTab:e
    },()=>{
      // this.props.changTabState(this.state);
    })
  }

  render() {
    const {
      tables,
      tableProps,
      dictionary,
      relationTables,
      showPermissionVisible,
      references,
      referencesObj,
      fetchReference,
      mode,
      showDisplayReference,
      productDev,
      formSource, currentConfigType
    } = this.props;
    let { values, referenceVisible } = this.state;
    if (!values) return null;
    const extraConfig = {};


    if (tables) {
      if (this.state.values.get('groupType') === groupType.table) {
        extraConfig.tableName = {
          // disabled: true,
          source: tables
        }
        extraConfig.eventTableName = {
          // disabled: true,
          source: tables
        }
        extraConfig['wildcard'] = { hide: '1' }
      } else {
        extraConfig['tableName'] = { source: tables }
        extraConfig['eventTableName'] = { source: tables }
        extraConfig['fixed'] = { hide: '1' }
        if (values.get('type') !== formFieldType.text.value) {
          extraConfig['wildcard'] = { hide: '1' }
        }
      }
      if (values.get('tableName')) {
        //2022-04-13 10:29:13 主表已用字段disabled
        let source = _.cloneDeep(tableProps[values.get('tableName')]) || []
        let fieldArr = []
        if (currentConfigType == "form" && formSource && formSource.length > 0) {
          formSource.map(item => {
            if (item.groupType == "part") {
              item.children.map(itemChild => {
                fieldArr.push(itemChild.dataIndex)
              })
            }
          })
          source.map(item => {
            let filter = fieldArr.filter(itemChild => item.field == itemChild)
            item.disabled = filter.length > 0 ? true : false
          })
        }
        extraConfig['dataIndex'] = { source };
      }
      if (values.get('eventTableName')) {
        extraConfig['eventDataIndex'] = { source: tableProps[values.get('eventTableName')] || [] };
      }
    } else {
      extraConfig['referenceConditions'] = { hide: '1' };
    }

    if (values.get('sourceKey')) {
      extraConfig['dicPermission'] = { hide: '0' };
    } else {
      extraConfig['dicPermission'] = { hide: '1' };
    }

    if (this.state.values.get('groupType') === groupType.table) {
      extraConfig.width = {
        extraProps: {
          min: 20
        }
      }
    } else if (this.state.values.get('groupType') === groupType.part) {
      extraConfig.width = {
        extraProps: {
          min: 1
        }
      }
    }

    if (mode === 'free') {
      extraConfig.tableName = {
        hide: '1',
        source: []
      }
      extraConfig.eventTableName = {
        hide: '1',
        source: []
      }
      extraConfig['dataIndex'] = { type: 'text' };
      extraConfig['eventDataIndex'] = { type: 'text' };
    }

    // else {
    //   extraConfig.tableName = {
    //       hide: '1',
    //       source: []
    //     }
    //   extraConfig['dataIndex'] = { type: 'text' };
    //   extraConfig['referenceConditions'] = { hide: '1' };
    // }

    extraConfig['sourceKey'] = { source: dictionary || [] };
    extraConfig['referenceKey'] = { source: references || [] };
    if (values.get('referenceKey')) {
      const reference = this.getReference(values.get('referenceKey'));

      if (reference) {
        extraConfig['referenceField'] = { source: reference['nodes'], disabled: reference['nodes'].length === 0 };
        extraConfig['referenceDisplayField'] = {
          source: reference['nodes'],
          disabled: reference['nodes'].length === 0,
          hide: showDisplayReference ? '0' : '1'
        };
      } else {
        extraConfig['referenceField'] = { source: [], disabled: true };
        extraConfig['referenceDisplayField'] = { source: [], hide: '1' };
      }
    }

    extraConfig['employeeSupport'] = { hide: values.get('type') === formFieldType.employeeSelector.value ? '0' : '1' };
    extraConfig['customReferenceKey'] = { hide: values.get('type') === formFieldType.customPopup.value ? '0' : '1' };

    if (values.get('defaultValueType') === defaultValueTypeConst.loginParams.value) {
      extraConfig['defaultValue'] = { source: translateObjectToList(loginParamsConst), type: 'select' };
    }

    if (values.get('defaultValueType') === defaultValueTypeConst.customDateRange.value) {
      extraConfig['defaultValue'] = { source: quickButtons, type: 'select' }
    }
    //2021-10-14 16:57:20:快捷日期
    if (values.get('defaultValueType') === defaultValueTypeConst.fastDate.value) {
      extraConfig['defaultValue'] = { source: fastDate, type: 'select' }
    }

    if (values.get('defaultValueType') === defaultValueTypeConst.time.value
      || values.get('defaultValueType') === defaultValueTypeConst.date.value
      || values.get('defaultValueType') === defaultValueTypeConst.month.value) {
      extraConfig['defaultValue'] = { help: '请填写时间offset，例如0表示当前时间，3表示三天后，-3表示三天前', type: 'number' };
    }
    //客开只读11
    const client = ['tableName', 'dataIndex', 'type', 'productDev', 'defaultValue'];
    if (values.get('productDev') && !productDev) {
      client.map(item => {
        this.formConfig[0].map((formItem, formIdx) => {
          if (formItem.dataIndex == item) {
            formItem.disabled = true
          }
        })
      })
    }

    if (values.get('required') === '1') {
      this.formConfig[0].forEach(item => {
        if (item.dataIndex == 'hide') {
          item.disabled = true
        }
      })
    } else {
      this.formConfig[0].forEach(item => {
        if (item.dataIndex == 'hide') {
          item.disabled = false
        }
      })
    }

    if (values.get('hide') === '1') {
      this.formConfig[0].forEach(item => {
        if (item.dataIndex === 'required') {
          item.disabled = true
        }
      })
    } else {
      this.formConfig[0].forEach(item => {
        if (item.dataIndex === 'required') {
          item.disabled = false
        }
      })
    }

    


    return <div style={{ paddingLeft: '10px' }}>
      <Tabs activeKey={this.state.activeTab} className="nodeTabs" onChange={(e)=>this.changeTab(e)}>
        <TabPane tab="基础" key="1">
          <AutoGenerationForm
            layout={{ md: 24 }}
            config={this.formConfig}
            source={values}
            fromPage={{ type: "modeling" }}
            extraConfig={extraConfig}
            onSubmitForm={() => this.props.submitConfig()}
            onItemValueChange={(value, dataIndex) => {
              this.onItemValueChange(value, dataIndex)
            }} />
        </TabPane>
        <TabPane tab="字典参照" key="2">
          <AutoGenerationForm
            layout={{ md: 24 }}
            config={this.formDicConfig}
            source={values}
            extraConfig={extraConfig}
            onSubmitForm={() => this.props.submitConfig()}
            onItemValueChange={(value, dataIndex) => this.onItemValueChange(value, dataIndex)} />
          {
            tables && <DraggableModal
              title="参照配置"
              width={800}
              destroyOnClose
              visible={referenceVisible}
              onCancel={() => this.setState({ referenceVisible: false })}
              onOk={() => this.setState({ referenceVisible: false })}
              bodyStyle={{ padding: '0 24px', height: '400px', overflow: 'auto' }}>
              <ReferenceConfig
                item={values}
                tables={tables}
                references={references}
                referencesObj={referencesObj}
                fetchReference={(key) => fetchReference(key)}
                tableProps={tableProps}
                onReferenceListChange={(newValues) => {
                  this.setState({ values: newValues })
                  this.props.onNodeChange(newValues);
                }} />
            </DraggableModal>
          }
        </TabPane>
        <TabPane tab="事件" key="3">
          <AutoGenerationForm
            layout={{ md: 24 }}
            config={this.formEventConfig}
            source={values}
            extraConfig={extraConfig}
            onSubmitForm={() => this.props.submitConfig()}
            onItemValueChange={(value, dataIndex) => this.onItemValueChange(value, dataIndex)} />
        </TabPane>
        <TabPane tab="其他" key="4">
          <AutoGenerationForm
            layout={{ md: 24 }}
            config={this.extraConfig}
            source={values}
            extraConfig={extraConfig}
            onSubmitForm={() => this.props.submitConfig()}
            onItemValueChange={(value, dataIndex) => this.onItemValueChange(value, dataIndex)} />
        </TabPane>
      </Tabs>
    </div>
  }
}
