import styles from './index.less';
import React, { PureComponent } from 'react';
import { Button, Input } from 'antd';

export default class PurchaseCount extends PureComponent {

	constructor(props) {
		super(props);

		this.state = {
			value: props.min || props.defaultValue || 0
		}
	}

	componentWillReceiveProps(newProps) {
		if (this.props.value !== newProps.value) {
			this.setState({ value: newProps.value });
		}
	}

	minus() {
		let { value } = this.state;
		const { min, onChange } = this.props;
		value --;
		value = Math.max(0, value);
		if (min) {
			value = Math.max(min, value);
		}
		this.setState({ value });
    onChange && onChange(value);
	}

	plus() {
		let { value } = this.state;
		const { max, onChange } = this.props;
		value ++;
		if (max) {
			value = Math.min(max, value);
		}
		this.setState({ value });
    onChange && onChange(value);
	}

	onCountChange(value) {
		const { max, min, onChange } = this.props;
		if (max) {
			value = Math.min(value, max);
		}
		if (min) {
			value = Math.max(value, min);
		}
		this.setState({ value });
    onChange && onChange(value);
	}

	render () {
		const { value } = this.state;

		return <Button.Group size="small" className="purchaseCount">
			<Button icon="minus" onClick={() => this.minus()}></Button>
			<Input value={value} onChange={(e) => this.setState({ value: e.target.value })} onBlur={(e) => this.onCountChange(e.target.value)} />
			<Button icon="plus" onClick={() => this.plus()} style={{ marginLeft: '50px' }}></Button>
		</Button.Group>
	}
}
