/**
 * Created by 王友生 on 2018-04-03.
 */

import "./index.less"
import { connect } from "react-redux"
import React, { PureComponent } from "react"
import { Row, Col, Modal, Icon,message } from "antd"
import QueueAnim from "rc-queue-anim"
import CustomTree from "../CustomTree"
import classnames from "classnames"
import EllipsisText from "../EllipsisText"
import _ from "lodash"

@connect(state => {
  const lang = state.get("system").get("lang")
  const system = state.get('system');
  return {
    originalMenu: system.get('originalMenu'),
    lang
  }
})
export default class QuickPanel extends PureComponent {
  state = {
    showQuickPanel: true,
    editVisible: false,
    checkedMenuItems: [],
    draggedIndex: -1,
    overIndex: -1,
    checkedKeys: []
  }
  componentDidMount() {
    const checkedKeys = Array.from(this.props.config, item => item.id)
    this.setState({ checkedMenuItems: this.props.config, checkedKeys })
  }
  componentWillReceiveProps(newProps) {
    if (newProps.config !== this.props.config) {
      const checkedKeys = Array.from(newProps.config, item => item.id)
      this.setState({ checkedMenuItems: newProps.config, checkedKeys })
    }
  }

  // 新建功能快捷方式
  tiaozhuan(item) {
    const { dispatch, originalMenu } = this.props
    let functionCode = item.functionCode
    try {
      const menu = originalMenu[functionCode]
      if (!menu) {
        message.error("无权限访问或页面不存在!")
        return
      }
    } catch (e) {
      message.error("无权限访问或页面不存在!")
    }
    dispatch({
      type: "system/jumpToEditPage",
      payload: "-1",
      functionCode: item.functionCode
    })
  }

  checkOutParentNode(list) {
    let newList = _.cloneDeep(list);

    let rnewlist = newList.filter(el => (!el.children || (el.children && el.children.length < 0 || el.children && el.children.length == 0)));
    return rnewlist
  }

  render() {
    const { menuList, saveQuickPanel, lang, config: quickMenus, funCode: functionCodeType } = this.props
    const { checkedMenuItems, draggedIndex, overIndex, editVisible, checkedKeys, showQuickPanel } = this.state
    // 末级pid出现,拼接
    let deepMenu = _.cloneDeep(menuList)
    deepMenu.map(item => {
      delete item.items
      // 菜单没有pid导致的白屏
      try {
        item.pid = item.pid.split(",")[0]
      } catch (e) {
        console.log(item.name, "没有配置父级节点")
      }
    })
    return (
      <div>
        {/* <div
          className="quickContainer"
          onMouseEnter={() => {
            this.enterQuickPanel = true
            this.setState({ showQuickPanel: true })
          }}
          onMouseLeave={() => {
            this.enterQuickPanel = false
            setTimeout(() => {
              if (!this.enterQuickPanel) {
                this.setState({ showQuickPanel: false })
              }
            }, 300)
          }}
        >
          {this.props.children || "快捷操作"}
          {showQuickPanel && ( */}
        <div className="quickPanel">
          <Row gutter={12}>
            <h3>
              <span>新增</span>
            </h3>
            {/* <QueueAnim> */}
            <div className="newAllBox">
              {quickMenus &&
                quickMenus.map((item, index) => {
                  if (item.items && item.items.length > 0) {
                    return null
                  } else if (item.children && item.children.length > 0) {
                    return null
                  } else if (item.funType === functionCodeType.list.value) {
                    return (
                      // <li key={index} title={`新建${lang === 'en' ? item.nameEN : item.name}`} onClick={() =>this.tiaozhuan(item)}>
                      //   <div>
                      //     <a rel="noopener noreferrer" href="#" ><i className='icon iconfont icon-plus-add'></i></a>
                      //     <span>{lang === 'en' ? item.nameEN : item.name}</span>
                      //   </div>
                      // </li>
                      <div
                        key={index}
                        title={`${lang === "en" ? item.nameEN : item.name}`}
                        onClick={() => this.tiaozhuan(item)}
                        className="newBox"
                      >
                        <Icon type="plus-circle" />
                        {lang === "en" ? item.nameEN : item.name}
                      </div>
                    )
                  }
                  return null
                })}
            </div>
            {/* </QueueAnim> */}
            <h3>
              <span>快捷操作</span>
            </h3>
            {/* <QueueAnim> */}
            {this.props.config &&
              this.props.config.map((item, index) => {
                if (item.children) {
                  return null
                }
                return (
                  <div
                    className="quickBox"
                    key={index}
                    onClick={() => {
                      this.setState({ showQuickPanel: false })
                      this.props.onItemClick && this.props.onItemClick(item)
                    }}
                  >
                    <EllipsisText>{lang === "en" ? item.nameEN : item.name}</EllipsisText>
                  </div>
                )
                // <Col lg={6}
                //   title={lang === 'en' ? item.nameEN : item.name}
                //   key={index}
                //   onClick={() => {
                //     this.setState({ showQuickPanel: false });
                //     this.props.onItemClick && this.props.onItemClick(item)
                //   }
                //   }>
                //   <div className="itemWrapper">
                //     {item.icon ? <div><i className={"icon iconfont " + item.icon}></i></div> : <Icon className="icon" type="file" />}
                //     <EllipsisText>{lang === 'en' ? item.nameEN : item.name}</EllipsisText>
                //   </div>
                // </Col>
              })}

            {/* <Col lg={6}
                  title="快捷设置"
                  key='setting'
                  onClick={() => {
                    this.setState({ editVisible: true })
                  }}>
                  <div className="itemWrapper">
                    <div><i className={"icon iconfont icon-edit"}></i></div>
                    <EllipsisText>快捷设置</EllipsisText>
                  </div>
                </Col> */}
            <div
              style={{ color: "#F30" }}
              onClick={() => {
                this.setState({ editVisible: true })
              }}
              className="quickBox"
            >
              <EllipsisText>快捷设置</EllipsisText>
            </div>
            {/* </QueueAnim> */}
          </Row>
        </div>
        {/* )}
        </div> */}

        {/* 快捷操作弹出层 */}
        <Modal
          title={<div className="popTitle">快捷操作配置</div>}
          visible={editVisible}
          className="popUp"
          onOk={() => {
            saveQuickPanel && saveQuickPanel(checkedMenuItems)
            this.setState({ editVisible: false })
          }}
          onCancel={() => this.setState({ editVisible: false })}
          width={800}
          bodyStyle={{ padding: "0 24px", height: "400px", overflow: "auto" }}
        >
          <div className="settingPanel">
            <div className="treeWrapper">
              <CustomTree
                checkedKeys={checkedKeys}
                onCheck={checkedMenuItems => {
                  this.setState({ checkedMenuItems })
                }}
                hidden={'ynHidden'}
                data={deepMenu || []}
                treeField={{ id: "id", name: "menuName", pid: "pid" }}
              />
            </div>
            <div className="settingContent">
              <Row gutter={6}>
                {this.checkOutParentNode(checkedMenuItems).map((item, index) => {
                  return (
                    <Col
                      lg={6}
                      key={index}
                      draggable
                      onDragStart={e => {
                        e.stopPropagation()
                        this.setState({ draggedIndex: index })
                      }}
                      onDragOver={e => {
                        e.stopPropagation()
                        draggedIndex !== index && overIndex !== index && this.setState({ overIndex: index })
                      }}
                      onDragEnd={e => {
                        e.stopPropagation()
                        const dragged = checkedMenuItems[draggedIndex]
                        checkedMenuItems.splice(draggedIndex, 1)
                        checkedMenuItems.splice(overIndex, 0, dragged)
                        this.setState({ overIndex: -1, draggedIndex: -1 })
                      }}
                    >
                      <div className={classnames("checkedItemWrapper", index === overIndex ? "over" : "")}>
                        <span>{lang === "en" ? item.nameEN : item.name}</span>
                      </div>
                    </Col>
                  )
                })}
              </Row>
            </div>
          </div>
        </Modal>
      </div>
    )
  }
}
