/**
 * Created by 王友生 on 2018-12-18.
 */

import './index.less';
import React from 'react';
import { Resizable } from 'react-resizable';

const ResizeableTitle = (props) => {
  const { onResize, width, fixed, ...restProps } = props;
  if (!width || !onResize) {
    return <th {...restProps} />;
  }

  return (
    <Resizable width={width} height={0} onResize={onResize}>
      <th {...restProps} />
    </Resizable>
  );
};

export default ResizeableTitle;
