/**
 * Created by 王友生 on 2018-12-13.
 */
import "./index.less"
import { Map, fromJS } from "immutable"
import React, { PureComponent } from "react"
import DragSortTable from "../DragSortTable"
import DraggableModal from "../DraggableModal"
import { Tabs, Checkbox, Radio, Tooltip, Modal, Button, message, Select } from "antd"
import { connect } from "react-redux"
import { FormattedMessage, injectIntl } from "react-intl"
import AutogenerationForm from "../AutoGenerationForm"
import { wfConditionConst } from "./../../common/const"
import _ from "lodash"

const { Option } = Select
@connect(state => {
  const lang = state.get("system").get("lang")
  return {
    lang
  }
})
export default class SearchScenarioConfig extends PureComponent {
  // FIXME:state数据内容
  state = {
    activeTabKey: "1",
    isAnd: true,
    shanchu: "",
    freeCombinationList: [
      { title: "", dataIndex: "", type: "", tiaojian: "", tjtitle: "", tiaojianMes: [], tiaojianMesData: {}, tiaojianObg: "" }
    ]
  }

  searchColumns = [
    {
      title: <FormattedMessage id="locale_name" />,
      dataIndex: "title"
    },
    {
      title: <FormattedMessage id="locale_QuickShow" />,
      dataIndex: "defaultHide",
      render: (text, record) => {
        return <Checkbox defaultChecked={text !== "1"} onChange={e => (record["defaultHide"] = `${1 - (parseInt(text) || 0)}`)} />
      }
    }
  ]

  tableColumns = [
    {
      title: <FormattedMessage id="locale_name" />,
      dataIndex: "title"
    },
    {
      title: <FormattedMessage id="locale_freeze" />,
      dataIndex: "fixed",
      render: (text, record) => {
        return (
          <Radio.Group onChange={e => (record["fixed"] = e.target.value)} defaultValue={text || ""}>
            <Radio value="">
              <FormattedMessage id="locale_none" />
            </Radio>
            <Radio value="left">
              <FormattedMessage id="locale_left" />
            </Radio>
            <Radio value="right">
              <FormattedMessage id="locale_right" />
            </Radio>
          </Radio.Group>
        )
      }
    },
    {
      title: <FormattedMessage id="locale_show" />,
      dataIndex: "defaultHide",
      render: (text, record) => {
        return <Checkbox defaultChecked={text !== "1"} onChange={e => (record["defaultHide"] = `${1 - (parseInt(text) || 0)}`)} />
      }
    }
  ]

  // tableColumns = [{
  //   title: '名称',
  //   dataIndex: 'title',
  // }, {
  //   title: '显示',
  //   dataIndex: 'defaultHide',
  //   render: (text, record) => {
  //     return <Checkbox defaultChecked={text !== '1'} onChange={(e) => record['defaultHide'] = `${1 - (parseInt(text) || 0)}`} />
  //   }
  // }]

  // TODO:点击搜索确定后判断Tab选中的哪一项
  onOk() {
    const { onClose, search, changeSearchConfig, searchConfig, searchScenario, changeTableConfig, tableConfig } = this.props
    const { activeTabKey, freeCombinationList } = this.state

    if (activeTabKey === "1") {
      let noPdList = freeCombinationList.filter(
        el => (el.tiaojian == "" || el.tiaojian == undefined || el.tiaojian == null) && el.type != "dateRange"
      )
      if (noPdList.length > 0) {
        message.error("条件有未选择的判断符，请选择判断符后再次搜素")
        return
      }
      search && search(freeCombinationList)

    } else if (activeTabKey === "2") {
      
      changeSearchConfig &&
        changeSearchConfig(
          this.newSortSearchData || (searchConfig && searchConfig.length > 0 ? searchConfig[0].filter(x => x.hide !== "1") : [])
        )
    } else if (activeTabKey === "3") {
      changeTableConfig && changeTableConfig(this.newTableConfig || tableConfig)
    }
    this.setState({
      activeTabKey: "1"
    })
    onClose && onClose()
  }

  // TODO:删除整个条件组
  dropGroup() {
    const setKong = () => {
      this.setState({
        freeCombinationList: [
          { title: "", dataIndex: "", type: "", tiaojian: "", tjtitle: "", tiaojianMes: [], tiaojianMesData: {}, tiaojianObg: "" }
        ]
      })
    }
    Modal.confirm({
      title: "确定删除整个条件组？",
      onOk() {
        setKong()
      }
      // onCancel(){},
    })
  }

  // NOTE:自定义form组件
  freeCombinationForm() {
    const { freeCombinationList, shanchu } = this.state
    const { searchConfig, searchScenario, search, getItemValue, onItemValueChange, tableConfig, lang } = this.props
    tableConfig &&
      tableConfig.length > 0 &&
      tableConfig.map(item => {
        if (!item.titleCh) {
          item.titleCh = item.title
        }
      })
    tableConfig &&
      tableConfig.length > 0 &&
      tableConfig.map(item => {
        item.title = lang === "en" ? item.titleEN : item.titleCh
      })

    let keysList = Object.keys(wfConditionConst)
    let dropIndex = keysList.indexOf("notcontain")
    keysList.splice(dropIndex, 1)
    // console.log("条件列表", keysList);

    // TODO:筛选出条件字段中能用的字段
    const listNotHave = () => {
      // let newArr = searchConfig&&searchConfig[0].filter((x) => !freeCombinationList.some((item) => x.dataIndex === item.dataIndex));
      let newArr = searchConfig && searchConfig[0].filter(el => el.ynEnable === "1")
      return newArr
    }

    // TODO: 判断禁用
    const isDisable = value => {
      const unChoList = ["dateRange"]
      return unChoList.indexOf(value) > -1
    }

    return (
      <div className="layerFormW">
        <span className="zongTj">
          且<em onClick={() => this.dropGroup()}>-</em>
        </span>
        <ul className="layerForm">
          {freeCombinationList &&
            freeCombinationList.map((item, index) => (
              <li className="layerLi" key={index}>
                <Select
                  style={{ width: 200, borderRadius: 2, marginRight: 10 }}
                  placeholder={"请选择条件字段"}
                  value={item.title}
                  onChange={(value, item) => this.setSelectChange(value, item, index)}
                >
                  {listNotHave() &&
                    listNotHave().map((item1, index) => (
                      <Option key={index} value={item1.dataIndex}>
                        {item1.title}
                      </Option>
                    ))}
                </Select>
                {shanchu}
                {/* disabled={isDisable(item.type)}   //禁用属性 */}
                <Select
                  style={{ width: 120, borderRadius: 2, marginRight: 10 }}
                  onChange={value => this.setTiaoJian(value, index)}
                  value={item.tjtitle}
                  placeholder="请选择条件关系"
                >
                  {keysList &&
                    keysList.map((item, index) => (
                      <Option key={index} value={wfConditionConst[item].value}>
                        {wfConditionConst[item].label}
                      </Option>
                    ))}
                </Select>
                <div style={{ width: 310, marginRight: 10, display: "inline-block" }}>
                  {item.tiaojianMes.length > 0 ? (
                    <AutogenerationForm
                      style={{
                        display: "inline-block",
                        height: 32,
                        lineHeight: 32,
                        boxSizing: "border-box",
                        marginTop: "-2px!important",
                        verticalAlign: "middle",
                        width: "100%"
                      }}
                      lang={this.props.lang}
                      forbidHide
                      labelWidthSwitch={"hide"}
                      scale={5}
                      config={[...[...item.tiaojianMes]]}
                      source={item.tiaojianMesData}
                      getItemValue={() => item.tiaojianObg}
                      // onItemValueChange && onItemValueChange(value, dataIndex, item, referenceResult) &&
                      onItemValueChange={(value, dataIndex, item, referenceResult) =>
                        this.setDataState(value, dataIndex, item, referenceResult, index)
                      }
                    />
                  ) : (
                    <span className="tishiWord">请选择搜索条件字段</span>
                  )}
                </div>
                <Tooltip placement="top" title={"删除当前行"}>
                  <Button type="primary" size="small" shape="circle" onClick={() => this.shangchu(index)} icon="minus" />
                </Tooltip>
              </li>
            ))}
          <li className="layerLi">
            <Tooltip placement="top" title={"新增一行"}>
              <Button size="small" type="primary" shape="circle" icon="plus" onClick={() => this.addNewItem()} />
            </Tooltip>
          </li>
        </ul>
      </div>
    )
  }

  // TODO:新增自定义form的一个条目
  addNewItem() {
    const { freeCombinationList } = this.state
    const newObg = { title: "", dataIndex: "", type: "", tiaojian: "", tjtitle: "", tiaojianMes: [], tiaojianMesData: {}, tiaojianObg: "" }
    let newlist = [...freeCombinationList, ...[newObg]]

    this.setState({
      freeCombinationList: newlist
    })
  }

  // TODO:选择框改变
  setSelectChange(value, obg, suoyin) {
    const { searchConfig, searchScenario } = this.props
    const { freeCombinationList } = this.state
    let newList = _.cloneDeep(freeCombinationList)

    let keywords = searchConfig[0].filter(el => el.dataIndex == value)

    let newObg = {
      [keywords[0].tableName]: {
        [value]: { value: "1", type: keywords[0].type }
      }
    }

    // return;
    newList[suoyin].dataIndex = value
    newList[suoyin].title = obg.props.children
    newList[suoyin].type = keywords[0].type
    let list = []
    list[0] = searchConfig[0].filter(el => el.dataIndex == value)
    newList[suoyin].tiaojianMes = list
    newList[suoyin].tiaojianMesData = fromJS(newObg)
    newList[suoyin].tiaojianObg = ""
    this.setState({
      freeCombinationList: newList
    })
  }

  // TODO:设置后面数据
  setDataState(value, dataIndex, item, referenceResult, suoyin) {
    console.log("设置的数据", value, dataIndex, item, suoyin)

    const { freeCombinationList } = this.state
    let newList = _.cloneDeep(freeCombinationList)

    newList.forEach((element, index) => {
      if (element.dataIndex == dataIndex && index == suoyin) {
        element.tiaojianObg = value
        element.tiaojianMesData = element.tiaojianMesData.setIn([item.tableName, dataIndex, "value"], value)
      }
    })

    this.setState({
      freeCombinationList: newList
    })
  }

  // TODO:判断符选择
  setTiaoJian = (judgmentF, suoyin) => {
    const { freeCombinationList } = this.state
    let newList = _.cloneDeep(freeCombinationList)

    let keys = Object.keys(wfConditionConst)
    let fName = ""
    keys.forEach(item => {
      if (judgmentF == wfConditionConst[item].value) {
        fName = wfConditionConst[item].label
      }
    })
    newList.forEach((element, index) => {
      if (index === suoyin) {
        element.tiaojian = judgmentF
        element.tjtitle = fName
      }
    })
    this.setState({
      freeCombinationList: newList
    })
  }

  // TODO:删除所选的行
  shangchu(suoyin) {
    const { freeCombinationList } = this.state
    if (freeCombinationList.length === 1) {
      Modal.error({
        title: "删除行提示！",
        content: "高级查询条件最少一行，当前已经是最后一行，无法删除！"
      })
      this.setState({
        freeCombinationList: [
          { title: "", dataIndex: "", type: "", tiaojian: "", tjtitle: "", tiaojianMes: [], tiaojianMesData: {}, tiaojianObg: "" }
        ]
      })
      return
    }
    let newList = freeCombinationList.filter((el, index) => index != suoyin)
    this.setState({
      freeCombinationList: newList
    })
  }

  render() {
    const { searchConfig, getItemValue, onItemValueChange, search, visible, onClose, searchScenario, tableConfig, lang } = this.props

    tableConfig &&
      tableConfig.length > 0 &&
      tableConfig.map(item => {
        if (!item.titleCh) {
          item.titleCh = item.title
        }
      })
    tableConfig &&
      tableConfig.length > 0 &&
      tableConfig.map(item => {
        item.title = lang === "en" ? item.titleEN : item.titleCh
      })

    return (
      <DraggableModal
        title={<FormattedMessage id="locale_AdvancedSettings" />}
        visible={visible}
        destroyOnClose
        onOk={() => this.onOk()}
        onCancel={() => onClose && onClose()}
        wrapClassName="searchScenarioConfig"
        width={800}
      >
        <Tabs defaultActiveKey="1" size="small" onChange={activeTabKey => this.setState({ activeTabKey })}>
          <Tabs.TabPane tab={<FormattedMessage id="locale_AdvancedQuery" />} key="1">
            
            {this.freeCombinationForm()}
          </Tabs.TabPane>
          <Tabs.TabPane tab={<FormattedMessage id="locale_QueryConditioning" />} key="2">
            <DragSortTable
              tableProps={{
                bordered: true,
                pagination: false,
                rowKey: record => (record["tableName"] || "") + record["dataIndex"]
              }}
              columns={this.searchColumns}
              onChange={newSortSearchData => (this.newSortSearchData = newSortSearchData)}
              dataSource={searchConfig && searchConfig.length > 0 ? searchConfig[0].filter(x => x.hide !== "1") : []}
            />
          </Tabs.TabPane>
          <Tabs.TabPane tab={<FormattedMessage id="locale_HeadersToSet" />} key="3">
            <DragSortTable
              tableProps={{
                bordered: true,
                pagination: false,
                rowKey: record => (record["tableName"] || "") + record["dataIndex"]
              }}
              columns={this.tableColumns}
              onChange={newData => (this.newTableConfig = newData)}
              dataSource={tableConfig || []}
            />
          </Tabs.TabPane>
        </Tabs>

        {/* <DragSortTable
          tableProps={{
            bordered: true,
            pagination: false,
            rowKey: record => (record["tableName"] || "") + record["dataIndex"]
          }}
          bodyH={500}
          columns={this.tableColumns}
          onChange={newData => (this.newTableConfig = newData)}
          dataSource={tableConfig || []}
        /> */}
      </DraggableModal>
    )
  }
}
