/**
 * Created by 王友生 on 2018-07-04.
 */

import React, { PureComponent } from "react"
import { Upload, message, Icon, Button } from "antd"
import { serverUrl, fileServerUrl } from "../../common/config"
import { systemCommonFileFunctionCode } from "../../common/const"
import { buildFileActualUrl } from "../../utils"

export default class UploadFile extends PureComponent {
  state = {
    fileList: []
  }

  beforeUpload(file) {
    return true
  }

  componentDidMount() {
    if (this.props.value && this.props.value.length > 0) {
      let temp = this.props.value
      temp.map(item => {
        item.url = buildFileActualUrl(item.fileUrl + item.newFileName)
        item.thumbUrl = buildFileActualUrl(item.fileUrl + item.newFileName)
      })
      this.setState({ fileList: temp })
    }
  }

  componentWillReceiveProps(newProps) {
    if ((!this.props.value || this.props.value.length === 0) && newProps.value) {
      let temp = newProps.value
      temp.map(item => {
        item.url = buildFileActualUrl(item.fileUrl + item.newFileName)
        item.thumbUrl = buildFileActualUrl(item.fileUrl + item.newFileName)
      })
      this.setState({ fileList: temp })
      //this.setState({ fileList: newProps.value });
    }
  }

  render() {
    const { value, onChange, disabled } = this.props
    const dragProps = {
      name: "file",
      disabled,
      listType: "picture",
      fileList: this.state.fileList,
      beforeUpload: file => this.beforeUpload(file),
      headers: { authorization: localStorage.getItem("token") || "", accessType: "backend" },
      action: `${serverUrl}/attach/uploadFiles?funCode=${this.props.functionCode || systemCommonFileFunctionCode}`,
      onChange: info => {
        const status = info.file.status
        // if (status !== 'uploading') {
        // }
        if (status === "done") {
          if (info.file.response && info.file.response.code === "0") {
            // message.success(`${info.file.name} 上传成功！`);
            if (info.file.response.data && info.file.response.data.result && info.file.response.data.result.length > 0) {
              const fileInfo = info.file.response.data.result[0]
              let newFile = {
                uid: fileInfo.newFileName,
                name: fileInfo.oldFileName,
                //url: buildFileActualUrl(fileInfo.fileUrl + fileInfo.newFileName),
                //thumbUrl: buildFileActualUrl(fileInfo.fileUrl + fileInfo.newFileName),
                //...fileInfo
                filePath: fileInfo.filePath,
                newFileName: fileInfo.newFileName,
                oldFileName: fileInfo.oldFileName,
                fileUrl: fileInfo.fileUrl
                //status: 'done',
              }
              value.push(newFile)
              onChange && onChange(value)
            }
          }
        } else if (status === "error") {
          message.error(`${info.file.name} 上传失败！`)
        } else if (status === "removed") {
          onChange && onChange(info.fileList)
        }
        this.setState({ fileList: [...info.fileList] })
      }
    }
    return (
      <div>
        <Upload {...dragProps} multiple>
          {!disabled && (
            <Button size="small">
              <Icon type="upload" />
              上传
            </Button>
          )}
        </Upload>
      </div>
    )
  }
}
