import React, { PureComponent } from "react"
import Table from "antd/es/table"
import { connect } from "react-redux"
import { FormattedMessage } from "react-intl"

@connect(state => {
  const lang = state.get("system").get("lang")
  return {
    lang
  }
})
class BaseTable extends PureComponent {
  constructor(props) {
    super(props)

    // const newRowSelection = rowSelection ? { ...rowSelection } : null
    // if (rowSelection) {
    //   const { onSelectAll, onChange } = rowSelection
    //   if (onSelectAll) {
    //     newRowSelection.onSelectAll = this.reOnSelectAll
    //     // 原方法保存下来
    //     this.onSelectAllCB = onSelectAll
    //   }
    //   if (onChange) {
    //     newRowSelection.onChange = this.reOnChange
    //     // 原方法保存下来
    //     this.onChangeCB = onChange
    //   }
    // }
    this.state = {
      selectedRowKeys: []
      // newRowSelection,
    }
  }
  componentDidMount() {
    const { rowSelection } = this.props
    this.rowSelectCopy(rowSelection)
  }
  // 组件更新时切换勾选方法
  rowSelectCopy(rowSelection) {
    const newRowSelection = rowSelection ? { ...rowSelection } : null
    if (rowSelection) {
      const { onSelectAll, onChange } = rowSelection
      if (onSelectAll) {
        newRowSelection.onSelectAll = this.reOnSelectAll
        // 原方法保存下来
        this.onSelectAllCB = onSelectAll
      }
      if (onChange) {
        newRowSelection.onChange = this.reOnChange
        // 原方法保存下来
        this.onChangeCB = onChange
      }
    }
    this.setState({
      selectedRowKeys: [],
      newRowSelection
    })
  }
  componentWillReceiveProps(newProps) {
    if (this.props.rowSelection !== newProps.rowSelection) {
      this.rowSelectCopy(newProps.rowSelection)
    }
  }

  reOnSelectAll = (selected, selectedRows, changeRows) => {
    // 处理全选函数
    const { dataSource, rowKey } = this.props
    if (selected) {
      const selectedRowKeys = dataSource.map(item => item[rowKey])
      this.setState(
        {
          selectedRowKeys
        },
        () => {
          this.onSelectAllCB(selected, dataSource, changeRows)
        }
      )
    } else {
      this.setState(
        {
          selectedRowKeys: []
        },
        () => {
          this.onSelectAllCB(selected, [], dataSource)
        }
      )
    }
  }

  reOnChange = (selectedRowKeys, selectedRows) => {
    // 处理onChange函数
    if (selectedRowKeys) {
      this.setState(
        {
          selectedRowKeys
        },
        () => {
          this.onChangeCB(selectedRowKeys, selectedRows)
        }
      )
    }
  }

  render() {
    const { renderSource, dataSource, rowSelection, ...rest } = this.props
    const { selectedRowKeys, newRowSelection } = this.state
    // 数据排错用
    // let arr = []
    // renderSource.map(item => {
    //   arr.push(item.id)
    // })
    // console.log(arr)

    try {
      if (newRowSelection) {
        /**需要兼容用户传递进来的selectedRowKeys，
         * 用户selectedRowKeys优先级高于内部selectedRowKeys */
        newRowSelection.selectedRowKeys = rowSelection["selectedRowKeys"] || selectedRowKeys
      }
    } catch (e) {
      console.log("catch", rowSelection)
    }
    return (
      <Table
        {...rest}
        locale={{ emptyText: <FormattedMessage id="locale_noData" /> }}
        rowSelection={newRowSelection}
        dataSource={renderSource}
      />
    )
  }
}

export default BaseTable
