/**
 * Created by 王友生 on 2018-04-13.
 */

import './index.less';
import React, { PureComponent } from 'react';
import { Popover, Input, Button } from 'antd';
import {connect} from 'react-redux';
import {FormattedMessage, injectIntl} from 'react-intl';



export const workflowHandleFlag = {
  unReach: '0',
  unHandle: '1',
  handled: '2'
};

export const workflowHandleType = {
  handle: '0',
  sendBack: '1',
  withDraw: '2'
}
@connect((state, route) => {
  const lang = state.get('system').get('lang');
  return {
    lang,
  }
})
export default class WorkFlowOperation extends PureComponent {

  state = {
    message: ''
  }

  render() {
    const { handleFlag, messages, dealWithWorkflow } = this.props;

    return <Popover
      title="协同回复"
      placement="bottomRight"
      content={<div className="wrapper">
        {
          handleFlag === workflowHandleFlag.unHandle && <div>
            <Input.TextArea value={this.state.message} onChange={(e) => this.setState({ message: e.target.value })}>
            </Input.TextArea>
            <div className="actions">
              <Button size="small" onClick={() => dealWithWorkflow && dealWithWorkflow(this.state.message, workflowHandleType.handle)}>处理</Button>
              <Button size="small" onClick={() => dealWithWorkflow && dealWithWorkflow(this.state.message, workflowHandleType.sendBack)}>回退</Button>
            </div>
          </div>
        }
        {messages ? <ul className="message">
          {
            messages.map((item, index) => <li key={index}>
              <div className="header">
                <div>{item.create_user_name}</div>
                <div>{ item.result === '5' ? '已审' : '退回' }</div>
                <div>{item.create_time}</div>
              </div>
              <div>{item.message || '无'}</div>
            </li>)
          }
        </ul> : '暂无协同记录'
        }
      </div>}>
      {this.props.children}
    </Popover>;
  }
}
