import './index.less';
import React, { PureComponent } from 'react';
import { DatePicker } from 'antd';

class YearPicker extends PureComponent {
  constructor(props) {
    super(props);
    this.state = {
      isopen: false,
    }
  }

  render() {
    const { params, onChange } = this.props;
    const { isopen } = this.state;
    return (
      <div className="custom-date-picker">
        <DatePicker
          mode="year"
          format="YYYY"
          disabled={params.disabled}
          style={{ width: "100%" }}
          {...params}
          open={isopen}
          onOpenChange={(status) => {
            if (status) {
              this.setState({ isopen: true })
            } else {
              this.setState({ isopen: false })
            }
          }}
          onPanelChange={value => {
            this.setState({ isopen: false })
            onChange(value && value.format("YYYY"))
          }}
          onChange={() => {
            onChange()
          }}
        />
      </div>
    )
  }
}

export default YearPicker;