/**
 * Created by 王友生 on 2018-07-05.
 */

import { Map } from 'immutable';

const initState = Map({});

export default (state = initState, action) => {
  switch (action.type) {
    case 'advanceList/fetchConfigSuccess':
      const { searchScenarioConfig, functionCode, collect, fields, basicInfo, searchScenario,
        listTopButtons, listMoreButtons, totalWidth, searchButton, listPrintTemplate, pagination,
        shortFormConfig, listPrintButtons, listExportButtons, listAuditingButton,
        listBatchEditButton, listBatchDeleteButton, listBatchUpdateButton,
        listRelationFormButtons, listToolButtons, listRelationSearchButtons, listSettingButton,
        listAbandonButton, listAddButton, searchRowCount, fullTableConfig,
        actionColumn, collectRowCount } = action.payload;
      return state.setIn([functionCode, 'searchScenarioConfig'], searchScenarioConfig)
        .setIn([functionCode, 'collectConfig'], collect)
        .setIn([functionCode, 'fieldsConfig'], fields)
        .setIn([functionCode, 'collectRowCount'], collectRowCount)
        .setIn([functionCode, 'basicInfo'], basicInfo)
        .setIn([functionCode, 'searchScenario'], searchScenario)
        .setIn([functionCode, 'fullTableConfig'], fullTableConfig)
        .setIn([functionCode, 'defaultSearchScenario'], searchScenario)
        .setIn([functionCode, 'listTopButtons'], listTopButtons)
        .setIn([functionCode, 'listMoreButtons'], listMoreButtons)
        .setIn([functionCode, 'totalWidth'], totalWidth)
        .setIn([functionCode, 'searchButton'], searchButton)
        .setIn([functionCode, 'listPrintButtons'], listPrintButtons)
        .setIn([functionCode, 'listExportButtons'], listExportButtons)
        .setIn([functionCode, 'listAuditingButton'], listAuditingButton)
        .setIn([functionCode, 'listAbandonButton'], listAbandonButton)
        .setIn([functionCode, 'listAddButton'], listAddButton)
        .setIn([functionCode, 'listBatchEditButton'], listBatchEditButton)
        .setIn([functionCode, 'listBatchDeleteButton'], listBatchDeleteButton)
        .setIn([functionCode, 'listBatchUpdateButton'], listBatchUpdateButton)
        .setIn([functionCode, 'listRelationFormButtons'], listRelationFormButtons)
        .setIn([functionCode, 'listRelationSearchButtons'], listRelationSearchButtons)
        .setIn([functionCode, 'listSettingButton'], listSettingButton)
        .setIn([functionCode, 'listToolButtons'], listToolButtons)
        .setIn([functionCode, 'listPrintTemplate'], listPrintTemplate)
        .setIn([functionCode, 'shortFormConfig'], shortFormConfig)
        .setIn([functionCode, 'pagination'], pagination)
        .setIn([functionCode, 'actionColumn'], actionColumn)
        .setIn([functionCode, 'searchRowCount'], searchRowCount)
        .setIn([functionCode, 'sorter'], {})
    case 'advanceList/changeSelectedRowKeys':
      return state.setIn([action.payload.functionCode, 'selectedRowKeys'], action.payload.selectedRowKeys);
    case 'advanceList/changeSelectedRow':
      return state.setIn([action.payload.functionCode, 'selectedRow'], action.payload.selectedRow);
    case 'advanceList/changeSearchScenario': {
      const { functionCode, dataIndex, value } = action.payload;
      return state.setIn([functionCode, 'searchScenario', dataIndex], value);
    }
    case 'advancelist/changeCacheTableConfig': {
      const { functionCode, totalWidth, fullTableConfig, tableConfig } = action.payload;
      return state.setIn([functionCode, 'totalWidth'], totalWidth)
        .setIn([functionCode, 'fullTableConfig'], fullTableConfig)
        .setIn([functionCode, 'fieldsConfig'], tableConfig)
    }
    case 'advanceList/changeAllSearchScenario':
      return state.setIn([action.payload.functionCode, 'searchScenario'], action.payload.searchScenario);
    case 'advanceList/changeCacheItem': {
      const { functionCode, key, value } = action.payload;
      return state.setIn([functionCode, key], value);
    }
    case 'advanceList/fetchAdvanceDataSuccess': {
      console.log('action.payload==>', action.payload);
      const { functionCode, data, pagination = { pageNo: 1, pageSize: 10 } } = action.payload;
      if (data && data.dataSource) {
        console.log('data.dataSource==>', data.dataSource);
        (data.dataSource || []).forEach((v, index) => {
          v._index = (pagination.pageNo - 1) * pagination.pageSize + index;
        });
      }
      console.log('===>', data);
      return state.setIn([functionCode, 'result'], data);
    }
    case 'advancelist/changeSearchConfig': {
      return state.setIn([action.payload.functionCode, 'searchScenarioConfig'], action.payload.newSearchConfig)
        .setIn([action.payload.functionCode, 'searchRowCount'], action.payload.searchRowCount)
    }
    case 'system/logoutSuccess':
      return initState;
    default:
      return state;
  }
}
