/**
 * Created by 王友生 on 2018-06-12.
 */

import { Map, fromJS } from 'immutable';

const initState = Map({});

export default (state = initState, action) => {
  switch (action.type) {
    case 'customReports/fetchReportConfigSuccess':
      const { seacherItem, groupItem, matrixItem, functionCode, defaultSearchScenario, searchScenario, reportName, reportType, content } = action.payload;
      return state.setIn([functionCode, 'seacherItem'], seacherItem)
        .setIn([functionCode, 'groupItem'], fromJS(groupItem))
        .setIn([functionCode, 'matrixItem'], fromJS(matrixItem))
        .setIn([functionCode, 'searchScenario'], searchScenario)
        .setIn([functionCode, 'defaultSearchScenario'], defaultSearchScenario)
        .setIn([functionCode, 'reportName'], reportName)
        .setIn([functionCode, 'reportType'], reportType)
        .setIn([functionCode, 'contentConfig'], content)
    case 'customReports/changeSearchScenario': {
      const { functionCode, dataIndex, value, type } = action.payload;
      return state.setIn([functionCode, 'searchScenario', dataIndex], fromJS({ value, type }));
    }
    case 'customReports/changeAllSearchScenario': {
      const { searchScenario, functionCode } = action.payload;
      return state.setIn([functionCode, 'searchScenario'], searchScenario);
    }
    case 'customReports/changeTabItem': {
      const { functionCode, dataIndex, value, index, type } = action.payload;
      return state.setIn([functionCode, type, index, dataIndex], value);
    }
    case 'customReports/fetchReportDataSuccess': {
      const { functionCode, data, chartData } = action.payload;
      return state.setIn([functionCode, 'result'], data)
        .setIn([functionCode, 'chartData'], chartData);
    }
    case 'customReports/fetchReportDataChartSuccess': {
      const { functionCode, data, header, totalWidth, chartData } = action.payload;
      return state.setIn([functionCode, 'data'], data)
        .setIn([functionCode, 'header'], header)
        .setIn([functionCode, 'totalWidth'], totalWidth)
        .setIn([functionCode, 'chartData'], chartData)
    }
    case 'system/logoutSuccess':
      return initState;
    default:
      return state;
  }
}
