/**
 * Created by 王友生 on 2018-07-16.
 */

import { Map } from 'immutable';

const initState = Map({
  dealWith: [],
  dealWithChartData: [],
  notices: [],
  dashboardWeizhi:{
    daiban:0,
    shishi:0,
    tongji:0,
  }
});

export default (state = initState, action) => {
  switch (action.type) {
    case 'dashboard/initDashboardConfigSuccess':
      return state.set('id', action.payload.id)
        .set('configurableMenus', action.payload.configurableMenus)
        .set('dashboardItems', action.payload.dashboardItems)
        .set('dashboardItemConfig', action.payload.dashboardItemConfig)
        .set('rightDashboardItems', action.payload.rightDashboardItems)
        .set('leftDashboardItems', action.payload.leftDashboardItems);
    case 'dashboard/changeDashboardItem':
      return state.set(action.payload.key, action.payload.value);
    case 'dashboard/saveDashboardConfigSuccess':
      return state.set('configModalVisible', false)
        .set('dashboardItemConfig', action.payload.dashboardItemConfig)
        .set('rightDashboardItems', action.payload.rightDashboardItems)
        .set('leftDashboardItems', action.payload.leftDashboardItems);
    case 'dashboard/fetchDashboardItemDataSuccess': {
      const { functionCode, data } = action.payload;
      return state.setIn(['dashboardItemData', functionCode], { data });
    }
    case 'dashboard/rerenderDashboard':
      return state.set('renderFlag', !state.get('renderFlag'));
    case 'dashboard/changeConfigMenuItem': {
      const { dragKeyPath, overKeyPath, listQueryViewButtons,searchScenario, menuId } = action.payload;
      // let menu = state.getIn(['configurableMenus', ...dragKeyPath]);
      let menus = state.getIn(['configurableMenus', dragKeyPath[0]]);
      // 下标改id添加删除
      let menu = undefined;
      let itemIdx = undefined
      for (let i = 0; i < menus.size; i++) {
        let item = menus.get(i)
        if (item.id == menuId) {
          menu = item
          itemIdx = i
        }
      }
      let sourceIndex = - 1;
      if (overKeyPath.length > 1) {
        sourceIndex = overKeyPath.pop();
      }
      // 插入视图
      if (listQueryViewButtons) {
        menu.listQueryViewButtons = listQueryViewButtons
      }
      if (searchScenario) {
        menu.searchScenario = searchScenario
      }
      return state.deleteIn(['configurableMenus', dragKeyPath[0], itemIdx])
        .updateIn(['configurableMenus', ...overKeyPath], menus => {
          menus = menus.insert(sourceIndex, menu)
          return menus;
        });
    }
    case 'dashboard/removeOnMenu': {
      const menu = state.getIn(['configurableMenus', ...action.payload.keyPath]);
      return state.deleteIn(['configurableMenus', ...action.payload.keyPath])
        .updateIn(['configurableMenus', 'sourceMenus'], menus => {
          menus = menus.push(menu);
          return menus;
        });
    }
    // 设置视图
    case 'dashboard/setQueryView': {
      const { queryViewPath, queryView } = action.payload;
      //console.log(queryViewPath, queryView)
      state.updateIn(['configurableMenus', ...action.payload.queryViewPath], item => {
        item.queryView = action.payload.queryView
      })
      return state
    }
    case 'dashboard/fetchDealWithSuccess':
      return state.set('dealWith', action.payload.result);
    case 'dashboard/fetchDealWithChartSuccess':
      return state.set('dealWithChartData', action.payload.chartData)
        .set('dealWithTotalCount', action.payload.totalCount);
    case 'dashboard/fetchNoticeSuccess':
      return state.set('notices', action.payload.result);
    case 'dashboard/fetchMailSuccess':
      return state.set('pendingMailCount', action.payload.result);
    case 'dashboard/weizhiMes':
      return state.set("dashboardWeizhi", action.payload.result);
    default:
      return state;
  }
}
