import { take, takeEvery, put, call, fork } from 'redux-saga/effects';
import { post, url } from '../../service/api';
import { message } from 'antd';
let dictionaryIds = [];
export const watchFetchDictionary = function* () {
  yield takeEvery('dictionary/refreshDictionary', initDictionary);
  while (true) {
    const action = yield take('dictionary/initDictionary');
    if (dictionaryIds.indexOf(action.payload) < 0) {
      dictionaryIds.push(action.payload);
      yield fork(initDictionary, action);
    }
    yield takeEvery('dictionary/iniStateSaga', iniStateSaga);
  }
}
function* iniStateSaga() {
  dictionaryIds = [];
  yield put({ type: 'dictionary/iniState' });
}
function* initDictionary(action) {
  if (!action.payload) {
    return;
  }
  const data = yield call(post, url.fetchDictionaryByKey, { key: action.payload });
  if (data && data.result) {
    yield put({ type: 'dictionary/fetchDictionarySuccess', payload: { key: action.payload, data: data.result } });
  }
}
