import { Map } from 'immutable';
import { fromJS, List } from 'immutable'
import { formulaType, operationType, functionType } from '../../common/const';

const initState = Map({});

export default (state = initState, action) => {
  switch (action.type) {
    case 'form/fetchFormConfigSuccess':
      return state.setIn([action.payload.functionCode, 'config'], action.payload.config)
        .setIn([action.payload.functionCode, 'referenceConfig'], action.payload.referenceConfig)
        .setIn([action.payload.functionCode, 'relationship'], action.payload.relationship)
        .setIn([action.payload.functionCode, 'titleItem'], action.payload.titleItem)
        .setIn([action.payload.functionCode, 'detailTopButtons'], action.payload.detailTopButtons)
        .setIn([action.payload.functionCode, 'detailMoreButtons'], action.payload.detailMoreButtons)
        .setIn([action.payload.functionCode, 'detailPrintButton'], action.payload.detailPrintButton)
        .setIn([action.payload.functionCode, 'detailAuditingButton'], action.payload.detailAuditingButton)
        .setIn([action.payload.functionCode, 'detailAbandonButton'], action.payload.detailAbandonButton)
        .setIn([action.payload.functionCode, 'detailDeleteButton'], action.payload.detailDeleteButton)
        .setIn([action.payload.functionCode, 'detailEditButton'], action.payload.detailEditButton)
        .setIn([action.payload.functionCode, 'detailRelationFormButtons'], action.payload.detailRelationFormButtons)
        .setIn([action.payload.functionCode, 'detailPopupRelationFormButtons'], action.payload.detailPopupRelationFormButtons)
        .setIn([action.payload.functionCode, 'detailRelationSearchButtons'], action.payload.detailRelationSearchButtons)
        .setIn([action.payload.functionCode, 'detailToolButtons'], action.payload.detailToolButtons)
        .setIn([action.payload.functionCode, 'detailXuandanButtons'], action.payload.detailXuandanButtons)
        .setIn([action.payload.functionCode, 'formAddButton'], action.payload.formAddButton)
        .setIn([action.payload.functionCode, 'detailAddButton'], action.payload.detailAddButton)
        .setIn([action.payload.functionCode, 'formSaveButton'], action.payload.formSaveButton)
        .setIn([action.payload.functionCode, 'formResetButton'], action.payload.formResetButton)
        .setIn([action.payload.functionCode, 'formulaList'], action.payload.formulaList)
        .setIn([action.payload.functionCode, 'mainTableName'], action.payload.mainTableName)
        .setIn([action.payload.functionCode, 'tabs'], action.payload.tabs)
        .setIn([action.payload.functionCode, 'tabsM'], action.payload.tabsM)
        .setIn([action.payload.functionCode, 'formulaTriggerMapping'], action.payload.formulaTriggerMapping)
        .setIn([action.payload.functionCode, 'formButtons'], action.payload.formButtons)
        .setIn([action.payload.functionCode, 'formDetail', '-1'], action.payload.formData)
        .setIn([action.payload.functionCode, 'formPrintTemplate'], action.payload.formPrintTemplate)
        .setIn([action.payload.functionCode, 'shortFormConfig'], action.payload.shortFormConfig)
        .setIn([action.payload.functionCode, 'formDetailAttachments', '-1'], [])
        .setIn([action.payload.functionCode, 'fieldMonitor'], action.payload.fieldMonitor);
    case 'form/FetchFormDetailDataSuccess':
      return state.setIn([action.payload.functionCode, 'formDetail', action.payload.id], action.payload.formDetail);
    case 'form/FetchFormDetailAttachmentsSuccess':
      return state.setIn([action.payload.functionCode, 'formDetailAttachments', action.payload.id], action.payload.formDetailAttachments);
    case 'form/fetchInvoiceWorkflowConfigSuccess':
      return state.setIn([action.payload.functionCode, 'workflowConfig', action.payload.id], action.payload.workflowConfig);
    case 'form/setFormData':
      return state.setIn([action.payload.functionCode, 'formData'], action.payload.formData).setIn([action.payload.functionCode, 'formAttachments'], action.payload.attachmentList || List([]));
    case 'form/resetFormData':
      return state.setIn([action.payload.functionCode, 'formData'], undefined)
        .setIn([action.payload.functionCode, 'formAttachments'], List([]));
    case 'form/addFormAttachment': {
      const { functionCode, attachments } = action.payload;
      return state.updateIn([functionCode, 'formAttachments'], formAttachments => {
        formAttachments = formAttachments || List([]);
        return formAttachments.concat(List(attachments));
      });
    }
    case 'form/deleteFormAttachment': {
      const { functionCode, deletedIndex } = action.payload;
      return state.deleteIn([functionCode, 'formAttachments', deletedIndex]);
    }
    case 'form/changeChildTableData': {
      return state.setIn([action.payload.functionCode, 'formData', action.payload.tableName], fromJS(action.payload.newData));
    }
    case 'form/setForm':
      return action.payload;
    case 'form/resetForm':
      return initState;
    case 'form/setFormConfig':
      return state.setIn([action.payload.functionCode, 'config', 'formConfig'], action.payload.formConfig);
    case 'system/logoutSuccess':
      return initState;
    case 'form/setLayerReadyLoadMap':
      return state.setIn([action.payload.functionCode, 'formDetail', "layerMapShow"], action.payload.layerMapShow);
    case 'form/setScroll':
      return state.setIn([action.payload.functionCode, "detailPosition", action.payload.id, 'y'], action.payload.y);
    default:
      return state;
  }
}
