/**
 * Created by 王友生 on 2018-06-29.
 */

import { takeEvery, put, call, select, fork, take } from 'redux-saga/effects';
import { sendMessage as sendMessageToOne } from '../../utils/stomp';

export const watchSendMessage = function* () {
  yield takeEvery('message/sendMessage', sendMessage);
}

function* sendMessage(action) {
  const { toUser, content } = action.payload;
  sendMessageToOne(toUser, content);
  yield put({ type: 'message/sendMessageToOne', payload: { toUser, content } });
}


export const watchReceiveMessage = function* () {
  yield takeEvery('message/receiveNewMessage', receiveMessage);
}

function* receiveMessage(action) {
  const { fromUser, content } = action.payload;
  const cache = yield select(x => x.get('message'));
  const chatUser = cache.get('chatUser');
  let isUnreadMessage = false;
  if (! chatUser || chatUser.id !== fromUser.id) {
    isUnreadMessage = true;
  }
  yield put({ type: 'message/receiveNewMessageSuccess', payload:{ fromUser, content, isUnreadMessage } })
}