/**
 * Created by 王友生 on 2018-06-29.
 */

import { Map, List } from "immutable"

const initState = Map({
  noteList: List([]),
  noteFolder: List([]),
  pagination: { pageNo: 1, pageSize: 5, total: 1 },
  type: "",
  editItem: {},
  selectFolder: ["0"],
  flag: ""
})

export default (state = initState, action) => {
  switch (action.type) {
    case "note/FetchNoteListDataSuccess": {
      const { listData } = action.payload
      return state.set("noteList", List(listData))
    }
    case "note/addNoteListData":
      const { addData } = action.payload
      return state.set("noteList", state.get("noteList").unshift(addData))
    case "note/editNoteListData":
      const { editData } = action.payload
      let noteList = state.get("noteList")
      const idx = noteList.findIndex((value, index, arr) => {
        return value.id === editData.id
      })
      noteList = noteList.update(idx, value => {
        return editData
      })
      return state.set("noteList", noteList)
    case "note/delNoteListData":
      const { delId } = action.payload
      let oldNoteList = state.get("noteList")
      let oldIdx = oldNoteList.findIndex((value, index, arr) => {
        return value.id === delId
      })
      oldNoteList = oldNoteList.delete(oldIdx)
      return state.set("noteList", oldNoteList)
    case "note/fetchNoteFolderSuccess":
      const { folderData } = action.payload
      return state.set("noteFolder", List(folderData))
    case "note/setNotePagination":
      const { pagination } = action.payload
      return state.set("pagination", { ...state.get("pagination"), ...pagination })
    case "note/setNoteSearch":
      const { type } = action.payload
      return state.set("type", type)
    case "note/editItem":
      const { item } = action.payload
      return state.set("editItem", item)
    case "note/selectFolder":
      const { folder } = action.payload
      return state.set("selectFolder", folder)
    case "note/changeModeFlag":
      const { flag } = action.payload
      return state.set("flag", flag)
    default:
      return state
  }
}
