/**
 * Created by 王友生 on 2018-06-29.
 */

import { functions } from 'lodash-es';
import { takeEvery, put, call, select, fork, take } from 'redux-saga/effects';
import { post} from '../../service/api';

export const watchFetchNoteListData = function* () {
  yield takeEvery('note/changeNotePagination', changeNotePagination);
  yield takeEvery('note/fetchNoteListData', fetchNoteListData);
  yield takeEvery('note/changeNoteListData', changeNoteListData);
  yield takeEvery('note/changeNoteSearch', changeNoteSearch);
}
function* fetchNoteListData(action) {
  const disableFunction = localStorage.getItem("disableFunction") ? JSON.parse(localStorage.getItem("disableFunction")) : '';
  if(disableFunction && disableFunction.disableNote === '1'){
    return
  }
  const note = yield select(x => x.get('note'));
  const pagination = note.get('pagination');
  const type = note.get('type');
  let { result,pageNo,pageSize,total } = yield call(post, '/mmMemorandum/getMmMemorandumListPaging', {type,...pagination });
  yield put({
    type: 'note/FetchNoteListDataSuccess',
    payload: {
      listData:result
    }
  });
  yield put({ type: 'note/setNotePagination', payload:{ pagination:{pageNo,pageSize,total} }})
}
function* changeNotePagination(action){
  yield put({ type: 'note/setNotePagination', payload:{ ...action.payload }});
  yield fetchNoteListData();
}
function* changeNoteListData(action){
  const { changeType,type,id,remindTime,isReminded = "0",remindOrNot = "0",title,content } = action.payload;
  if(changeType === 'add'){
    yield call(post, '/mmMemorandum/mmMemorandumAdd', {remindTime,type,isReminded,remindOrNot,title,content});
    //yield put({ type: 'note/addNoteListData', payload:{ addData : result }});
    yield fetchNoteListData(action);
  }else if(changeType === 'edit'){
    yield call(post, '/mmMemorandum/mmMemorandumEdit', {id,remindTime,type,isReminded,remindOrNot,title,content});
    //yield put({ type: 'note/editNoteListData', payload:{ editData : result }});
    yield fetchNoteListData(action);
  }else if(changeType === 'del'){
    yield call(post, '/mmMemorandum/deleteMmMemorandumById', {id});
    //yield put({ type: 'note/delNoteListData', payload:{ delId : id }});
    yield fetchNoteListData(action);
  }
}
function* changeNoteSearch(action){
  yield put({ type: 'note/setNoteSearch', payload:{ type:action.payload.type }});
  yield fetchNoteListData();
}

export const watchFetchNoteFolderData = function* () {
  yield takeEvery('note/fetchNoteFolderData', fetchNoteFolderData);
  yield takeEvery('note/changeNoteFolderData', changeNoteFolderData);
}

function* fetchNoteFolderData(action) {
  const disableFunction = localStorage.getItem("disableFunction") ? JSON.parse(localStorage.getItem("disableFunction")) : '';
  if(disableFunction && disableFunction.disableNote === '1'){
    return
  }
  let { result } = yield call(post, '/mmMemorandum/getMmMemorandumClass', {});
  yield put({ type: 'note/fetchNoteFolderSuccess', payload:{ folderData : result }});
}
function* changeNoteFolderData(action){
  const { name,id,changeType } = action.payload;
  if(changeType === 'add'){
    yield call(post, '/mmMemorandum/insertSelectiveMmMemorandumclass', {name});
    yield fetchNoteFolderData(action);
  }else if(changeType === 'edit'){
    yield call(post, '/mmMemorandum/updateMmMemorandumclass', {id,name});
    yield fetchNoteFolderData(action);
  }else if(changeType === 'del'){
    yield call(post, '/mmMemorandum/deleteMmMemorandumClassById', {id});
    yield fetchNoteFolderData(action);
  }
}




