/**
 * Created by 王友生 on 2018-05-16.
 */

import { Map } from 'immutable';

const iniState = Map({
  visible: false,
  currentId: '',
  selectedSuccess: false,
  selectedRows: [],
  currentItem: undefined,
  selectedMode: '',
  objectHash: undefined,
  singleTree: false//单树
});

export default (state = iniState, action) => {
  switch (action.type) {
    case 'reference/loadReferenceConfigSuccess':
      return state.setIn([action.payload.id, 'config'], action.payload.config)
        .setIn([action.payload.id, 'treeData'], action.payload.treeData);
    case 'reference/visibleReference':
      return state.set('visible', true).set('currentId', action.payload.id)
        .set('currentItem', action.payload.item)
        .set('selectedMode', action.payload.selectedMode)
        .set('extraSearchScenario', action.payload.extraSearchScenario)
        .set('objectHash', action.payload.objectHash)
        .set('filterTableRecord', action.payload.filterTableRecord)
        .set('onSelectedSuccess', action.payload.onSelectedSuccess)
        .set('singleTree', action.payload.singleTree);
    case 'reference/visibleReferenceWithData': {
      return state.set('visible', true).set('currentId', action.payload.id)
        .set('currentItem', action.payload.item)
        .set('selectedMode', action.payload.selectedMode)
        .set('extraSearchScenario', action.payload.extraSearchScenario)
        .set('objectHash', action.payload.objectHash)
        .set('filterTableRecord', action.payload.filterTableRecord)
        .set('onSelectedSuccess', action.payload.onSelectedSuccess)
        .set('singleTree', action.payload.singleTree)//单树
        .setIn([action.payload.id, 'fuzzy'], action.payload.fuzzy)
        .setIn([action.payload.id, 'tableData'], action.payload.tableData);
    }
    case 'reference/hideReference':
      return state.set('visible', true)
        .set('currentId', '')
        .set('selectedSuccess', false)
        .set('onSelectedSuccess', null);
    case 'reference/fetchReferenceTreeDataStart':
      return state.setIn([action.payload.id, 'treeData'], []);
    case 'reference/fetchReferenceTreeDataSuccess':
      return state.setIn([action.payload.id, 'treeData'], action.payload.treeData);
    case 'reference/fetchReferenceTableDataSuccess':
      return state.setIn([action.payload.id, 'tableData'], action.payload.tableData);
    case 'reference/selectReferenceSuccess': {
      if (action.objectHash) {
        state = state.set('objectHash', action.objectHash);
      }
      if (action.currentItem) {
        state = state.set('currentItem', action.currentItem);
      }
      return state.set('visible', false)
        .set('selectedSuccess', true)
        .set('selectedRows', action.payload)
        .set('onSelectedSuccess', null);
    }
    case 'reference/resetReference':
      return state.set('selectedSuccess', false)
        .set('selectedRows', [])
        .set('objectHash', undefined)
        .set('currentItem', undefined)
        .set('currentId', '')
        .set('extraSearchScenario', {})
        .set('onSelectedSuccess', null);
    case 'reference/onChangeSuccess':
      return state.set('selectedRows', action.payload.selectedRows)
        .set('objectHash', action.payload.objectHash)
        .set('currentItem', action.payload.currentItem)
        .set('selectedSuccess', action.payload.selectedSuccess)
    case 'reference/cachePop'://参照回填相关
      return state.set('cachePop', action.payload)
    case 'reference/callBackPop':
      if (action.functionCode) {
        return state.set('callBackPop', { ...state.get('cachePop'), callBackFunCode: action.functionCode })
      } else {
        return state.set('callBackPop', '')
      }
    case 'reference/iniState':
      return iniState
    default:
      return state;
  }
}
