/**
 * Created by 王友生 on 2018-06-12.
 */

import { Map } from 'immutable';

const initState = Map({});

export default (state = initState, action) => {
  switch (action.type) {
    case 'report/fetchReportConfigSuccess':
      const { searchScenarioConfig, functionCode, collect, fields, columns, basicInfo, searchScenario, reportPrintTemplate } = action.payload;
      return state.setIn([functionCode, 'searchScenarioConfig'], searchScenarioConfig)
        .setIn([functionCode, 'collectConfig'], collect)
        .setIn([functionCode, 'fieldsConfig'], fields)
        .setIn([functionCode, 'basicInfo'], basicInfo)
        .setIn([functionCode, 'searchScenario'], searchScenario)
        .setIn([functionCode, 'reportPrintTemplate'], reportPrintTemplate)
        .setIn([functionCode, 'columnsConfig'], columns);
    case 'report/changeSearchScenario': {
      const { functionCode, dataIndex, value } = action.payload;
      return state.setIn([functionCode, 'searchScenario', dataIndex], value);
    }
    case 'report/fetchReportDataSuccess': {
      const { functionCode, data, chartData } = action.payload;
      return state.setIn([functionCode, 'result'], data)
        .setIn([functionCode, 'chartData'], chartData);
    }
    case 'system/logoutSuccess':
      return initState;
    default:
      return state;
  }
}
