/**
 * Created by 王友生 on 2018-07-27.
 */

import { Map } from 'immutable';

const initState = Map({
  visible: false,
  data: Map({}),
  config: Map({}),
  shortFormId: '',
  selectRowKeys: Map({})
});

export default (state = initState, action) => {
  switch (action.type) {
    case 'shortForm/initShortFormConfig': {
      const { shortFormId } = action.payload;
      return state.setIn(['config', shortFormId], Map(action.payload))
    }
    case 'shortForm/initShortForm':
      return state.set('visible', true)
        .set('data', action.payload.data)
        .set('fromId', action.payload.fromId)
        .set('shortFormId', action.payload.shortFormId)
        .set('saveAction', action.payload.saveAction)
        .set('saveApi', action.payload.saveApi)
        .set('selectedIds', action.payload.selectedIds)
        .set('refreshAction', action.payload.refreshAction)
        .set('extraParams', action.payload.extraParams)
        .set('fromFunctionCode', action.payload.fromFunctionCode);
    case 'shortForm/changeDataItemValue':
      return state.setIn(['data', action.payload.dataIndex], action.payload.value);
    case 'shortForm/changeItemValue':
      return state.set(action.payload.key, action.payload.value);
    case 'shortForm/closeShortForm':
      return initState;
    case 'shortForm/changeSelectedRowKeys': {
      return state.setIn(['selectedRowKeys', action.payload.field], action.payload.selectedRowKeys)
    }
    case 'shortForm/setForm':
      return action.payload;
    default:
      return state;
  }
}
