import { Map } from 'immutable';
const initState = Map({});

export default (state = initState, action) => {
  switch (action.type) {
    case 'treeForm/fetchConfigSuccess':
      const { searchScenarioConfig, functionCode, collect, fields, basicInfo, searchScenario,
        listTopButtons, listMoreButtons, totalWidth, searchButton, listPrintTemplate, pagination } = action.payload;
      return state.setIn([functionCode, 'searchScenarioConfig'], searchScenarioConfig)
        .setIn([functionCode, 'basicInfo'], basicInfo)
        .setIn([functionCode, 'searchScenario'], searchScenario)
        .setIn([functionCode, 'defaultSearchScenario'], searchScenario);
    case 'treeForm/changeSearchScenario': {
      const { functionCode, dataIndex, value } = action.payload;
      return state.setIn([functionCode, 'searchScenario', dataIndex], value);
    }
    case 'treeForm/resetSearchScenario': {
      const { functionCode } = action.payload;
      return state.setIn([functionCode, 'searchScenario'], state.getIn([functionCode, 'defaultSearchScenario']));
    }
    case 'treeForm/fetchSelectTreeFormDetailDataSuccess': {
      const { functionCode, searchScenario, selectId } = action.payload;
      return state.setIn([functionCode, 'selectId'], selectId)
        .setIn([functionCode, 'searchScenario'], searchScenario);
    }
    case 'treeForm/setForm':
      return action.payload;
    case 'system/logoutSuccess':
      return initState;
    default:
      return state;
  }
}
