/**
 * Created by Administrator on 2019-01-16.
 */
import { Map } from 'immutable';
import { fromJS, List } from 'immutable'

const initState = Map({
  currentFunctionCode: undefined,
  currentRecordId: undefined,
  currentRecordIds: [],
  verifiedVisible: false,
  verifiedMessage: '',
  codeVerifiedMessage:Map({}),
  visibleWorkflow: false,
  refreshCurrentWorkflow: false,
  steps:undefined,
  noticeMes:undefined
});

export default (state = initState, action) => {
  switch (action.type) {
    case 'workflow/fetchWorkflowTemplateSuccess': {
      const { functionCode, workflowTemplate } = action.payload;
      if (!workflowTemplate) {
        return state;
      }
      return state.set(functionCode, fromJS(JSON.parse(workflowTemplate)));
    }
    case 'workflow/changeCurrentFunctionCode':
      return state.set('currentFunctionCode', action.payload.currentFunctionCode);
    case 'workflow/beginVerifiedWorkflow':
      return state.set('currentRecordIds', action.payload.recordIds)
        .set('currentFunctionCode', action.payload.functionCode)
        .set('verifiedVisible', true);
    case 'workflow/cancelVerifiedWorkflow':
      return state.set('currentRecordIds', [])
        .set('verifiedVisible', false)
        .set('verifiedMessage', '')
        .set('currentFunctionCode', undefined);
    case 'workflow/changeVerifiedMessage':
      if(action.payload.functionCode){
        return state.setIn(["codeVerifiedMessage", action.payload.functionCode,action.payload.id ,'verifiedMessage'], action.payload.verifiedMessage)
      }
      return state.set('verifiedMessage', action.payload.verifiedMessage);
    case 'workflow/showWorkflowView':
      return state.set(action.payload.functionCode + action.payload.recordId, action.payload.workflowInfo)
        .set('visibleWorkflow', action.payload.hideWindow ? false : true)
        .set('currentRecordId', action.payload.recordId)
        .set('currentFunctionCode', action.payload.functionCode);
    case 'workflow/hideWorkflowView':
      return state.set('visibleWorkflow', false)
        //2022-01-06 15:25:57 详情侧滑展示记录 暂时没有发现副作用
        // .set('currentRecordId', undefined)
        .set('currentFunctionCode', undefined)
    case 'workflow/refreshCurrentWorkflow':
      if(action.payload.functionCode){
      return state.set('refreshCurrentWorkflow', !state.get('refreshCurrentWorkflow'))
        .setIn(["codeVerifiedMessage", action.payload.functionCode,action.payload.id, 'verifiedMessage'], '')
      }
      return state.set('refreshCurrentWorkflow', !state.get('refreshCurrentWorkflow'))
        .set('verifiedMessage', '');
    case 'workflow/saveStapes':
      return state.set('steps', action.payload.steps);
    case 'workflow/saveNoticeMes':
      return state.set('noticeMes', action.payload.item);
    default:
      return state;
  }
}