import { Map } from 'immutable';
import { combineReducers } from 'redux-immutablejs'
import { routerReducer } from 'react-router-redux'
import system from './model/system/reducer';
import list from './model/list/reducer';
import form from './model/form/reducer';
import reference from './model/reference/reducer';
import dictionary from './model/dictionary/reducer';
import report from './model/report/reducer';
import customReport from './model/customReports/reducer';
import message from './model/message/reducer';
import note from './model/note/reducer';
import advanceList from './model/advanceList/reducer';
import dashboard from './model/dashboard/reducer';
import shortForm from './model/shortForm/reducer';
import treeForm from './model/treeForm/reducer';
import workflow from './model/workflow/reducer';

const rootCombinedReducer = combineReducers(
  Map({
    system,
    list,
    form,
    report,
    reference,
    dictionary,
    message,
    note,
    dashboard,
    advanceList,
    shortForm,
    treeForm,
    workflow,
    router: routerReducer,
    customReport
  })
);

export default rootCombinedReducer;
