import { request, download as downloadRequest, downloadFromServer as downloadFromServerRequest, requestPrintUi } from '../utils/request';

export async function get(url) {
  return request(url, {
    method: 'GET',
  });
}

export async function post(url, params, funCode, actionId, loading = true, withReject = false) {
  return request(url, params, loading, withReject, funCode, actionId)
}

export async function ajaxCors(url, params) {
  return new Promise((resolve, reject) => {
    var xhr = new XMLHttpRequest();
    xhr.withCredentials = false;
    xhr.open('post', url, false);
    xhr.setRequestHeader('Content-Type', 'application/json;charset=UTF-8');
    var body = typeof params === 'string' ? params : JSON.stringify(params);
    xhr.onreadystatechange = function(){
      if(xhr.readyState == 4 && xhr.status == 200){
        resolve (xhr.responseText)
      }else if(xhr.readyState == 4 && xhr.status != 200){
        reject (xhr.status)
      }
    }
    xhr.send(body);
  }).then(data=>{
    return data;
  }).catch(err=>{
    return err;
  })

}

export async function download(url, params, fileName) {
  return downloadRequest(url, params, fileName)
}

export async function downloadFromServer(url, params, fileName, funCode) {
  return downloadFromServerRequest(url, params, fileName, funCode)
}

export async function put({ url, params }) {
  return request(url, params)
}

export async function requestPrintServer(params, id) {
  return requestPrintUi(params, id);
}

export const url = {
  getSysListConfig: '/sysCache/getCacheList',
  getCustomReportsConfig: '/sysReport/getCustomReportShowCfg',
  getCustomReportsChartsConfig: '/sysReport/getSysReportCommonCfg',
  getSysFormCfg: '/generate/getSysFormCfg',
  getListPaging: '/senior/getListPaging',
  advancedListPaging: '/senior/advancedListPaging', //高级搜索2022/04/21
  getListPagingNo: '/senior/getList',
  getSysFormConfig: '/sysCache/getCacheForm',
  addFormData: '/senior/add',
  modFormData: '/senior/mod',
  removeFormData: '/senior/remove',
  fetchFormDetail: '/senior/getDetail',
  fetchAttachments: '/attach/getAttachmentList',
  fetchWorkflowStatus: '/wfInvoice/searchCurrentWorkFlowInfo',
  fetchInvoiceWorkflowConfig: '/wfInvoice/searchInvoiceInfo',
  getReferenceConfig: '/sysCache/getCacheReference',
  fetchReferenceTreeData: '/senior/getReferenceTreeAndDropDown',
  fetchReferenceTableData: '/senior/getReferenceTable',
  fetchDictionaryByKey: '/sysCache/getCacheDictionary',
  fetchChildrenByParentId: '/senior/getChildrenList',
  fetchReportConfig: '/sysReport/getSysReportCfg',
  exportToFile: '/sysExport/exportExcel',
  exportToFileAll: '/sysExport/exportExcelAll',
  getSysMessageList: '/sysMessage/getMessageByCurrentUser',
  turnCorpLogin: '/index/turnCorpLogin',
  fetchShortFormConfig: '/sysCache/getCacheSimpleWindow',
  fetchSysSetting: '/sysPlatformCfg/getSysPlatformCfg',
  saveDashboardConfig: '/sysPersonalWorkbench/saveSysPersonalWorkbench',
  modDashboardConfig: '/sysPersonalWorkbench/modSysPersonalWorkbench',
  getSysPendingItemsListPaging: '/sysPendingItems/getSysPendingItemsListPaging',
  getSysPendingItemGradeCount: '/sysPendingItems/getSysPendingItemGradeCount',
  getSysNoticeList: '/sysNotice/getSysNoticeByCurrentUser',
  getSysPendingMailCount: '/emailWeb/getMailMessages',
}
