/********************************下面写工具***************************************************/
// 月间隔
export function getMonthDiff(startDate, endDate) {
    var startMonth = startDate.getMonth();
    var endMonth = endDate.getMonth();
    var intervalMonth = (endDate.getFullYear() * 12 + endMonth) - (startDate.getFullYear() * 12 + startMonth);
    return intervalMonth;
}

//两个时间比较大小，返回小的
export function compareDate(checkStartDate, checkEndDate) {
    var arys1 = new Array();
    var arys2 = new Array();
    if (checkStartDate != null && checkEndDate != null) {
        arys1 = checkStartDate.split('-');
        var sdate = new Date(arys1[0], parseInt(arys1[1] - 1), arys1[2]);
        arys2 = checkEndDate.split('-');
        var edate = new Date(arys2[0], parseInt(arys2[1] - 1), arys2[2]);
        if (sdate > edate) {
            return edate;
        } else {
            return sdate;
        }
    }
}
/*************************************************下面是工具代码，业务代码请写在上面*******************************************************/
// 保留的小数位数
var fiexd = 8;
// 合同金额保留位数
var contractMoneyFiexd = 2;
//说明：javascript的加法结果会有误差，在两个浮点数相加的时候会比较明显。这个函数返回较为精确的加法结果。
//调用：accAdd(arg1,arg2)
//返回值：arg1加上arg2的精确结果
export function accAdd(arg1, arg2) {
    arg1 = isNullTo0(arg1);
    arg2 = isNullTo0(arg2);
    var r1, r2, m;
    try {
        r1 = arg1.toString().split(".")[1].length;
    } catch (e) {
        r1 = 0;
    }
    try {
        r2 = arg2.toString().split(".")[1].length;
    } catch (e) {
        r2 = 0;
    }
    m = Math.pow(10, Math.max(r1, r2));
    return (arg1 * m + arg2 * m) / m;
}
//说明：javascript的减法结果会有误差，在两个浮点数相加的时候会比较明显。这个函数返回较为精确的减法结果。
//调用：accSub(arg1,arg2)
//返回值：arg1减上arg2的精确结果
export function accSub(arg1, arg2) {
    arg1 = isNullTo0(arg1);
    arg2 = isNullTo0(arg2);
    return accAdd(arg1, -arg2);
}
//说明：javascript的乘法结果会有误差，在两个浮点数相乘的时候会比较明显。这个函数返回较为精确的乘法结果。
//调用：accMul(arg1,arg2)
//返回值：arg1乘以arg2的精确结果
export function accMul(arg1, arg2) {
    arg1 = isNullTo0(arg1);
    arg2 = isNullTo0(arg2);
    var m = 0, s1 = arg1.toString(), s2 = arg2.toString();
    try {
        m += s1.split(".")[1].length;
    } catch (e) {
    }
    try {
        m += s2.split(".")[1].length;
    } catch (e) {
    }
    return Number(s1.replace(".", "")) * Number(s2.replace(".", "")) / Math.pow(10, m);
}

//说明：javascript的除法结果会有误差，在两个浮点数相除的时候会比较明显。这个函数返回较为精确的除法结果。
//调用：accDiv(arg1,arg2)
//返回值：arg1除以arg2的精确结果
export function accDiv(arg1, arg2) {
    arg1 = isNullTo0(arg1);
    arg2 = isNullTo0(arg2);
    var t1 = 0, t2 = 0, r1, r2;
    try {
        t1 = arg1.toString().split(".")[1].length;
    } catch (e) {
    }
    try {
        t2 = arg2.toString().split(".")[1].length;
    } catch (e) {
    }
    // with (Math) {
    r1 = Number(arg1.toString().replace(".", ""));
    r2 = Number(arg2.toString().replace(".", ""));
    return (r1 / r2) * Math.pow(10, t2 - t1);
    // }
}

/**
 * 判断空等于0
 * @param variable1
 * @returns {*}
 */
export function isNullTo0(variable1) {
    if (variable1 == null || variable1 == undefined || variable1 == '') {
        return 0;
    } else {
        return variable1;
    }
}

/**
 * 除法保留小数，四舍五入
 * @param arg
 * @param num 保留位数
 * @returns {*}
 */
export function toDecimal(arg1, arg2, num) {
    var result = accDiv(arg1, arg2);
    result = isNullTo0(result);
    num = isNullTo0(num);
    if (result == 0) {
        return result;
    }
    return result.toFixed(num);
}

/**
 *
 *
 * @export
 * @param {*} date
 * @return {*} 
 */
export function formatTime(date) {
    var year = date.getFullYear();
    var month = date.getMonth() + 1, month = month < 10 ? '0' + month : month;
    var day = date.getDate(), day = day < 10 ? '0' + day : day;
    return year + '-' + month + '-' + day;
}

/**
 * 日期格式化带时分秒
 * @param fmt
 * @param date
 * @returns {*}
 */
export function dateFormat(fmt, date) {
    var ret;
    const opt = {
        "Y+": date.getFullYear().toString(),        // 年
        "m+": (date.getMonth() + 1).toString(),     // 月
        "d+": date.getDate().toString(),            // 日
        "H+": date.getHours().toString(),           // 时
        "M+": date.getMinutes().toString(),         // 分
        "S+": date.getSeconds().toString()          // 秒
        // 有其他格式化字符需求可以继续添加，必须转化成字符串
    };
    for (var k in opt) {
        ret = new RegExp("(" + k + ")").exec(fmt);
        if (ret) {
            fmt = fmt.replace(ret[1], (ret[1].length == 1) ? (opt[k]) : (opt[k].padStart(ret[1].length, "0")))
        }
    }
    return fmt;
}
export function numberToFixed(str) {
    if (str == null || str == "" || str == "undefined" || str == 'null') {
        return 0;
    } else {
        return str.toFixed(2);
    }
}
export function isEmpty(str) {
    if (str == null || str == "" || str == "undefined" || str == 'null') {
        return true;
    } else {
        return false;
    }
}
//日期格式化
export function formatDate(date) {
    var myYear = date.getFullYear();
    var myMonth = date.getMonth() + 1;
    var myDate = date.getDate();
    if (myMonth < 10) {
        myMonth = '0' + myMonth;
    }
    if (myDate < 10) {
        myDate = '0' + myDate;
    }
    return myYear + '-' + myMonth + '-' + myDate;
}
// 日期加减
export function dateAdd(date, days) {
    if (days == undefined || days == '') {
        days = 1;
    }
    var date = new Date(date);
    date.setDate(date.getDate() + days);
    var month = date.getMonth() + 1;
    var day = date.getDate();
    return date.getFullYear() + '-' + getFormatDate(month) + '-' + getFormatDate(day);
}
export function getFormatDate(arg) {
    if (arg == undefined || arg == '') {
        return '';
    }

    var re = arg + '';
    if (re.length < 2) {
        re = '0' + re;
    }

    return re;
}
//获取指定日期周第一天
export function getWeekStartByDate(date) {
    var now = new Date(date);
    var now_year = now.getFullYear();
    var now_month = now.getMonth();
    var now_date = now.getDate();
    var now_day = now.getDay();
    var weekStart = new Date(now_year, now_month, now_date - now_day + 1);
    return formatDate(weekStart);
}
// 获取指定日期周最后一天
export function getWeekEndByDate(date) {
    var now = new Date(date);
    var now_year = now.getFullYear();
    var now_month = now.getMonth();
    var now_date = now.getDate();
    var now_day = now.getDay();
    var weekEnd = new Date(now_year, now_month, now_date + (7 - now_day));
    return formatDate(weekEnd);
}
// 获取指定日期月第一天
export function getMonthStartByDate(date) {
    var now = new Date(date);
    var now_year = now.getFullYear();
    var now_month = now.getMonth();
    var MonthStart = new Date(now_year, now_month, 1);
    return formatDate(MonthStart);
}
// 获取指定日期月最后一天
export function getMonthEndByDate(date) {
    var now = new Date(date);
    var now_year = now.getFullYear();
    var now_month = now.getMonth();
    var MonthEnd = new Date((new Date(now_year, now_month + 1, 1)).getTime() - 1000 * 60 * 60 * 24);
    return formatDate(MonthEnd);
}
// 获取指定日期季度第一天
export function getQuartorStartDateByDate(date) {
    var now = new Date(date);
    var year = now.getFullYear();
    var quarter = getQuarter(now.getMonth());
    var startMonth = 1;
    if (quarter == 1) {
        startMonth = 1;
    } else if (quarter == 2) {
        startMonth = 4;
    } else if (quarter == 3) {
        startMonth = 7;
    } else if (quarter == 4) {
        startMonth = 10;
    }
    var endMonth = startMonth + 2;
    if (quarter == 0) {
        endMonth = 12
    }
    var startDate = year + "-" + formatMonthDate(startMonth) + '-01';
    return startDate;
}
// 获取指定日期季度最后一天
export function getQuartorEndDateByDate(date) {
    var now = new Date(date);
    var year = now.getFullYear();
    var quarter = getQuarter(now.getMonth());
    var startMonth = 1;
    if (quarter == 1) {
        startMonth = 1;
    } else if (quarter == 2) {
        startMonth = 4;
    } else if (quarter == 3) {
        startMonth = 7;
    } else if (quarter == 4) {
        startMonth = 10;
    }
    var endMonth = startMonth + 2;
    if (quarter == 0) {
        endMonth = 12
    }
    var endDate = year + '-' + formatMonthDate(endMonth) + '-' + new Date(year, endMonth, 0).getDate()
    return endDate;
}
// 获取本周第一天
export function getWeekStart() {
    var now = new Date();
    var now_year = now.getFullYear();
    var now_month = now.getMonth();
    var now_date = now.getDate();
    var now_day = now.getDay();
    var weekStart = new Date(now_year, now_month, now_date - now_day + 1);
    return formatDate(weekStart);
}
// 获取本周最后一天
export function getWeekEnd() {
    var now = new Date();
    var now_year = now.getFullYear();
    var now_month = now.getMonth();
    var now_date = now.getDate();
    var now_day = now.getDay();
    var weekEnd = new Date(now_year, now_month, now_date + (7 - now_day));
    return formatDate(weekEnd);
}
// 获取本月第一天
export function getMonthStart() {
    var now = new Date();
    var now_year = now.getFullYear();
    var now_month = now.getMonth();
    var MonthStart = new Date(now_year, now_month, 1);
    return formatDate(MonthStart);
}
// 获取本月最后一天
export function getMonthEnd() {
    var now = new Date();
    var now_year = now.getFullYear();
    var now_month = now.getMonth();
    var MonthEnd = new Date((new Date(now_year, now_month + 1, 1)).getTime() - 1000 * 60 * 60 * 24);
    return formatDate(MonthEnd);
}
// 获取本季度第一天
export function getQuartorStartDate() {
    var now = new Date();
    var year = now.getFullYear();
    var quarter = getQuarter(now.getMonth());
    var startMonth = 1;
    if (quarter == 1) {
        startMonth = 1;
    } else if (quarter == 2) {
        startMonth = 4;
    } else if (quarter == 3) {
        startMonth = 7;
    } else if (quarter == 4) {
        startMonth = 10;
    }
    var endMonth = startMonth + 2;
    if (quarter == 0) {
        endMonth = 12
    }
    var startDate = year + "-" + formatMonthDate(startMonth) + '-01';
    return startDate;
}
export function formatMonthDate(value) {
    if (value < 10) {
        value = "0" + value;
    }
    return value;
}
// 获取本季度最后一天
export function getQuartorEnfDate() {
    var now = new Date();
    var year = now.getFullYear();
    var quarter = getQuarter(now.getMonth());
    var startMonth = 1;
    if (quarter == 1) {
        startMonth = 1;
    } else if (quarter == 2) {
        startMonth = 4;
    } else if (quarter == 3) {
        startMonth = 7;
    } else if (quarter == 4) {
        startMonth = 10;
    }
    var endMonth = startMonth + 2;
    if (quarter == 0) {
        endMonth = 12
    }
    var endDate = year + '-' + formatMonthDate(endMonth) + '-' + new Date(year, endMonth, 0).getDate()
    return endDate;
}
export function getQuarter(month) {
    //月份从0-11
    if (month < 3) {
        return 1;
    }

    if (month < 6) {
        return 2;
    }

    if (month < 9) {
        return 3;
    }

    return 4;
}
//当前年第一天
export function getYearFirstDay() {
    var firstDay = new Date();
    firstDay.setDate(1);
    firstDay.setMonth(0);
    firstDay = firstDay.Format("yyyy-MM-dd");
    return firstDay;
}
//当前年最后一天
export function getYearLastDay() {
    var lastDay = new Date();
    lastDay.setFullYear(lastDay.getFullYear() + 1);
    lastDay.setDate(0);
    lastDay.setMonth(-1);
    lastDay = lastDay.Format("yyyy-MM-dd");
    return lastDay;
}
const tool = {
    accAdd: accAdd,
    accSub: accSub,
    accMul: accMul,
    accDiv: accDiv,
    isNullTo0: isNullTo0,
    isEmpty: isEmpty,
    toDecimal: toDecimal,
    formatTime: formatTime,
    getMonthDiff: getMonthDiff,
    compareDate: compareDate,
    dateAdd: dateAdd,
    getWeekStartByDate: getWeekStartByDate,
    getWeekEndByDate: getWeekEndByDate,
    getMonthStartByDate: getMonthStartByDate,
    getMonthEndByDate: getMonthEndByDate,
    remark: [
        { value: 'accAdd', title: '精确加', param: 'num1, num2' },
        { value: 'accSub', title: '精确减', param: 'num1, num2' },
        { value: 'accMul', title: '精确乘', param: 'num1, num2' },
        { value: 'accDiv', title: '精确除', param: 'num1, num2' },
        { value: 'isNullTo0', title: '空转0', param: 'all' },
        { value: 'isEmpty', title: '判空返回true', param: 'all' },
        { value: 'toDecimal', title: '除法保留小数，四舍五入', param: 'num1, num2, num' },
        { value: 'formatTime', title: '日期格式化', param: 'date' },
        { value: 'getMonthDiff', title: '月间隔', param: 'startDate, endDate' },
        { value: 'compareDate', title: '两个时间对比返回小', param: 'startDate, endDate' },
        { value: 'dateAdd', title: '日期增加', param: 'date, days' },
        { value: 'getWeekStartByDate', title: '周第一天', param: 'date' },
        { value: 'getWeekEndByDate', title: '周最后一天', param: 'date' },
        { value: 'getMonthStartByDate', title: '月第一天', param: 'date' },
        { value: 'getMonthEndByDate', title: '月最后一天', param: 'date' },
    ]

}
export default tool