import { newGuid } from './index';
import _ from 'lodash';

const eventObj = {};
const eventHandler = {};

eventObj.addEventHandler = (eventName, hanlder) => {
  const hanlders = eventHandler[eventName] || [];
  if (typeof hanlder === 'function') {
    const hash = newGuid();
    hanlders.push({ hash, hanlder });
    eventHandler[eventName] = hanlders;
    return hash;
  }
  return undefined;
}

eventObj.removeEventHandler = (eventName, hash) => {
  const hanlders = eventHandler[eventName];
  if (hanlders && hanlders.length > 0) {
    const index = _.findIndex(hanlders, { hash });
    hanlders.splice(index, 1);
    eventHandler[eventName] = hanlders;
  }
}

eventObj.sendEvent = (eventName, params) => {
  const hanlders = eventHandler[eventName];
  hanlders && hanlders.forEach(eventHandler => {
    if (typeof eventHandler.hanlder === 'function') {
      eventHandler.hanlder(params);
    }
  });
}

window.eventObj = eventObj
